# https://iso639-3.sil.org/code_tables/download_tables
part1_id = Dict("mg" => "mlg", "tw" => "twi", "et" => "est", "mh" => "mah", "tl" => "tgl", "cr" => "cre", "wa" => "wln", "br" => "bre", "gl" => "glg", "an" => "arg", "kr" => "kau", "bi" => "bis", "te" => "tel", "cy" => "cym", "ka" => "kat", "ko" => "kor", "uz" => "uzb", "vo" => "vol", "kw" => "cor", "ho" => "hmo", "eo" => "epo", "ii" => "iii", "ay" => "aym", "my" => "mya", "rn" => "run", "lu" => "lub", "or" => "ori", "bo" => "bod", "bs" => "bos", "ja" => "jpn", "ta" => "tam", "be" => "bel", "lo" => "lao", "ha" => "hau", "sk" => "slk", "so" => "som", "hz" => "her", "ts" => "tso", "rm" => "roh", "uk" => "ukr", "it" => "ita", "pl" => "pol", "nv" => "nav", "de" => "deu", "gv" => "glv", "fy" => "fry", "ba" => "bak", "bm" => "bam", "yi" => "yid", "aa" => "aar", "lv" => "lav", "fr" => "fra", "co" => "cos", "ny" => "nya", "se" => "sme", "sn" => "sna", "hi" => "hin", "kk" => "kaz", "oj" => "oji", "kg" => "kon", "ur" => "urd", "ht" => "hat", "ig" => "ibo", "dz" => "dzo", "gn" => "grn", "fo" => "fao", "bg" => "bul", "zu" => "zul", "ak" => "aka", "kn" => "kan", "lb" => "ltz", "el" => "ell", "ky" => "kir", "nb" => "nob", "hr" => "hrv", "mt" => "mlt", "ti" => "tir", "id" => "ind", "ch" => "cha", "qu" => "que", "mk" => "mkd", "mr" => "mar", "km" => "khm", "ug" => "uig", "ln" => "lin", "hu" => "hun", "si" => "sin", "cv" => "chv", "oc" => "oci", "ru" => "rus", "gu" => "guj", "sq" => "sqi", "la" => "lat", "zh" => "zho", "am" => "amh", "cs" => "ces", "sg" => "sag", "ar" => "ara", "yo" => "yor", "sd" => "snd", "mn" => "mon", "as" => "asm", "lg" => "lug", "to" => "ton", "os" => "oss", "ff" => "ful", "jv" => "jav", "ty" => "tah", "sr" => "srp", "ms" => "msa", "nn" => "nno", "ce" => "che", "ks" => "kas", "mi" => "mri", "ga" => "gle", "pi" => "pli", "ps" => "pus", "xh" => "xho", "dv" => "div", "ik" => "ipk", "tg" => "tgk", "th" => "tha", "eu" => "eus", "sw" => "swa", "pt" => "por", "az" => "aze", "iu" => "iku", "es" => "spa", "nr" => "nbl", "ia" => "ina", "za" => "zha", "su" => "sun", "fa" => "fas", "af" => "afr", "no" => "nor", "lt" => "lit", "en" => "eng", "st" => "sot", "ab" => "abk", "ca" => "cat", "bn" => "ben", "li" => "lim", "ie" => "ile", "kj" => "kua", "ae" => "ave", "ss" => "ssw", "ne" => "nep", "sa" => "san", "na" => "nau", "cu" => "chu", "ve" => "ven", "hy" => "hye", "tn" => "tsn", "gd" => "gla", "nl" => "nld", "is" => "isl", "kv" => "kom", "tt" => "tat", "ki" => "kik", "sl" => "slv", "sv" => "swe", "fj" => "fij", "da" => "dan", "io" => "ido", "wo" => "wol", "av" => "ava", "nd" => "nde", "pa" => "pan", "rw" => "kin", "tr" => "tur", "vi" => "vie", "sh" => "hbs", "om" => "orm", "ee" => "ewe", "kl" => "kal", "sm" => "smo", "sc" => "srd", "ml" => "mal", "tk" => "tuk", "fi" => "fin", "ku" => "kur", "ng" => "ndo", "ro" => "ron", "he" => "heb")
iid_mid = Dict("cnp" => "zho", "zca" => "zap", "zpe" => "zap", "qvn" => "que", "zaw" => "zap", "mww" => "hmn", "xhe" => "lah", "taq" => "tmh", "qwh" => "que", "nob" => "nor", "ayl" => "ara", "bln" => "bik", "ztt" => "zap", "zeh" => "zha", "qux" => "que", "ltg" => "lav", "quk" => "que", "ztn" => "zap", "bxk" => "luy", "rmc" => "rom", "esg" => "gon", "cpx" => "zho", "msi" => "msa", "bxm" => "bua", "zai" => "zap", "zaa" => "zap", "zar" => "zap", "hmq" => "hmn", "crl" => "cre", "sdc" => "srd", "gaz" => "orm", "hmj" => "hmn", "hae" => "orm", "rml" => "rom", "pes" => "fas", "hml" => "hmn", "zpk" => "zap", "ccy" => "zha", "zlj" => "zha", "bhr" => "mlg", "zao" => "zap", "hme" => "hmn", "bvu" => "msa", "bjn" => "msa", "kvb" => "msa", "pbt" => "pus", "hak" => "zho", "ydd" => "yid", "scs" => "den", "tec" => "kln", "zpp" => "zap", "rmy" => "rom", "kxd" => "msa", "gda" => "raj", "qwa" => "que", "diq" => "zza", "qur" => "que", "zsr" => "zap", "gun" => "grn", "arb" => "ara", "mnp" => "zho", "zpq" => "zap", "mhr" => "chm", "fuc" => "ful", "acm" => "ara", "sro" => "srd", "bxr" => "bua", "liw" => "msa", "gmm" => "gba", "gnw" => "grn", "apc" => "ara", "ebk" => "bnc", "cqd" => "hmn", "ojs" => "oji", "lks" => "luy", "pbu" => "pus", "dip" => "din", "zcd" => "zap", "ayp" => "ara", "qvc" => "que", "thv" => "tmh", "khk" => "mon", "vbk" => "bnc", "rmo" => "rom", "bdt" => "gba", "zpl" => "zap", "zpn" => "zap", "knn" => "kok", "mdo" => "gba", "hmm" => "hmn", "hea" => "hmn", "lvs" => "lav", "vro" => "est", "wbr" => "raj", "ssh" => "ara", "qxa" => "que", "aju" => "jrb", "crk" => "cre", "xsl" => "den", "hmz" => "hmn", "jak" => "msa", "yud" => "jrb", "hoj" => "raj", "bcc" => "bal", "ars" => "ara", "wry" => "mwr", "lce" => "msa", "sdh" => "kur", "ciw" => "oji", "zpr" => "zap", "mvf" => "mon", "zyn" => "zha", "qxp" => "que", "gbq" => "gba", "tmw" => "msa", "bto" => "bik", "hma" => "hmn", "gax" => "orm", "mfb" => "msa", "kiu" => "zza", "afb" => "ara", "ors" => "msa", "mqg" => "msa", "zps" => "zap", "zln" => "zha", "zgm" => "zha", "nno" => "nor", "gju" => "raj", "acw" => "ara", "bgp" => "bal", "ggo" => "gon", "rbl" => "bik", "hrm" => "hmn", "quz" => "que", "arz" => "ara", "avl" => "ara", "rbk" => "bnc", "sgc" => "kln", "krt" => "kau", "tkg" => "mlg", "wsg" => "gon", "csp" => "zho", "bjq" => "mlg", "mlq" => "man", "myq" => "man", "abv" => "ara", "gug" => "grn", "msc" => "man", "swc" => "swa", "zpz" => "zap", "apd" => "ara", "niq" => "kln", "fat" => "aka", "bgn" => "bal", "ztl" => "zap", "orc" => "orm", "bzc" => "mlg", "hrv" => "hbs", "lkb" => "luy", "dhd" => "mwr", "prs" => "fas", "gkp" => "kpe", "zpx" => "zap", "ojc" => "oji", "auz" => "ara", "lsm" => "luy", "qvj" => "que", "spy" => "kln", "hmd" => "hmn", "qul" => "que", "zas" => "zap", "mrj" => "chm", "xmm" => "msa", "dik" => "din", "fue" => "ful", "adf" => "ara", "qub" => "que", "dup" => "msa", "gan" => "zho", "zav" => "zap", "nhd" => "grn", "dty" => "nep", "qvp" => "que", "lrm" => "luy", "qwc" => "que", "knc" => "kau", "phr" => "lah", "ayr" => "aym", "crj" => "cre", "rag" => "luy", "ajt" => "jrb", "coa" => "msa", "min" => "msa", "ccx" => "zha", "zlq" => "zha", "fub" => "ful", "uzn" => "uzb", "aao" => "ara", "mfa" => "msa", "qup" => "que", "zat" => "zap", "xmv" => "mlg", "dib" => "din", "plt" => "mlg", "fuf" => "ful", "cqu" => "que", "rmn" => "rom", "swh" => "swa", "cld" => "syr", "ekk" => "est", "ztg" => "zap", "ldi" => "kon", "cjy" => "zho", "qxr" => "que", "zpd" => "zap", "mtr" => "mwr", "zlm" => "msa", "nle" => "luy", "qxc" => "que", "zab" => "zap", "mku" => "man", "otw" => "oji", "ike" => "iku", "kvr" => "msa", "mup" => "raj", "zqe" => "zha", "pst" => "pus", "mnk" => "man", "zgn" => "zha", "ayh" => "ara", "cts" => "bik", "grj" => "grb", "qxo" => "que", "ojw" => "oji", "umu" => "del", "fuq" => "ful", "oki" => "kln", "blu" => "hmn", "lri" => "luy", "tdx" => "mlg", "zpv" => "zap", "wuu" => "zho", "qvi" => "que", "zte" => "zap", "gso" => "gba", "hmi" => "hmn", "zam" => "zap", "zsm" => "msa", "ary" => "ara", "diw" => "din", "hno" => "lah", "nyd" => "luy", "fbl" => "bik", "qxt" => "que", "zae" => "zap", "czo" => "zho", "bmm" => "mlg", "fui" => "ful", "ztc" => "zap", "max" => "msa", "zyj" => "zha", "aeb" => "ara", "zpa" => "zap", "bbz" => "ara", "zpj" => "zap", "zpo" => "zap", "hmh" => "hmn", "bve" => "msa", "zpy" => "zap", "zpc" => "zap", "quw" => "que", "zgb" => "zha", "gry" => "grb", "lbl" => "bik", "kby" => "kau", "mui" => "msa", "acx" => "ara", "zpb" => "zap", "ajp" => "ara", "lts" => "luy", "bxu" => "bua", "xpe" => "kpe", "zpt" => "zap", "grv" => "grb", "zhn" => "zha", "aae" => "sqi", "gbp" => "gba", "qve" => "que", "hmy" => "hmn", "gya" => "gba", "gui" => "grn", "vkk" => "msa", "unm" => "del", "qvo" => "que", "zpf" => "zap", "kpv" => "kom", "arq" => "ara", "gom" => "kok", "twi" => "aka", "hmc" => "hmn", "jye" => "jrb", "lbk" => "bnc", "hnj" => "hmn", "yhd" => "jrb", "lwg" => "luy", "yue" => "zho", "ztu" => "zap", "npi" => "nep", "hnd" => "lah", "pmu" => "lah", "zpu" => "zap", "meo" => "msa", "skr" => "lah", "hmg" => "hmn", "qxh" => "que", "skg" => "mlg", "aat" => "sqi", "zaf" => "zap", "cmn" => "zho", "ayn" => "ara", "qus" => "que", "orn" => "msa", "azb" => "aze", "qvm" => "que", "zax" => "zap", "ind" => "msa", "zpw" => "zap", "mmr" => "hmn", "aln" => "sqi", "pko" => "kln", "rmf" => "rom", "zaq" => "zap", "zpg" => "zap", "aec" => "ara", "sdn" => "srd", "acy" => "ara", "ztm" => "zap", "zyb" => "zha", "lzh" => "zho", "quh" => "que", "thz" => "tmh", "xnr" => "doi", "cwd" => "cre", "ztp" => "zap", "zyg" => "zha", "aii" => "syr", "gno" => "gon", "azj" => "aze", "srp" => "hbs", "nan" => "zho", "sfm" => "hmn", "muq" => "hmn", "kmr" => "kur", "jat" => "lah", "ztx" => "zap", "enb" => "kln", "jax" => "msa", "mve" => "mwr", "lko" => "luy", "shu" => "ara", "zpi" => "zap", "qxl" => "que", "als" => "sqi", "uzs" => "uzb", "gbo" => "grb", "msh" => "mlg", "ffm" => "ful", "huj" => "hmn", "ikt" => "iku", "zzj" => "zha", "qxw" => "que", "pnb" => "lah", "cdo" => "zho", "zmi" => "msa", "obk" => "bnc", "hji" => "msa", "qvl" => "que", "qxn" => "que", "swv" => "mwr", "bos" => "hbs", "zty" => "zap", "zts" => "zap", "qvs" => "que", "qvw" => "que", "czh" => "zho", "lcf" => "msa", "zoo" => "zap", "kwy" => "kon", "koi" => "kom", "cnr" => "hbs", "esi" => "ipk", "ojg" => "oji", "zch" => "zha", "vkt" => "msa", "abh" => "ara", "xmw" => "mlg", "emk" => "man", "zhd" => "zha", "qug" => "que", "bhk" => "bik", "ckb" => "kur", "fuh" => "ful", "zad" => "zap", "ubl" => "bik", "ida" => "luy", "mly" => "msa", "src" => "srd", "quf" => "que", "txy" => "mlg", "pga" => "ara", "hdn" => "hai", "csw" => "cre", "ayc" => "aym", "pse" => "msa", "lto" => "luy", "qva" => "que", "crm" => "cre", "spv" => "ori", "qud" => "que", "zac" => "zap", "ztq" => "zap", "rmw" => "rom", "kng" => "kon", "dks" => "din", "fuv" => "ful", "btj" => "msa", "qxu" => "que", "ory" => "ori", "acq" => "ara", "bgq" => "raj", "qws" => "que", "gec" => "grb", "esk" => "ipk", "hax" => "hai", "mwk" => "man", "eyo" => "kln", "tuy" => "kln", "urk" => "msa", "hms" => "hmn", "qvh" => "que", "hmw" => "hmn", "ojb" => "oji", "hsn" => "zho", "bcl" => "bik", "rwr" => "mwr", "zpm" => "zap", "zph" => "zap", "quy" => "que", "hmp" => "hmn", "dgo" => "doi", "ttq" => "tmh", "yih" => "yid", "pel" => "msa", "qvz" => "que")
id_all = Set(["lyn", "psy", "sgp", "ont", "loy", "iin", "glw", "fau", "sdk", "eze", "sgh", "vmw", "ztt", "ksj", "kux", "moq", "bkc", "bxk", "kwf", "isd", "kti", "wbp", "gek", "wyb", "lvk", "khl", "mpb", "wwb", "zpk", "gyf", "xpj", "anz", "bgs", "khs", "osu", "nru", "auo", "cia", "wrv", "gmn", "jda", "hak", "sbc", "keg", "pez", "soz", "mtp", "aeq", "bbw", "fun", "nju", "skv", "ggd", "ssr", "ukk", "til", "gwm", "mae", "yim", "mdp", "yor", "jje", "skp", "mrc", "ssu", "kue", "yuk", "khv", "ofo", "aih", "bqy", "dny", "liu", "pno", "pmo", "tza", "ksw", "lks", "pow", "aof", "piy", "vau", "byn", "tdb", "ygs", "zaj", "ile", "gay", "hrk", "kcx", "pot", "kdz", "rej", "omy", "tes", "hea", "sui", "amk", "bsp", "fir", "bbn", "bxw", "swl", "xtg", "crk", "jum", "rim", "lse", "mot", "sde", "olr", "mqf", "wbf", "kye", "nut", "pum", "jru", "mti", "bju", "ycr", "nbt", "kyo", "anb", "zik", "ndi", "tvk", "amr", "mov", "ggb", "afb", "muz", "lka", "nup", "noa", "wle", "bqj", "zmh", "kiw", "aym", "sep", "hil", "arv", "kpe", "stn", "kdj", "reg", "yaz", "ksy", "saj", "mtg", "ghr", "wsg", "mlq", "kfa", "pna", "dub", "lbu", "msc", "kay", "elh", "njz", "lsn", "rob", "tuv", "skc", "xud", "ymn", "dtr", "apb", "idi", "jgo", "sov", "uig", "xeb", "haj", "kxk", "mxk", "ckr", "xpk", "lie", "mlj", "tnx", "beg", "wah", "qvj", "ytw", "mtt", "brt", "aum", "goj", "gon", "koc", "mbv", "bse", "agr", "azo", "mzo", "nbh", "tsv", "snd", "aru", "apj", "kyz", "ylb", "gpe", "tep", "gwf", "wrs", "usk", "vmr", "sve", "bnq", "csi", "ump", "tnz", "ggk", "kxj", "fil", "kba", "tsl", "tun", "nrn", "nlo", "apl", "siy", "wgg", "huv", "suo", "swj", "slu", "hss", "tra", "dtm", "nsg", "osa", "nks", "peh", "eki", "glg", "lok", "jpa", "rjs", "xwe", "iqu", "kxv", "mzr", "gnt", "pid", "tjp", "zxx", "sbk", "kwj", "mgq", "msz", "tqp", "bmf", "vsl", "tgq", "wku", "pcp", "lez", "cks", "mxx", "ary", "mfr", "xtu", "jao", "bwr", "mlh", "peq", "sim", "lah", "mnx", "aua", "luv", "pas", "bin", "bud", "lop", "gdl", "mvt", "che", "mdu", "nrx", "kqh", "swk", "yer", "bsx", "rbp", "tzn", "hye", "aek", "vol", "xuu", "mls", "wxw", "kdl", "aan", "grw", "vis", "bmv", "xib", "ese", "hrt", "tmr", "kym", "mjn", "kqp", "vkm", "jog", "yda", "fos", "mxh", "jku", "ubi", "bwu", "crn", "mgw", "anw", "orm", "khb", "abx", "bmc", "nmg", "tan", "cte", "adw", "gmz", "btv", "gzi", "nia", "ylo", "srd", "zpu", "xzh", "rgk", "alh", "mty", "okv", "gce", "ugo", "nca", "iar", "yns", "spp", "trx", "kxo", "zaq", "xtw", "ldj", "msd", "ztm", "abz", "aqg", "nbs", "bnb", "pur", "dbw", "tuk", "xgd", "jbo", "rjg", "xnr", "dho", "ksd", "aaz", "aii", "bjf", "bnf", "puj", "grb", "xsp", "eso", "css", "bbf", "cce", "gbi", "gie", "hop", "djn", "cho", "bry", "mam", "mhj", "wdu", "wet", "wos", "awr", "mgr", "buz", "bio", "err", "hhy", "uzs", "ekp", "gej", "kml", "wua", "roo", "cwb", "rei", "mxi", "liv", "atu", "ggt", "asg", "nnt", "gbr", "zty", "mcs", "czh", "bxs", "has", "kxy", "svm", "slw", "abh", "oss", "cpi", "ywq", "snm", "dbg", "crv", "zad", "blf", "dad", "bal", "kyt", "mce", "eth", "tbf", "nyy", "pty", "xvn", "hdn", "nmr", "pga", "dij", "lto", "oac", "ury", "qud", "akg", "ebr", "whk", "dlk", "dks", "mkk", "xsu", "nkb", "viv", "guj", "xwt", "tnl", "zbw", "chc", "xco", "nna", "lns", "xpl", "sgz", "mci", "ixl", "csh", "krx", "kyx", "mlp", "nlc", "pbv", "pog", "gmv", "ykl", "ikl", "ywr", "ksu", "asz", "bqw", "sez", "ulf", "wwa", "xnh", "mze", "maq", "jal", "knr", "pop", "wed", "qvn", "tpn", "imr", "izh", "bvm", "tcy", "swi", "waw", "teb", "ium", "aoa", "trj", "qwt", "kkg", "pkn", "kgj", "tcl", "cli", "bsa", "dww", "law", "bxe", "wab", "amt", "zai", "zsa", "gng", "cas", "vaj", "sct", "oyy", "sdo", "mvz", "gum", "mph", "nsm", "smm", "wth", "txj", "ntg", "sbt", "skf", "oka", "pmn", "anp", "pnm", "muy", "gyb", "thi", "bta", "pdn", "xpx", "tiz", "rmz", "stp", "bfp", "frp", "kvw", "ypo", "mdf", "cuy", "bov", "bkf", "kcv", "gsm", "ctz", "mgo", "miz", "shj", "tct", "mfg", "xso", "wro", "xna", "pmr", "mrt", "ojs", "lbb", "nka", "ynn", "bgy", "inz", "lvi", "miu", "ltu", "plh", "agy", "klu", "kxx", "mhx", "jmn", "omk", "jdg", "got", "dar", "mgn", "cbk", "cma", "kmu", "xku", "nkd", "ptn", "mgi", "wdy", "xlp", "ecr", "xlb", "mse", "jak", "rxd", "scu", "tpq", "bhe", "rkw", "xpc", "zgh", "kug", "mmo", "esl", "biz", "jra", "wry", "dkr", "mas", "tmw", "myo", "bix", "gax", "aky", "kkf", "ikz", "brv", "awb", "med", "kvp", "pnh", "ndf", "iby", "kza", "etx", "sjs", "rbk", "smj", "tpg", "ebu", "xcl", "clh", "tnk", "mxm", "nre", "isn", "abd", "tli", "ili", "wka", "did", "ahi", "fln", "lkm", "vas", "mjk", "mio", "aui", "ssd", "tnv", "osi", "jad", "mni", "pbg", "sjk", "grt", "sae", "xgu", "keo", "hra", "kis", "lmp", "kpk", "myj", "ibu", "spy", "wrk", "ali", "byh", "tab", "wss", "gni", "tck", "aoz", "tom", "esu", "khj", "csg", "bkq", "bhj", "kmc", "omt", "pzn", "gew", "kyu", "tif", "csv", "jbe", "kul", "mfp", "mjs", "xtm", "dak", "bzq", "mwh", "gor", "jih", "ikp", "bol", "pca", "ulw", "mcz", "tmc", "xxt", "aaq", "sqt", "tba", "sna", "bcb", "jna", "pup", "sik", "klj", "kyf", "dia", "zmy", "kvh", "djr", "phm", "btd", "kny", "zgn", "xum", "ikw", "leh", "vai", "fuq", "gye", "smp", "bdp", "skd", "tke", "oki", "gde", "oma", "dus", "gwg", "pdu", "lre", "ddr", "kcc", "ray", "kbd", "khz", "iii", "sme", "qwm", "xbg", "plo", "bkl", "nke", "zhw", "olk", "ymk", "mua", "mqq", "saf", "bug", "tcn", "ada", "gnh", "igg", "lis", "csj", "dsb", "oum", "soi", "mha", "mor", "cie", "dav", "dln", "poi", "bwl", "xmu", "gid", "poo", "cuo", "alt", "gnr", "bmo", "kne", "rsw", "ace", "bwq", "xhm", "lwu", "tow", "kka", "eli", "jye", "bon", "yhd", "tbt", "dds", "trp", "kzd", "pta", "tlu", "oht", "ybe", "ohu", "ctp", "jii", "wgo", "woo", "xmc", "dba", "omc", "khu", "lue", "olt", "bbj", "bik", "crf", "bxp", "wxa", "mle", "nyv", "mkd", "bag", "etb", "kmy", "lnj", "pig", "vsv", "bqo", "hal", "wlm", "uly", "ynd", "ify", "omb", "cac", "mqb", "ygi", "vmd", "kwc", "pua", "thn", "goy", "pgk", "ahn", "ssm", "pak", "sot", "gkn", "pad", "rys", "xkx", "guo", "lby", "kij", "eka", "ise", "fkv", "ara", "pmf", "jut", "lku", "bzf", "elk", "ato", "bar", "koh", "ttf", "tsz", "phh", "hbo", "sol", "aze", "ppt", "nnm", "hol", "enm", "tsm", "loq", "mlz", "ree", "lir", "bcq", "mqw", "owl", "hig", "xzm", "ckn", "mvw", "aer", "aab", "bco", "agj", "nla", "yiu", "cta", "mid", "ifa", "tlj", "ykm", "lsp", "tlc", "grz", "pwo", "gvj", "mqm", "mrd", "phq", "ksx", "piv", "drt", "cya", "big", "bkk", "cib", "mtj", "njb", "sau", "syn", "gjn", "mnc", "gse", "kpw", "btz", "crw", "hsn", "juk", "ojb", "tkv", "vkl", "nsz", "xgb", "ptu", "tgd", "buu", "kcf", "zph", "isl", "kdf", "mtl", "awh", "cll", "rmh", "dmb", "ahs", "isi", "kch", "lkl", "tir", "wmi", "gau", "phl", "zaw", "lui", "kmo", "wea", "yui", "axm", "kwr", "hmo", "spg", "eja", "mrr", "okc", "kso", "mem", "zmm", "das", "des", "nmn", "sge", "kqq", "xdo", "luy", "jer", "bvf", "hml", "bmt", "ctt", "age", "bnp", "nab", "ihw", "gva", "cul", "ahp", "ajw", "lgr", "var", "zen", "coo", "ema", "kzm", "nay", "ryn", "ydd", "byw", "pth", "ino", "vto", "yis", "cnc", "mfv", "lac", "lls", "bez", "dnv", "ako", "tyz", "kun", "olu", "qur", "mpu", "aty", "amx", "cdj", "sqa", "sro", "fon", "huk", "nvh", "mlr", "gby", "cuq", "sek", "kpi", "myp", "nav", "whg", "emu", "frt", "kjt", "dur", "kld", "ttv", "bfg", "lat", "arw",
 "kud", "itk", "kew", "nsk", "ldn", "dru", "juo", "hag", "vra", "kdt", "agi", "tqt", "ymz", "tjg", "tny", "kwm", "msa", "kqd", "uky", "klw", "kvn", "sfw", "kfw", "xsh", "nsa", "kqn", "mul", "tqm", "weo", "zem", "bqz", "aia", "ngd", "hne", "rnl", "sdx", "kvg", "fin", "faz", "cal", "svx", "afg", "gbq", "khp", "pcf", "crt", "piu", "ert", "tbk", "tug", "xoi", "szy", "mqg", "nli", "pef", "uhn", "tpv", "put", "dec", "rdb", "nou", "krs", "bhy", "kxs", "peg", "wes", "psn", "csp", "bka", "srw", "arz", "dne", "glr", "oge", "wlr", "cps", "drb", "tva", "bgk", "dyi", "mjo", "rtm", "gss", "duo", "otr", "tsj", "apd", "gko", "afz", "mcd", "puc", "xpy", "kpd", "syb", "nnn", "mkz", "mqc", "uth", "ibn", "dga", "mqy", "mcn", "msx", "nop", "avi", "ndx", "wim", "tvu", "xww", "inn", "hmd", "kqk", "yky", "kbe", "aly", "trq", "mxy", "nye", "dup", "qxs", "mnq", "stj", "toj", "dbb", "qwc", "coe", "dmf", "kgr", "yir", "ays", "ven", "yad", "plk", "kjv", "jbm", "sds", "sea", "boj", "prk", "vmf", "cuv", "xvo", "aas", "tgf", "aom", "mvb", "nxm", "wtm", "xmv", "jnd", "mab", "ypb", "gqu", "thy", "abt", "jbk", "snr", "nwe", "bty", "bqr", "kbz", "was", "bzl", "iri", "bwd", "mku", "yba", "ttz", "sll", "pms", "knt", "lyg", "aor", "kii", "kvc", "emy", "zqe", "okx", "cfm", "air", "cbj", "glo", "kzn", "ppe", "wih", "syk", "xqa", "dju", "mnf", "rut", "wll", "omw", "nsc", "opo", "xmo", "nmf", "ish", "ets", "dwr", "bid", "lag", "ddg", "rkm", "lmx", "itw", "ktc", "ems", "amj", "hch", "liz", "djw", "aap", "gyg", "xtj", "pbh", "sfs", "bcs", "fuj", "txn", "zak", "chk", "kbs", "crd", "oml", "lsi", "dto", "hkh", "nep", "skz", "xel", "awe", "env", "mpt", "ymm", "rit", "ami", "klv", "bpl", "xts", "kby", "wwr", "daz", "boh", "grc", "nwo", "mmx", "dti", "afk", "mmd", "yna", "sjo", "hwa", "mxa", "mix", "kez", "bsy", "jee", "nyc", "sti", "jac", "dhu", "apf", "pih", "gbh", "oon", "bey", "xgg", "lwg", "psa", "ajs", "aci", "kdu", "ore", "xsi", "vun", "ghc", "ckv", "ncl", "mco", "njh", "bui", "rah", "huz", "lib", "rnb", "cut", "ckq", "ava", "ttm", "nos", "iff", "auk", "nko", "biy", "dmo", "otm", "xpp", "lgq", "bwh", "dbo", "ues", "wul", "puu", "uvl", "xtn", "wym", "cah", "kfl", "aad", "dng", "ukg", "ans", "xat", "bvl", "cvg", "huj", "pkr", "tkz", "tvo", "una", "ncd", "vnk", "awc", "bua", "kmq", "ele", "kic", "ybi", "ibd", "bru", "pma", "ids", "nxk", "imn", "nuw", "wow", "cat", "syo", "wom", "btc", "yap", "jya", "aaw", "lew", "tae", "bil", "mjm", "bna", "xow", "elx", "kpj", "njj", "xdq", "msl", "tth", "ywl", "kaq", "azm", "lgk", "neb", "bmr", "mad", "imo", "kbv", "xiy", "lhp", "mud", "knf", "cog", "muk", "nzz", "tnu", "nrk", "tvs", "uku", "clj", "lcl", "aij", "ora", "okz", "dtb", "rof", "buc", "qvh", "gwe", "urk", "txb", "cnk", "geb", "dag", "jaf", "csz", "men", "shi", "ivv", "shw", "bbo", "bst", "ngu", "paf", "dyg", "cjm", "maa", "shv", "ygp", "sjr", "gjm", "yyz", "pag", "tee", "rup", "xhe", "dux", "ekg", "twm", "akz", "ztn", "ncb", "nyo", "gbg", "oui", "pam", "xmr", "ilm", "tlr", "bxm", "kgn", "zaa", "srr", "akd", "pnq", "sth", "pbo", "isg", "wbk", "kbo", "zao", "tpj", "doy", "akm", "gdd", "hme", "chy", "kxr", "pkc", "tmy", "pbt", "toz", "dsi", "tqu", "kps", "pnr", "lau", "stf", "bld", "gii", "twf", "bvo", "kxd", "ibg", "xcn", "yej", "yac", "bso", "onk", "abp", "xbo", "xyy", "foi", "nss", "sso", "ocu", "ltc", "alu", "amw", "beb", "muh", "tik", "coh", "wic", "tcp", "ngm", "nja", "bqm", "tos", "diy", "xwl", "eee", "gaq", "arr", "hmm", "bxd", "ukv", "urf", "fap", "inb", "bbg", "bek", "bhh", "lrn", "tbp", "tkm", "coz", "hoo", "bjp", "yud", "cse", "nma", "ssk", "umm", "tde", "mfk", "grn", "hps", "pau", "spb", "tsw", "bff", "bga", "bmq", "nnw", "nhe", "xjt", "xcw", "wlv", "bth", "nmw", "ycl", "dzd", "rai", "cov", "sew", "mtb", "ttr", "nno", "kle", "ong", "kon", "swr", "wlc", "akf", "wru", "asn", "sua", "rme", "sbx", "iyx", "atz", "iws", "txm", "khm", "kfj", "kvd", "orw", "oke", "luu", "ush", "fat", "ztl", "kkn", "mos", "bgz", "nzb", "tgw", "kip", "bwk", "nio", "typ", "gef", "mgu", "soo", "ksh", "bbt", "xiv", "kdd", "rmm", "enq", "sry", "mxt", "xer", "eke", "gmu", "kao", "scq", "umc", "ark", "sny", "nsn", "ttd", "mkg", "nrg", "ntp", "mwp", "otd", "tpm", "tti", "bmj", "taj", "cos", "hke", "mqi", "bkr", "nqg", "dhw", "wpc", "szc", "gis", "soh", "bjv", "jiv", "sfb", "ige", "csa", "jul", "kmg", "ldh", "far", "prn", "smx", "ilg", "tpz", "wmt", "bsj", "oue", "kod", "wem", "wkr", "bfi", "stl", "zat", "aut", "kqv", "uba", "cfd", "crs", "izz", "pby", "chv", "aoc", "xrd", "yxg", "ikr", "acu", "scn", "kui", "agq", "dmk", "unr", "orx", "ijc", "tic", "duq", "ikh", "dyd", "kma", "csx", "seo", "lin", "xwg", "kwb", "nxa", "yaq", "gww", "wja", "kyi", "ast", "bnl", "bap", "mub", "tix", "lrt", "dah", "bcw", "zpv", "shs", "mcc", "agu", "cbi", "dgr", "lsd", "cml", "lum", "ypz", "lmh", "nsx", "yha", "mtu", "csr", "nhn", "asa", "tml", "fra", "lav", "mro", "tty", "ktf", "mbt", "tum", "ruq", "aml", "yee", "sop", "pkt", "tui", "ego", "bjo", "ccj", "tdy", "mru", "bge", "amb", "acx", "mho", "bjc", "gim", "dax", "laq", "psm", "nyg", "bqk", "jbt", "asp", "vkk", "bls", "sva", "twi", "ssv", "esy", "cfg", "aya", "myc", "scl", "vkz", "gei", "mbz", "ril", "ssn", "mez", "cwa", "dmd", "mlo", "ekl", "nyn", "srg", "xhc", "buk", "mvr", "poh", "tgo", "ane", "att", "fiw", "zpw", "aln", "ncz", "mfn", "zma", "sdn", "nmv", "qyp", "kki", "let", "swg", "quh", "gam", "kpg", "mmu", "aja", "yhl", "pbe", "rey", "azj", "okr", "ruf", "ije", "mel", "nso", "yab", "ztx", "afn", "rsb", "udj", "lki", "hmk", "bci", "ruc", "lko", "prd", "pla", "wlh", "khn", "zpi", "ntk", "juy", "byj", "gle", "anx", "ssg", "kbn", "gcd", "ley", "mqn", "bee", "puy", "ssw", "sdb", "vot", "mri", "bzg", "anq", "hji", "gll", "xbb", "ndv", "gds", "lcf", "mcw", "stv", "kzz", "nuv", "pcw", "uri", "bss", "cur", "mkn", "ybk", "jls", "ziw", "ati", "mrf", "ist", "trn", "vjk", "bba", "tak", "gcl", "huy", "cdn", "oks", "kuq", "gnj", "lcm", "ayc", "pne", "pnx", "kfe", "wew", "kig", "cop", "xon", "csk", "slz", "pib", "hah", "teq", "tvw", "rat", "hif", "kur", "tmb", "drs", "hug", "zml", "urg", "wmx", "gea", "loz", "lpa", "xnb", "hbn", "byz", "slc", "kjl", "adl", "bqh", "bwt", "eip", "dda", "omu", "ned", "wmd", "cwt", "egl", "gut", "szv", "ksv", "mlc", "mma", "keb", "asx", "bln", "brk", "kbg", "mff", "pnw", "zbe", "lbe", "sbi", "ply", "mdj", "dge", "tpk", "ufi", "cth", "kxc", "qui", "szs", "hae", "kpo", "ure", "tpi", "ffi", "and", "kmt", "pio", "dnu", "ahk", "khg", "kvb", "ypg", "kkr", "dnt", "rbb", "kwv", "bfm", "nci", "ncr", "alp", "qwa", "tin", "dby", "tjj", "kvj", "crb", "drl", "lwo", "tau", "wne", "mus", "fuc", "gct", "brx", "mwz", "xce", "aai", "lfn", "msf", "xps", "kfg", "tqn", "tzm", "tdo", "ylu", "tsa", "pkh", "gnl", "pwn", "pah", "yel", "mnw", "mou", "tpr", "axe", "bno", "knn", "bgv", "vro", "wrl", "bjl", "dok", "udl", "yla", "ndc", "ich", "lbw", "xta", "nrp", "skx", "ums", "weh", "mii", "kos", "ndl", "tka", "dov", "slf", "tua", "kqj", "neh", "pyu", "ewo", "nwy", "mow", "jah", "gne", "xwj", "hup", "raz", "toh", "kuz", "dae", "lsy", "ngq", "mlf", "swa", "ngg", "kac", "yuj", "quz", "bni", "dhi", "kia", "nhu", "sda", "xai", "mzd", "mnb", "giw", "mzc", "nco", "odt", "bpp", "zpz", "yuz", "alr", "kga", "niq", "sng", "hrv", "ndj", "tnp", "hub", "hyw", "ahb", "tio", "brp", "prs", "abf", "hus", "not",
 "swn", "wni", "ymq", "slm", "mbn", "mvd", "auz", "bnz", "llp", "bwb", "shl", "nyi", "sou", "bfa", "ben", "lub", "xmx", "zas", "nnb", "zah", "vaf", "adf", "nml", "are", "idu", "sby", "keh", "msw", "ngi", "rma", "lrm", "uuu", "lgt", "xes", "agx", "lli", "kqz", "sci", "byb", "ghe", "tuq", "ksc", "kcp", "bhx", "tkn", "lei", "trb", "bab", "hap", "csm", "gvm", "tkt", "kwk", "xeu", "mtr", "aee", "bys", "dzn", "llx", "bqd", "kua", "res", "zab", "van", "bir", "kem", "cbu", "igo", "shg", "brd", "jsl", "kmz", "kcr", "nwr", "rsn", "cow", "nem", "zos", "bpn", "thu", "tbv", "jae", "nih", "ywn", "hlt", "chz", "kfm", "jcs", "mdc", "wuu", "cdz", "kjb", "tce", "hno", "jmi", "nyd", "twb", "sgw", "jns", "fui", "pnc", "okj", "jmr", "apv", "rug", "gos", "wok", "bsk", "npy", "amq", "kll", "guq", "sbm", "vag", "pwm", "dim", "tuo", "see", "gbm", "lkj", "bwm", "kbu", "nlm", "acz", "kev", "pnu", "lbl", "yxy", "hmu", "tgk", "wnb", "jei", "mnl", "ait", "idt", "mui", "bxb", "nce", "ota", "ten", "lkr", "zpt", "gku", "bog", "tox", "isu", "kfx", "miq", "arl", "xsb", "mxs", "yii", "boy", "nkv", "sqk", "lbk", "hnj", "gev", "nhc", "sxs", "rpt", "xkl", "pap", "aou", "tgh", "asv", "mbu", "nps", "bti", "bfy", "dsz", "xcy", "cmn", "etc", "bct", "srl", "ekm", "leq", "dji", "nim", "syl", "ymc", "zmq", "cje", "elm", "sbe", "kif", "bxq", "agh", "sxl", "bsg", "txr", "wrr", "dym", "gil", "ybj", "lec", "bif", "djo", "tgs", "xpz", "kju", "mfl", "har", "bed", "bav", "mje", "pil", "mtd", "luf", "sif", "zro", "jrr", "pmz", "bzh", "wlg", "pab", "liy", "gnq", "otl", "tnw", "plr", "meu", "aol", "frc", "yiq", "cwe", "xmq", "yat", "bnj", "wkw", "wmm", "wmn", "crh", "wme", "jmx", "zzj", "pal", "dsk", "kzy", "hoh", "amm", "oti", "mlb", "sgs", "stw", "bej", "wij", "kxw", "lcs", "tdt", "xsm", "buj", "ktq", "twn", "obl", "avn", "umb", "fuh", "xau", "yuy", "cou", "pon", "sgm", "gob", "gic", "yog", "zba", "bya", "ysg", "mpg", "mqv", "sco", "ann", "cty", "mpv", "nhp", "mqz", "zmp", "cav", "yle", "wrm", "xun", "xmn", "can", "mqh", "ked", "wti", "dhl", "ssf", "cnq", "xrm", "cip", "aqd", "njo", "bly", "ctd", "tea", "mfd", "xwk", "lmv", "auy", "xin", "pnz", "rwr", "agv", "ola", "xpf", "zom", "skm", "bpq", "yil", "opm", "slr", "srt", "trf", "avu", "jic", "bgc", "kmn", "kry", "hlu", "mzk", "mis", "dtu", "lpe", "amn", "epo", "boq", "gud", "bwe", "kcd", "awo", "sas", "blp", "hlb", "nkz", "xkc", "ahl", "kfi", "ttg", "duu", "xmf", "lnm", "ywa", "kqs", "txa", "zns", "iki", "kgs", "mia", "bnm", "gnk", "msi", "xbd", "mik", "tar", "cjn", "lgb", "rml", "bnd", "bot", "swq", "cyb", "ded", "nov", "don", "ypn", "lsr", "hbs", "inp", "tyn", "pce", "ddw", "chr", "url", "api", "amv", "cng", "kla", "dau", "agn", "gdg", "lmk", "mjd", "nof", "nhz", "lle", "pui", "emg", "xti", "bqb", "nte", "zkn", "dio", "beu", "moe", "aig", "aba", "kjp", "ktd", "esq", "lnz", "loi", "sor", "nus", "tmu", "jui", "jaz", "tyy", "lud", "zmo", "apt", "asm", "sjw", "ilu", "gwj", "vmm", "tuu", "bdt", "haf", "eza", "fam", "wlw", "aoi", "apm", "uka", "yul", "ssh", "plu", "ylr", "stk", "weg", "arj", "pka", "cns", "svb", "shh", "inm", "khq", "org", "lll", "mgd", "rnd", "mfe", "ciw", "bhm", "mge", "wla", "otz", "ntd", "bli", "ykn", "nsi", "abg", "xls", "ckm", "est", "cuc", "gvl", "loa", "bkm", "ssi", "xpm", "mwb", "xwc", "bgp", "hhr", "ack", "smu", "avl", "cly", "afr", "yax", "mgf", "ihi", "dbu", "mhb", "cky", "ybl", "pok", "scf", "spa", "yko", "hul", "asq", "mxn", "nsl", "con", "tmq", "yox", "bre", "goi", "mys", "lqr", "nnj", "cdm", "rif", "vut", "imi", "gkp", "emq", "xkj", "for", "ari", "myz", "zrp", "dig", "cjp", "bjx", "szb", "knl", "bsn", "saz", "mbk", "gue", "kks", "hvk", "ilv", "kgx", "mhl", "sow", "nhr", "wum", "xag", "cbg", "stg", "yai", "lgi", "pfa", "ckx", "spk", "hro", "dyn", "syi", "aos", "kyl", "kwl", "bwa", "oyd", "sgt", "phr", "noy", "hna", "lla", "tlg", "ynq", "gbe", "jib", "mfa", "mzs", "oav", "buf", "nux", "mdk", "nbk", "rge", "nnz", "gac", "pnp", "zla", "yol", "akw", "aji", "jay", "sse", "qxr", "ena", "cle", "git", "ign", "jkr", "pha", "sbb", "ppo", "nle", "ofu", "juu", "vmy", "btf", "xrg", "kgq", "plg", "gve", "wmc", "xmp", "fia", "mkx", "roe", "clu", "mew", "kli", "klc", "mok", "bpt", "tvi", "nol", "alw", "bbd", "hiw", "mfq", "lcq", "czn", "erk", "gnb", "plc", "tux", "val", "ttb", "lay", "mla", "sty", "mkm", "fng", "sfe", "urv", "djd", "bqq", "gso", "knk", "mhs", "giq", "ngs", "mwg", "tbs", "zrn", "kjo", "azd", "chn", "jbw", "lan", "lwe", "wrn", "bfu", "itr", "bpz", "kvi", "sce", "sdr", "mlm", "xms", "zpo", "isr", "tbw", "hmh", "kuj", "slv", "kpc", "ywg", "din", "mim", "aiy", "pyx", "kmx", "neu", "nlk", "llh", "nmk", "arn", "jwi", "cnl", "gia", "neo", "bpg", "cpg", "lts", "kve", "hni", "tve", "vam", "tci", "ybo", "skq", "cbv", "kkj", "udu", "sbs", "xda", "btt", "apy", "doi", "hir", "lkd", "lpo", "awu", "teh", "ass", "wng", "bfn", "bvx", "lnl", "cao", "mbp", "nak", "abj", "oub", "pni", "kvx", "lmb", "afo", "sya", "suv", "qvm", "jbi", "psd", "bfk", "mmr", "msr", "bpo", "dgz", "krb", "xmk", "kyk", "mtk", "ran", "tha", "irn", "byt", "nny", "bze", "kjj", "nwc", "gqi", "gno", "hhi", "nbw", "tnm", "bxn", "mbm", "mto", "ogb", "sks", "dos", "bbk", "prc", "eno", "mve", "kts", "nis", "bmd", "dre", "esm", "nxg", "sns", "dun", "csl", "meh", "nrb", "nuf", "otk", "bte", "szw", "ase", "pqm", "kja", "opy", "xaw", "ate", "blc", "kwt", "mxl", "xns", "tda", "jet", "nmb", "yar", "byd", "pij", "del", "ibl", "idr", "zoo", "iwo", "kwy", "atw", "koi", "rnp", "sri", "yga", "wnd", "wif", "kwd", "qug", "bhg", "cbb", "kqw", "puf", "dcc", "chw", "she", "atx", "ehu", "tlo", "ste", "koq", "crr", "mbw", "nmm", "yre", "ard", "yun", "ljx", "tks", "nax", "nud", "bdq", "btu", "gez", "cno", "ndk", "awg", "yvt", "qvy", "ads", "blr", "xsv", "mva", "hsb", "omr", "bue", "mgk", "lti", "efa", "nei", "uro", "btr", "juc", "sax", "xhv", "yag", "ons", "moi", "nkq", "bcy", "mki", "msu", "mwk", "gjk", "jml", "khc", "mat", "wsu", "iwm", "nyt", "xpn", "kgo", "mdq", "bwz", "tkl", "siz", "mbh", "sin", "pns", "xpr", "mmz", "axb", "bpu", "cry", "ymi", "xsn", "tyr", "chf", "bbc", "apq", "abb", "dez", "pwi", "prq", "zkd", "myw", "bpe", "mmw", "uki", "bbb", "ccm", "han", "mgb", "tyl", "mpa", "usu", "muc", "kyg", "npx", "puo", "cub", "uon", "enc", "mwc", "rad", "gaz", "ule", "urh", "wrw", "gwu", "kty", "ppq", "cme", "sbh", "woi", "cds", "bus", "duh", "adb", "toc", "bhr", "wud", "xyt", "lsl", "haq", "bvu", "nxq", "bqp", "lji", "byr", "mgz", "tcq", "seq", "dml", "iml", "nhg", "sdq", "wmo", "yok", "lot", "xrn", "bgl", "lal", "kru", "nbi", "bgd", "eme", "sam", "mrx", "urc", "vsi", "yoy", "gup", "gdk", "pkp", "xor", "tyv", "dgs", "ria", "tdg", "gdn", "hoz", "kdn", "dnw", "mif", "nmh", "yon", "cmi", "dzg", "mck", "geg", "zne", "yng", "sgy", "buo", "emz", "mqa", "tfn", "xem", "bcz", "uvh", "byq", "lzn", "kee", "pol", "srz", "wbr", "bgb", "xno", "aju", "ams", "top", "ntz", "sac", "tpo", "blv", "hns", "mds", "xln", "kto", "afd", "nyj", "mvf", "mvg", "jko", "ktz", "sbg", "ksk", "dgg", "lmj", "slj", "tyj", "tsn", "apn", "bvk", "myk", "xmb", "ylm", "enw", "tao", "gol", "tla", "xni", "gip", "vmc", "gyl", "tkg", "hid", "jni", "loh", "mxg", "akb", "dgw", "mcj", "obi", "tnc", "dws", "chb", "aim", "ugh", "orc", "jit", "neg", "mbf", "tby", "xaq", "lea", "lkb", "tei", "kko", "nnk", "nba", "gey", "obu", "xgm", "kaj",
 "mdh", "vit", "ado", "xnj", "mtx", "ojc", "khf", "prt", "xpw", "dep", "jua", "abs", "mbj", "irr", "amo", "cxh", "kol", "naf", "qul", "unk", "itm", "skw", "daj", "mnd", "yyr", "ssy", "vmk", "xak", "xjb", "lva", "ncx", "pic", "mjq", "cfa", "kxn", "wec", "rms", "shz", "ntx", "lww", "xyb", "psq", "akt", "bmg", "ayr", "huq", "avb", "lbm", "min", "ocm", "ngp", "bvi", "zlq", "tpf", "xcb", "avd", "wdk", "ldg", "dbd", "gha", "dde", "all", "kfk", "gah", "bft", "wae", "xii", "cld", "gap", "ajg", "bfe", "gtu", "mgt", "twe", "shp", "knd", "vgr", "uji", "xwa", "msj", "cax", "otw", "pgd", "urp", "dgi", "mft", "trc", "wiy", "dgc", "owi", "xhd", "mkb", "pst", "gwa", "pgs", "efe", "mql", "pcm", "xrw", "ayh", "ulm", "cdh", "xut", "lya", "aha", "kxh", "kpy", "smt", "tew", "aph", "yml", "kzo", "wbh", "tnt", "ura", "zsl", "bcj", "atr", "ngr", "kik", "udg", "smh", "enr", "wax", "nbd", "biu", "emx", "lje", "jaa", "mmi", "tmv", "xuj", "xto", "lih", "fwe", "rsl", "sxu", "bqt", "nkf", "pai", "sox", "cea", "wdg", "bpc", "csd", "doh", "pbs", "kqa", "nlv", "pie", "djb", "xqt", "gbu", "kfp", "ngl", "psw", "hmy", "waa", "bca", "kok", "onb", "qvo", "ful", "nbn", "bwo", "mrs", "met", "rts", "xlo", "yue", "biw", "chd", "pfl", "rib", "okd", "iou", "aat", "ldm", "bzn", "auj", "kqc", "com", "dsh", "rmf", "fai", "tvm", "ula", "aec", "ymx", "guu", "zyb", "jam", "mtw", "asu", "xla", "kyp", "bml", "krp", "ztp", "yaw", "dry", "kmr", "lbf", "kmp", "bts", "brc", "cod", "tit", "xxm", "mox", "giz", "als", "twy", "hac", "wsk", "yid", "cet", "stq", "adx", "kyr", "cbr", "blw", "msh", "lnh", "sak", "sgr", "ttt", "tgt", "lrc", "kcw", "xan", "obk", "doo", "tqw", "pit", "spi", "akh", "kbr", "miy", "nbr", "pls", "gih", "mka", "iqw", "qvw", "apu", "phg", "sos", "hue", "hur", "tjn", "etn", "xep", "bvy", "nct", "mzj", "zrs", "hka", "klk", "xal", "hoy", "srn", "psl", "azn", "roh", "dob", "bzy", "quq", "abe", "kji", "raq", "ovd", "tri", "kuk", "khy", "tpa", "ret", "oko", "bfc", "add", "kmm", "mcx", "slt", "kfy", "tkw", "orh", "bzp", "nmz", "lov", "nsb", "ull", "dje", "jdt", "kel", "tkp", "cpy", "xnz", "lme", "mya", "yrw", "imy", "laa", "txi", "ykg", "stm", "slk", "atb", "kyy", "vbb", "bcl", "mmg", "xmg", "msp", "ajz", "nfr", "yob", "gpn", "zpm", "bcp", "sec", "bnv", "brs", "tts", "ayq", "kej", "bxi", "luj", "snp", "ttq", "aun", "kcl", "zbc", "pax", "bmp", "ler", "rgr", "yuq", "lnu", "enf", "awt", "tdi", "myh", "pcj", "bvn", "quk", "liq", "vms", "tcz", "bzm", "mal", "cpx", "gmd", "vls", "aod", "kqb", "gel", "ttn", "gdf", "nng", "khh", "klx", "enn", "dgb", "ble", "mod", "mdr", "xtr", "nlx", "bjn", "oru", "gdo", "scs", "lad", "cmt", "tgj", "nkt", "sih", "tsq", "mhz", "dox", "ndg", "bia", "lup", "mpr", "khe", "hve", "kxp", "bpk", "fer", "sel", "wir", "ofs", "mrb", "bxo", "fan", "tbz", "bws", "bou", "bxr", "shx", "maw", "xcg", "kci", "txx", "msg", "apc", "fom", "kjn", "lmi", "rri", "sjt", "pbu", "dip", "anf", "wms", "dao", "ksb", "mdm", "bsv", "scx", "ukq", "tbo", "ito", "smy", "mqt", "yme", "lvs", "tsu", "kvm", "oco", "ssj", "gwr", "jmw", "tav", "mop", "atk", "tia", "wnw", "dhn", "gft", "daa", "ptp", "xrr", "aem", "ccd", "doc", "tiu", "snk", "xga", "waz", "bfb", "cir", "kmw", "adr", "bjs", "aaa", "lce", "oua", "zyn", "ang", "bjh", "bel", "lng", "bto", "rak", "bkn", "mfb", "mxe", "tld", "buy", "gta", "tma", "uta", "itz", "kfb", "lhs", "yak", "sxw", "kwg", "unx", "lsh", "ndn", "xkf", "bvr", "shd", "rar", "erh", "apx", "gqa", "rbl", "svc", "iba", "gwx", "mfj", "xru", "uli", "ahm", "bmh", "drc", "sao", "ykk", "fax", "jeu", "swu", "tdm", "mpe", "ils", "dyb", "ksn", "cih", "tii", "clk", "dem", "bxg", "tms", "yig", "poq", "pug", "fay", "bqf", "kuy", "byg", "nch", "xgw", "jab", "div", "nes", "tbl", "fue", "pnd", "kfz", "kbw", "nbj", "xsd", "sja", "goa", "ltz", "dyu", "ghl", "pac", "nir", "pcb", "ddi", "dmx", "kzp", "tmm", "xkd", "xzp", "caf", "unz", "aag", "jgb", "nez", "hca", "xyk", "car", "zhi", "kas", "jbn", "evn", "auq", "ndr", "ruo", "sod", "los", "sok", "aes", "swf", "vec", "bxf", "dmy", "unn", "azt", "ibb", "ngj", "kre", "spx", "heg", "tkb", "meb", "izm", "sad", "esn", "mhn", "wdt", "klt", "nqk", "mvp", "wrg", "vao", "nfa", "xwr", "pmd", "nvo", "crx", "stb", "boi", "yso", "buh", "muu", "gdt", "wlx", "kfq", "ssx", "rgs", "okm", "agg", "gka", "sig", "duv", "dmg", "mxd", "njm", "quw", "wai", "cuw", "gry", "pwr", "khw", "ney", "lkt", "yec", "ved", "zkr", "cdf", "mmn", "byf", "giy", "jow", "tsg", "nbp", "nuu", "hti", "wbe", "afe", "nef", "sld", "avt", "clo", "gly", "ugy", "pue", "ung", "lcp", "tul", "alo", "diu", "jiu", "lmg", "ghn", "hmc", "tpx", "xnm", "tzx", "bra", "war", "kje", "mpm", "kqg", "luc", "nau", "aby", "xmt", "kyw", "ylg", "atq", "xbw", "jos", "ole", "sdg", "sil", "xke", "ter", "noc", "mcf", "djm", "srf", "cjk", "lix", "lld", "mcy", "tcd", "usi", "naw", "szp", "xle", "dug", "kcz", "zyg", "kam", "srp", "lrv", "ynu", "fkk", "pck", "kwn", "jbj", "shu", "osc", "sut", "xwd", "sly", "nsd", "bmu", "ffm", "bpr", "wky", "ags", "kra", "twq", "mky", "ses", "kys", "bos", "ddj", "oog", "ttl", "wor", "jrb", "knm", "tex", "tol", "aeu", "stt", "ifb", "bdz", "weu", "sqo", "dkk", "hay", "ncn", "kpn", "cku", "ape", "fuu", "hio", "emw", "fgr", "deq", "gdb", "kqf", "bjy", "soq", "sts", "sws", "dot", "bie", "kat", "gvp", "aau", "bkp", "bqc", "kei", "hpo", "hds", "bnu", "nti", "abw", "bzw", "wav", "ega", "tlv", "woa", "kof", "bla", "nyw", "god", "snw", "hrz", "eto", "kho", "mng", "ach", "gbl", "kin", "rrt", "uwa", "caw", "mfx", "csf", "dtn", "agk", "xkp", "acl", "pwa", "tax", "sze", "wbt", "akq", "pww", "rmu", "llj", "qvz", "myr", "tsc", "mcr", "kms", "mkf", "zca", "tac", "nhy", "twg", "lob", "twu", "rir", "pee", "nyf", "nzs", "mbe", "sjp", "blb", "pof", "nsp", "bex", "xhu", "sqm", "kjy", "xkg", "nao", "ilk", "mah", "khx", "nkj", "nwi", "sej", "ciy", "xrb", "syy", "hmj", "rou", "lmu", "gbf", "igb", "kvy", "nty", "bne", "ccr", "kpl", "ynl", "nnf", "gdh", "tnd", "nyr", "hbu", "pmw", "bpj", "iyo", "myf", "nok", "tod", "yot", "brl", "sbo", "nbb", "but", "nya", "zpq", "bxh", "ham", "lia", "aez", "quv", "krf", "gmm", "pnk", "sir", "pmi", "lro", "tbc", "nld", "ess", "tij", "sqn", "anj", "gwi", "aft", "atv", "swy", "lmo", "lsv", "imt", "awk", "rwm", "yxl", "rtc", "ogc", "wbj", "vap", "nib", "kpt", "kwu", "mey", "lrz", "nkn", "shr", "paz", "unu", "bwi", "ghk", "mpc", "coj", "iow", "hud", "csb", "mip", "tgb", "uiv", "faf", "wrz", "nac", "bcc", "hoi", "daq", "sch", "ars", "scw", "sis", "zpr", "ckt", "cpo", "jhs", "wha", "ixc", "tca", "yly", "hma", "kwh", "bll", "jub", "wkb", "yva", "sht", "tyu", "byp", "sqs", "nyx", "wac", "aix", "pkb", "xte", "cik", "wuy", "lwa", "tqb", "dgh", "sbp", "ldp", "vmz", "kfc", "ppi", "jbr", "opa", "xbn", "tuz", "ukh", "tco", "kbk", "njs", "rkb", "enh", "drd", "ndh", "dbr", "nkh", "lbq", "yix", "swe", "adu", "mqu", "hoa", "mqo", "two", "emm", "bpw", "bbe", "mdv", "sbv", "nxe", "pre", "pav", "osp", "lsm", "sxg", "tni", "yww", "sav", "krw", "hux", "sgg", "eot", "bho", "kca", "mks", "nll", "hia", "dme", "ipi", "pti", "wol", "klm", "bvz", "ker", "mit", "jid", "mmy", "taw", "bec", "tip", "mjx", "dty", "mch", "duk", "mtv", "ngv", "xcm", "rhp", "raf", "luk", "btw", "njn", "sjm", "crj", "utp", "wie", "yit", "vic", "awn", "mdz", "waq", "lgg", "plt", "dta", "oyb", "swh", "goz", "zeg", "cvn", "xho", "dii", "jng",
 "kbj", "tev", "ktk", "pnl", "cgc", "zag", "nzr", "lif", "ike", "kgb", "khr", "onp", "bds", "sun", "dkx", "qxo", "ktn", "set", "ica", "mxu", "otb", "urz", "lgs", "nug", "bim", "bbp", "xlg", "acs", "tmf", "bup", "wgi", "lso", "xis", "rth", "cjv", "tnn", "zsm", "leb", "riu", "bjj", "guh", "qxt", "geh", "suw", "xph", "zme", "mie", "mbr", "jmc", "ael", "pyy", "bzu", "sip", "nuk", "kiq", "nst", "kou", "oca", "mth", "aqz", "pld", "six", "llb", "nym", "lep", "dgn", "kbc", "sww", "her", "tgr", "rui", "igm", "gya", "sss", "aox", "bcf", "twh", "grq", "eud", "mfs", "faa", "wrh", "lid", "kxt", "vkn", "ctg", "wyr", "bps", "xop", "gdq", "dal", "aik", "mlw", "adi", "ppu", "prg", "srm", "vep", "xtv", "xvs", "pox", "meo", "udm", "acv", "cux", "pgz", "xve", "bjr", "bgu", "sux", "xgf", "gwt", "moh", "syx", "caj", "kri", "mzv", "mvk", "pko", "waf", "msv", "trm", "yuw", "ygw", "une", "lam", "kop", "kor", "mkj", "pbi", "goh", "nrz", "nmc", "oso", "coq", "ilo", "akc", "nam", "mjp", "ndp", "mcl", "cso", "dek", "pbl", "atd", "prm", "sdz", "tus", "mli", "bsc", "rmx", "kim", "pev", "bvt", "mml", "tse", "zza", "uve", "rnw", "tsy", "awm", "axg", "itl", "zmi", "mzh", "kqe", "nkk", "mnu", "swv", "bwc", "ayb", "sbd", "gao", "kcg", "kkc", "csq", "dyy", "qvs", "awx", "rop", "yry", "txh", "ijn", "tmg", "cim", "moo", "szn", "ykt", "gbk", "bby", "hld", "gml", "hun", "jeb", "bwg", "knz", "xed", "sbu", "inh", "wun", "win", "ckb", "kuo", "aup", "mwm", "hba", "kyh", "otu", "yrl", "diz", "enu", "ken", "dya", "taz", "wep", "pgg", "loo", "ida", "bhn", "ots", "dgd", "ank", "zkt", "mvo", "txy", "yxa", "ago", "gyo", "pht", "krz", "njd", "pse", "pqa", "bau", "sre", "kid", "lij", "xod", "yut", "biv", "kth", "bji", "gma", "fum", "fuv", "twr", "nag", "tur", "fll", "krr", "sxr", "tvl", "hax", "eyo", "skb", "umg", "hms", "hih", "iya", "jaq", "hto", "too", "mgl", "lda", "bny", "mlx", "ama", "flh", "mkv", "knb", "mvi", "afp", "aed", "nsr", "ood", "bkd", "jpr", "lrk", "tiy", "tkx", "wtf", "nea", "mut", "sjb", "bfr", "enx", "zkp", "bax", "zeh", "nri", "noq", "arc", "zng", "qum", "soc", "dze", "heb", "atm", "coc", "atl", "dsl", "jod", "rmc", "zmb", "hrp", "oie", "ljp", "tss", "mmj", "kda", "xha", "jaj", "ndb", "jeh", "kpa", "nin", "cdr", "mwt", "lbj", "lke", "bmx", "vgt", "bkj", "aie", "yub", "drq", "nge", "sho", "apo", "emn", "nap", "laz", "chx", "bmw", "dbq", "gda", "pdi", "tsk", "ysd", "zbu", "ort", "jil", "gun", "sxb", "yux", "fqs", "acm", "njt", "avk", "xae", "ihp", "hnn", "yev", "urd", "adz", "kcq", "ntr", "uar", "kva", "zcd", "kkx", "wtb", "twp", "nek", "bzs", "vbk", "mqs", "bdx", "mym", "trv", "thd", "yta", "asl", "lao", "bdd", "gsg", "svs", "llu", "fuy", "tdn", "daw", "mhk", "nor", "orr", "box", "tgi", "dwz", "kwp", "tst", "mqx", "end", "mih", "lmy", "kmv", "oni", "spu", "mkp", "qua", "yku", "xay", "bzk", "cbd", "cnu", "cre", "hoj", "kxb", "agz", "pay", "hya", "lkc", "hle", "hem", "lbo", "arp", "sdf", "mde", "klp", "jkp", "bub", "kiu", "ave", "okb", "tmo", "trh", "bks", "mwu", "pye", "mko", "bdr", "sgi", "nrf", "tbn", "snq", "myg", "ckl", "abl", "yrs", "amc", "bdw", "pze", "gnm", "cht", "mqk", "nyk", "xli", "gmy", "bck", "kil", "dtk", "lim", "kdr", "wib", "bes", "yli", "ssq", "ubr", "dul", "log", "dro", "eng", "ata", "aqp", "llf", "lul", "mrg", "oos", "hot", "nnr", "phu", "sbj", "suk", "vid", "zpx", "zuh", "gua", "jjr", "tlf", "sli", "gdc", "ysy", "por", "huh", "nbm", "bjm", "aid", "qub", "mza", "ydk", "gat", "zav", "mnn", "nkg", "now", "soy", "mye", "rao", "zmw", "ykh", "ges", "mju", "tfi", "taf", "kau", "fub", "poe", "smk", "bva", "bfd", "xpi", "kvu", "tpl", "dib", "npo", "hut", "pao", "vum", "pll", "cay", "dac", "sne", "spq", "zlm", "avo", "nne", "fak", "psh", "yka", "tgv", "nni", "mvu", "axx", "bbu", "boo", "dni", "gba", "ksm", "gho", "kuu", "ldq", "otx", "mup", "smg", "dbv", "wri", "xcc", "snu", "szl", "bbq", "mnk", "fal", "nar", "iks", "kfr", "tji", "zsu", "umu", "cox", "old", "sef", "opt", "ngy", "nuo", "snc", "nqn", "tet", "und", "tyt", "mbd", "ayt", "mdg", "kxm", "fbl", "lom", "frs", "nue", "guk", "kkd", "mcu", "bob", "kzg", "rkh", "mdl", "man", "kco", "bew", "goo", "hod", "krn", "pcn", "itd", "zpy", "guc", "krc", "baj", "klq", "nnh", "dka", "yif", "prz", "txo", "gga", "rmq", "ktt", "gmr", "toi", "yuc", "szg", "akk", "ibh", "ipk", "nhb", "bgx", "sob", "onn", "yuf", "urt", "ziz", "rwo", "suy", "cna", "pek", "irh", "mss", "yki", "rmi", "ytl", "trl", "tyh", "kus", "jor", "tah", "opk", "hmg", "teg", "nkp", "dei", "kag", "tlp", "ces", "bib", "rzh", "tmt", "rem", "lbs", "lht", "ccp", "paw", "sbf", "zea", "kdc", "sfm", "ctm", "suc", "nrt", "prx", "sia", "gvo", "lvl", "kqm", "npg", "ism", "xng", "xoo", "cri", "loe", "rnn", "mby", "xkt", "xre", "sqq", "xri", "sha", "mda", "dbe", "dwk", "suq", "rhg", "xsc", "tbd", "nsu", "nyh", "wod", "emi", "bzv", "nbg", "bok", "zch", "tih", "emk", "kan", "gwn", "piz", "mhm", "ale", "koo", "xmz", "bcg", "udi", "xpg", "dan", "cof", "jct", "psu", "mgj", "fwa", "oro", "kex", "src", "nkc", "zka", "kln", "bmk", "kpb", "yao", "pgl", "uum", "qva", "ltn", "crm", "nhf", "adn", "brf", "awv", "icl", "mqp", "sgb", "mcb", "nex", "xyl", "bdv", "wal", "irx", "bep", "bwn", "ita", "gec", "lus", "xtb", "orv", "ewe", "wyn", "juw", "tdk", "tgc", "hmw", "mmt", "krv", "chj", "kmi", "vwa", "rwa", "xkk", "tlt", "nmp", "bfq", "dpp", "yih", "nmt", "njy", "cup", "bmb", "cbt", "msn", "xom", "wnn", "xld", "mlk", "mww", "obr", "beo", "kub", "afh", "rmt", "mhw", "tgl", "wbi", "kkt", "tga", "klr", "ymr", "zuy", "cjo", "nbo", "tgu", "wnu", "kut", "xtq", "ifu", "tre", "crl", "brz", "knw", "bqi", "vmh", "pwg", "bsh", "xml", "aht", "brr", "ayi", "ttp", "tud", "frd", "bnr", "etu", "ppp", "ilp", "gox", "onr", "gru", "rpn", "tjs", "tys", "xbm", "xkr", "ing", "byv", "lnw", "ymg", "mrn", "czk", "acb", "xrt", "nog", "ntm", "mnp", "amg", "bbr", "tgy", "sjd", "ukl", "pgn", "nod", "xpq", "bod", "eus", "zna", "cot", "hob", "waj", "low", "lug", "xmh", "dmw", "chg", "ldk", "lun", "mmk", "ydg", "fly", "xtl", "dop", "mra", "aog", "ukr", "ptv", "www", "gbx", "stu", "shn", "zpl", "trs", "had", "tvd", "wln", "yia", "srv", "dix", "luz", "csc", "tbu", "zum", "xsl", "jel", "dbp", "hmz", "ity", "wji", "phw", "tja", "kbl", "lut", "qun", "cua", "ggw", "aib", "sdh", "nto", "kai", "lrl", "tuj", "bvd", "azg", "wba", "caq", "yiv", "jqr", "dwu", "gsn", "maj", "ukp", "nzd", "nnv", "wwo", "lga", "mzy", "yzk", "cnt", "glj", "acw", "lol", "bzo", "mhy", "mpq", "nmd", "kpf", "miw", "krt", "ake", "hmv", "der", "sbw", "kdg", "yoi", "doa", "non", "tmn", "bgf", "dsq", "idb", "gal", "kax", "nxd", "bvv", "kef", "haz", "obt", "mhi", "nmq", "aye", "bzc", "kce", "amh", "fud", "keq", "ldo", "xky", "trr", "fsl", "cbs", "duw", "wsr", "due", "kmd", "usa", "pip", "nur", "xpd", "kir", "ain", "ttu", "acp", "bfh", "mgv", "mrj", "grd", "agm", "xas", "rtw", "nzi", "jbu", "ndw", "ruu", "ppm", "urx", "nhd", "gin", "twc", "mrm", "mbo", "gvf", "atc", "wdj", "nqq", "abo", "mna", "lmq", "kup", "nsf", "ser", "dtd", "cto", "aak", "zko", "kql", "mxo", "zgr", "mjc", "oci", "hgw", "klb", "kzf", "qxc", "spn", "zmf", "gld", "zhb", "zor", "kot", "lej", "tkr", "tub", "kiv", "rsk", "bpm", "ggu", "yin", "xki", "tna", "mwf", "cad", "dgl", "bux", "ktg", "bpd", "zmd", "agt", "xpb", "quc", "xct", "vmi", "mhf", "ged", "tez", "diw", "ple", "bhz", "gmb", "gvc", "kie",
 "qxq", "yav", "gfk", "kls", "ppl", "nwb", "dwa", "zyj", "kno", "bxj", "rau", "zpa", "gsp", "toq", "lss", "kdx", "okn", "xpo", "mwv", "mgm", "kht", "kdw", "noz", "bcv", "kqr", "krd", "dnr", "kta", "mbb", "ubu", "wfg", "bwj", "bpx", "lkh", "bqa", "muj", "sed", "sxk", "bdy", "grv", "ukw", "vah", "ksl", "gui", "wci", "aub", "njx", "mvl", "gwb", "ton", "abq", "ncg", "gak", "tnq", "djf", "alq", "pli", "tbm", "ysc", "kst", "ztu", "tzl", "scp", "bdb", "gix", "lna", "tdl", "cnx", "kib", "moz", "onw", "wig", "cmo", "les", "ybn", "yph", "tvn", "pnt", "glh", "bhb", "ibo", "trw", "bww", "kkv", "ijs", "bhs", "jpn", "mzm", "tor", "nuj", "bit", "btm", "gge", "gag", "hrx", "gdi", "enb", "kkh", "ntw", "raw", "tob", "wer", "tim", "nnd", "tsb", "xkw", "nlq", "bvq", "nuz", "jiq", "kap", "lfa", "lmw", "nyb", "thq", "tro", "urn", "yes", "ibm", "kuc", "row", "xub", "tlb", "mln", "yik", "eko", "pix", "mpp", "umr", "sxn", "bhw", "suj", "xnk", "bhp", "aey", "bcr", "nmi", "zhd", "pbm", "sky", "bgw", "jun", "niw", "gub", "kbq", "dui", "mwn", "skt", "pep", "aga", "nnl", "dyr", "spl", "mes", "raj", "ske", "dbf", "seg", "mei", "kec", "goc", "mta", "kaw", "rng", "bsw", "ngw", "ztq", "mwl", "arg", "eri", "oaa", "lnb", "xtt", "ped", "srh", "wut", "nul", "ppn", "cgk", "kom", "bbi", "vmx", "pci", "nvm", "lai", "soj", "sus", "ekr", "pps", "aiq", "tbi", "kvl", "irk", "vko", "tbg", "bxc", "yey", "cbc", "bjg", "mig", "bbv", "nzu", "cgg", "moc", "snx", "akl", "dmu", "tjo", "nob", "bow", "nas", "avs", "nij", "tis", "jms", "brg", "zkv", "sxe", "giu", "trz", "lek", "dlg", "wlo", "nhq", "ymh", "tqr", "ddd", "kfu", "ren", "nmj", "yug", "mvy", "fcs", "gqn", "pes", "xsj", "lil", "fah", "nnq", "mga", "plq", "mxb", "gov", "tay", "tdr", "tju", "auc", "hkk", "gcn", "mns", "tdh", "vin", "jnl", "cbw", "mfi", "zpp", "rmy", "rgu", "bjt", "pbc", "thf", "mrz", "toy", "rap", "ndo", "hii", "fad", "arb", "hgm", "uan", "nlg", "xty", "esh", "yln", "ndy", "som", "yrb", "gxx", "liw", "gnn", "swb", "uni", "gnw", "snl", "nzk", "ket", "axk", "bro", "ide", "pda", "myu", "kzl", "nbq", "kal", "apg", "bbm", "skh", "bgo", "zmv", "msm", "rmo", "hab", "ksq", "apz", "ogo", "zpn", "mhc", "xpv", "csy", "dth", "gvn", "kbx", "zmz", "soa", "hvn", "xeg", "xwo", "ceb", "tzh", "lnd", "sml", "rav", "lev", "kdp", "bxl", "twx", "moy", "gri", "ypa", "cwg", "emb", "mgh", "onu", "xmy", "asi", "dts", "msk", "ynk", "bcn", "ccc", "kdy", "kea", "mai", "aul", "aww", "dtp", "qxp", "sab", "snf", "tuf", "yss", "cms", "jkm", "pey", "vku", "mji", "nqo", "mwa", "ymd", "kke", "gvs", "cuh", "lax", "ndu", "zgm", "zra", "obo", "ksg", "nsy", "sij", "niu", "sko", "bqg", "sgc", "sju", "iry", "fie", "wsi", "zkh", "aqr", "llq", "tkf", "pwb", "mca", "gug", "swc", "ysl", "sza", "gir", "tpc", "prh", "dee", "lmd", "kgi", "cin", "run", "sqr", "dil", "frq", "doe", "npl", "dhv", "ire", "bzt", "mau", "tto", "col", "hwc", "spm", "gnu", "mfz", "mcm", "seb", "kvv", "omi", "uha", "kgf", "tjw", "tye", "fas", "xpa", "dgk", "gbz", "ldl", "dsn", "dik", "dhr", "isa", "bch", "aso", "bdc", "dis", "tcm", "nkm", "tku", "gan", "nrc", "psp", "mfy", "duy", "bae", "app", "rmd", "msy", "lsb", "snz", "nme", "akj", "lzl", "smr", "grg", "ndm", "ozm", "gus", "bfl", "fuf", "cjy", "agd", "mhg", "zpd", "kzi", "pom", "kzk", "zib", "bpy", "hei", "hmr", "ctc", "hkn", "gcf", "lmn", "pmx", "xka", "ytp", "bwp", "len", "jek", "lja", "pdo", "jka", "ihb", "kit", "mvv", "ifm", "dbn", "gaf", "acf", "kdi", "bbx", "tel", "oda", "yae", "kyd", "yaf", "btn", "kak", "nfd", "uks", "umn", "pim", "ajn", "ttk", "zae", "llc", "czo", "ngt", "bhq", "sdt", "wrb", "wrx", "slh", "bkv", "zpj", "brw", "kkp", "xks", "llk", "fpe", "atn", "duz", "huw", "mme", "fij", "kxq", "yty", "any", "nev", "nix", "oin", "lws", "bzb", "hbb", "twa", "yxu", "fur", "jyy", "xua", "kyv", "bdu", "kcb", "nyq", "dbi", "pcg", "sck", "aoj", "zpb", "cga", "cen", "kkl", "mwe", "zhn", "ndz", "wkd", "lbx", "ori", "obm", "ala", "bwy", "niv", "ncq", "kpv", "knu", "rcf", "unm", "kjz", "krl", "zul", "pmm", "bje", "hor", "cmg", "kaf", "npi", "hvc", "puw", "hnd", "niz", "tsr", "ysr", "lhi", "pku", "okg", "nzm", "qus", "spr", "zax", "kky", "fip", "swx", "omg", "prr", "mre", "sto", "tdd", "phn", "thz", "ruh", "cwd", "mhp", "ilb", "faj", "wlu", "fit", "wdd", "dtt", "tiq", "cjh", "mry", "fro", "mic", "srq", "sgx", "kfo", "tbe", "jav", "lch", "qxl", "csn", "mlv", "txt", "npb", "bpa", "gdr", "ife", "dof", "huf", "omx", "aqk", "vmq", "kff", "mon", "qxw", "chp", "fry", "hoc", "qxn", "zwa", "lwh", "sym", "dmm", "thk", "mjl", "ojg", "tgp", "tcw", "ths", "vkt", "dbj", "auh", "dna", "ijj", "mdw", "moa", "nnp", "omo", "tzo", "bma", "itv", "asr", "tqq", "lth", "ubl", "ktl", "nbl", "rmv", "cap", "kjk", "wsa", "aux", "kgg", "xac", "zga", "sat", "lsa", "tmz", "skn", "jrt", "kmf", "kwo", "lma", "kuv", "ctl", "kkk", "new", "pgu", "loj", "mbc", "rin", "btj", "alj", "rmw", "roc", "shb", "egy", "siw", "sni", "tcs", "wgb", "qxu", "pfe", "dnk", "dbm", "iso", "kdm", "xbi", "svk", "mer", "anv", "ror", "scb", "tuy", "mgp", "ell", "kkw", "pos", "ver", "wli", "wbs", "sei", "myb", "orz", "sbr", "uam", "lhl", "tdv", "wga", "kvo", "vie", "bkw", "srs", "quy", "aew", "dcr", "ryu", "pel", "tek", "yua", "mpw", "bym", "xby", "krh", "rer", "swt", "hat", "grh", "itt", "fao", "gmh", "ayl", "tng", "caa", "dhm", "gym", "anl", "qux", "pcd", "dkg", "erg", "tkd", "bak", "guz", "hmf", "zun", "djj", "ygr", "kku", "gnz", "oym", "sdc", "uya", "woy", "gai", "noi", "adg", "ygm", "alf", "bnn", "mmf", "pro", "wsv", "ybm", "asy", "bvj", "kwa", "wbm", "ykr", "cbq", "bcm", "mzi", "dva", "yip", "boa", "gae", "mkl", "kfn", "rka", "tec", "tey", "wnc", "pln", "gyy", "bvb", "aio", "htx", "kgw", "mvq", "ckh", "jge", "mpk", "kzx", "anc", "xht", "abi", "icr", "bmz", "byk", "job", "knq", "mil", "sno", "png", "lbg", "mct", "olo", "bev", "kyn", "gzn", "kkm", "moj", "wur", "rac", "aqm", "oty", "yal", "zap", "jmb", "utr", "zho", "hsl", "tzj", "bme", "tuh", "xnu", "mzz", "rmk", "kgy", "mso", "aro", "rsm", "cor", "lra", "ldb", "ska", "trt", "mgg", "tcc", "mcv", "gex", "ptw", "mev", "xkq", "drg", "zmx", "sst", "bza", "rki", "bdh", "kxz", "tpt", "bsb", "nrr", "ggg", "efi", "slx", "mkr", "mkq", "gyz", "btq", "mcp", "npu", "pmh", "xkv", "vae", "xkz", "kjs", "bqx", "kpr", "psc", "ram", "ext", "zps", "gop", "crz", "yaj", "thm", "ysm", "kfs", "hav", "xsa", "tsx", "glu", "ruk", "pnn", "swp", "bha", "mnv", "nun", "wan", "dua", "yas", "asb", "cbo", "bzz", "mpx", "gur", "vaa", "yah", "cak", "abv", "onx", "ntu", "zdj", "ksp", "gsl", "teo", "mfo", "kgu", "kgp", "jas", "amp", "bgn", "bzx", "sbn", "jup", "wnk", "mpy", "tag", "aug", "ski", "nat", "noj", "nqt", "sln", "bum", "kly", "klo", "ndt", "noe", "bdf", "squ", "vmu", "zoc", "auw", "naq", "bsi", "tru", "hnu", "gcr", "nql", "tiw", "zal", "mvn", "kav", "bjk", "kuw", "ckz", "lgn", "myx", "wls", "nhw", "zau", "nhk", "zmc", "pys", "aca", "ikx", "nee", "bgi", "ngh", "yau", "bmn", "ana", "bph", "lbi", "nsw", "cha", "bop", "wyy", "bky", "dgx", "knc", "rag", "syw", "sdj", "aao", "shm", "brb", "byi", "npa", "pgi", "clw", "ian", "fod", "nph", "niy", "ibr", "veo", "rmn", "tas", "kme", "ecy", "mnm", "mef", "ldi", "ktm", "nuh", "pto", "ysn", "lvu", "era", "rol", "ywt", "lcc", "mdt", "abu", "zkg", "bkg", "tvy", "kbh", "yrm", "kcm", "doz", "cuk", "prw", "sev", "tsi", "kaz", "ntj", "ybh", "suz",
 "sog", "ald", "bea", "fse", "hmb", "mhd", "sgu", "anu", "sur", "chl", "bzi", "anh", "izr", "alz", "mmb", "xok", "pzh", "aka", "nby", "bfw", "nik", "bay", "hmi", "jvd", "alc", "aur", "mzl", "bgj", "bet", "cpn", "chh", "knx", "kyj", "kmk", "cro", "kna", "bmm", "mhq", "mzx", "sii", "vav", "yby", "mqr", "nxi", "woc", "cpc", "mug", "xth", "crg", "nxl", "cnb", "bbh", "sen", "upv", "kse", "boz", "mog", "ayz", "bjw", "bqv", "mmv", "tmd", "yay", "kkq", "muo", "shk", "cym", "guw", "uge", "bah", "hik", "aae", "atj", "cag", "qve", "mea", "plb", "qya", "igs", "myy", "lee", "rus", "ssb", "tgx", "xdy", "gom", "zpf", "azz", "yyu", "kfd", "aah", "gab", "tfo", "dma", "srx", "htu", "asc", "xcv", "hib", "anm", "zlu", "lsw", "nhi", "txe", "bbs", "ame", "pss", "rgn", "vel", "mxp", "jan", "jia", "xbj", "acy", "tvt", "etz", "reb", "aax", "beq", "bvp", "ras", "yum", "iai", "nbc", "tht", "lmf", "noh", "int", "jat", "nhx", "nza", "bhl", "hvv", "prl", "sgj", "aqn", "cid", "heh", "gro", "rga", "kwz", "tam", "mxr", "gbo", "xly", "axl", "mqj", "tge", "mcg", "cuj", "kwe", "yij", "wny", "urw", "zkk", "vkp", "urm", "kqo", "mee", "adj", "kjq", "kjd", "cuu", "esi", "gow", "keu", "baw", "mdn", "pjt", "tww", "smb", "vnp", "bpv", "saw", "xko", "lml", "naa", "kah", "wub", "raa", "wiu", "abm", "tlh", "baa", "bhc", "shq", "ypm", "luq", "goe", "yne", "meq", "nmy", "nmx", "mzq", "wtk", "sbl", "odk", "xab", "zac", "tem", "vmb", "itb", "xtp", "sib", "lgo", "gig", "hov", "glc", "hsh", "mrl", "mts", "bjb", "nys", "iko", "kmb", "nui", "sba", "ikk", "epi", "tln", "acn", "kcy", "fab", "iru", "las", "lit", "nda", "kph", "gdx", "acd", "nde", "pbn", "vma", "gra", "tpp", "puq", "koa", "bdj", "dgo", "nmu", "tbj", "ncf", "pyn", "sys", "apw", "xbr", "bce", "bda", "bku", "cja", "cui", "mll", "loc", "pud", "cek", "kws", "kze", "seh", "kha", "ltg", "bsm", "xil", "tog", "try", "nlu", "esg", "blo", "vmj", "zaz", "ivb", "uur", "rmp", "uis", "cok", "djk", "tdc", "tmi", "num", "ymo", "smz", "bxz", "cab", "otn", "bom", "bkh", "mdy", "biq", "mpd", "uga", "kpq", "rwk", "xoc", "gas", "gnd", "sbq", "smv", "gvy", "slg", "frr", "kaa", "npn", "nck", "maz", "blq", "idd", "umo", "naj", "ahr", "pbb", "lmc", "dja", "neq", "zsr", "ina", "xpu", "cko", "wkl", "zyp", "mhr", "spc", "tcg", "xya", "prf", "mdi", "cqd", "bsr", "chm", "kqi", "txs", "jma", "saa", "hks", "nec", "bas", "mej", "hom", "kwi", "agf", "dbt", "knv", "xkn", "nig", "kxf", "kss", "zms", "key", "xsq", "wau", "hos", "fag", "koy", "smw", "kbp", "spd", "mjt", "jvn", "mht", "mwr", "och", "nlj", "bfz", "xfa", "nae", "zia", "saq", "fni", "xgl", "glb", "mdb", "mgy", "adq", "sid", "kkz", "tkq", "bxv", "ruz", "smn", "kni", "tof", "kzu", "xug", "dhx", "xao", "ybx", "gju", "yro", "nyp", "hmn", "ktp", "xhr", "gaw", "hrm", "zmn", "uss", "clt", "guf", "mjj", "pin", "rue", "tlq", "txc", "ypp", "sjg", "wrp", "kzw", "mps", "pxm", "jud", "how", "tjm", "tyi", "vlp", "fut", "ktj", "ted", "its", "ghh", "nqm", "gwc", "btx", "ott", "led", "tnb", "tiv", "msq", "kow", "spe", "elo", "ctn", "par", "xtc", "pym", "mue", "kxi", "dnn", "bfx", "nht", "vor", "lhh", "lwl", "kum", "ite", "llm", "xet", "one", "bqs", "ktx", "dih", "laj", "yup", "bdm", "kio", "kov", "qup", "gaa", "kgt", "plz", "lox", "kjg", "umd", "ztg", "tsd", "acr", "pmt", "alm", "sku", "lgu", "sta", "gke", "gog", "txg", "xdc", "alx", "trg", "fmp", "tgz", "bri", "bsu", "ych", "afs", "nid", "oia", "kbt", "caz", "agw", "byl", "lsc", "pbp", "tdx", "cpa", "grx", "qvi", "yra", "ipo", "lkn", "bht", "yea", "aal", "ecs", "mpl", "way", "kyc", "ikv", "kzc", "mvx", "max", "ncj", "pex", "aip", "yaa", "lem", "ogg", "aar", "tcb", "hdy", "ywu", "wnp", "zmj", "bac", "ulu", "jie", "mfc", "jmd", "bor", "rji", "mxf", "ugn", "kpu", "pea", "ddo", "kpx", "xpe", "ngz", "zmg", "kzv", "nwx", "muv", "buv", "mav", "ssc", "kns", "tnh", "xaa", "lou", "mxv", "sjn", "cji", "sqh", "afi", "mhe", "mrk", "soe", "kzb", "wao", "kfv", "mbs", "amz", "ktb", "aoe", "bgg", "skg", "skr", "vml", "zaf", "ayn", "chq", "azb", "ant", "lcd", "ksf", "blj", "kjr", "lbc", "mpo", "duc", "uru", "ngk", "umi", "xap", "ymp", "amy", "sgk", "oji", "mek", "hit", "muq", "wof", "apk", "mzb", "xxr", "kbb", "cyo", "mbl", "aok", "nki", "yhs", "iwk", "kqu", "dzl", "bfs", "tap", "urr", "ngx", "syr", "xlc", "nwa", "aws", "ccl", "knj", "cam", "pnb", "iti", "qvl", "kjm", "nfl", "kqt", "ogu", "hao", "mzp", "kxa", "ysp", "mfm", "mlu", "okh", "phv", "ptr", "smo", "snn", "iku", "lgm", "nbu", "ncu", "kvq", "aac", "lgl", "ona", "kjx", "blh", "ude", "deu", "gcc", "jau", "lhu", "ero", "xlu", "lig", "bem", "aqc", "tta", "bkt", "ppk", "std", "gou", "goq", "dse", "gux", "xmj", "yrk", "uzb", "gqr", "mjr", "xnn", "ayd", "lgz", "bvh", "blx", "yeu", "kek", "osn", "buq", "adh", "bja", "luo", "mvs", "aqt", "auu", "ory", "gla", "kbm", "qws", "rkt", "dso", "xur", "huo", "lnn", "gbs", "tcx", "yxm", "zil", "urb", "upi", "dai", "pmb", "ido", "klg", "lky", "okk", "cni", "nnc", "hmp", "kuf", "uma", "yur", "chu", "klz", "txu", "kcs", "wyi", "ruy", "ett", "hij", "lof", "bwx", "xuo", "wca", "deh", "xbp", "say", "blt", "mny", "mws", "wly", "lex", "bde", "crc", "hrc", "hrw", "plv", "rel", "mkc", "hmq", "mnz", "inl", "tds", "zmt", "gpa", "ayg", "bwf", "gyd", "tmh", "utu", "xog", "cmr", "bhd", "mqe", "cby", "bnk", "sug", "act", "mbx", "mur", "bis", "arh", "mec", "gof", "hru", "ins", "pkg", "pdc", "lef", "nbe", "diq", "pme", "wmg", "btg", "pcc", "pej", "cnw", "zsk", "mjw", "xcr", "deg", "ers", "jus", "dnj", "gdm", "ggl", "mxc", "bzr", "sub", "def", "ebk", "enl", "naz", "nrm", "luw", "ptq", "lzz", "mtc", "mag", "yde", "ayp", "aaf", "akp", "cdi", "flr", "knp", "mum", "nrl", "ifk", "khk", "lab", "kck", "rro", "tad", "dnd", "frm", "pho", "teu", "ncs", "thv", "wlk", "gmg", "xdm", "yll", "atp", "haa", "nfu", "pbf", "nxr", "beh", "ral", "lik", "ahh", "wag", "hwo", "bql", "byx", "aku", "bhv", "idc", "the", "xse", "dwy", "bnc", "nnu", "sdu", "kvk", "mnh", "xaj", "pch", "rea", "wuv", "vrs", "kwx", "lel", "slp", "dms", "vmg", "ndq", "mwo", "cae", "xbe", "xcu", "bao", "ors", "hre", "sah", "kte", "cbl", "psi", "doq", "lxm", "gdu", "lha", "bhu", "mne", "tte", "cbn", "plw", "ulc", "gdj", "ban", "mzu", "rwl", "igw", "xad", "mnr", "xam", "ssp", "wiv", "mjh", "lbv", "ayu", "ngc", "lmr", "xgi", "cde", "dow", "kix", "kpm", "grm", "nsv", "mlt", "rnr", "nzy", "ats", "nho", "xmm", "xtd", "ano", "wog", "nej", "laf", "xir", "pae", "frk", "ptt", "cda", "shc", "blz", "bye", "qvp", "ojv", "tmj", "wat", "skj", "nen", "sje", "ycn", "mcq", "fnb", "bdg", "sle", "jiy", "uzn", "dzo", "nkx", "zim", "xnt", "bhf", "byc", "pru", "leu", "mte", "mrp", "ekk", "omn", "ygu", "llg", "mkw", "bvc", "xup", "seu", "yiz", "vrt", "swm", "trd", "maf", "tpy", "bbl", "byo", "ybb", "lbz", "bdk", "cpu", "lwm", "aps", "uln", "nbv", "evh", "ojp", "yam", "apr", "hng", "usp", "lpx", "dmv", "mux", "ail", "ebg", "bvw", "pif", "zmr", "cts", "fmu", "mjv", "ojw", "tpu", "bko", "pdt", "kgv", "lar", "twt", "zoq", "mhu", "cpb", "myv", "phj", "mak", "nga", "bqn", "duf", "nmo", "pux", "kgk", "kzq", "agc", "oor", "tal", "bsf", "zam", "ssz", "buw", "myl", "tok", "mrv", "kpz", "sie", "nsh", "mzn", "bun", "nwm", "odu", "mar", "aeb", "vka", "mtm", "gbn", "ycp", "lor", "tnr", "bng", "gjr", "zpc", "kvz", "bxa", "kcu", "cnh", "mxq", "igl", "aob", "ncc", "net", "tov", "znk", "ksr", "tso", "gbp", "ner",
 "xch", "kqy", "afu", "srk", "fif", "ttw", "ute", "bzj", "glk", "dlm", "nji", "smf", "dyo", "mmp", "jhi", "ulk", "snj", "ior", "sga", "tme", "scv", "tlk", "kft", "nqy", "mvh", "zin", "wno", "dno", "gnc", "siu", "kcj", "aic", "pmq", "dam", "fvr", "pml", "vmv", "tcu", "tbx", "jio", "nuy", "pmy", "okl", "tlx", "mdd", "won", "xbc", "kab", "zmk", "erw", "pnj", "mjb", "mpn", "oku", "tvx", "mjz", "grs", "kad", "lbr", "drn", "poc", "mlg", "zku", "jax", "krj", "nua", "tcf", "xsr", "klf", "pcl", "ask", "nxx", "gaj", "pei", "cob", "ibe", "jnj", "vil", "smc", "ikt", "yzg", "tya", "cdo", "mbq", "avm", "twl", "vme", "kjc", "lst", "tft", "sqi", "lwt", "mxj", "bjz", "bkx", "pir", "nil", "cnr", "uby", "cmm", "lip", "wgu", "str", "gza", "gbb", "mke", "ceg", "swo", "mpi", "elu", "baf", "awa", "ady", "njl", "ddn", "jen", "nuq", "snv", "dol", "isc", "vnm", "leo", "bnx", "mbi", "pnv", "quf", "lur", "nra", "mrq", "bcd", "mij", "mjg", "cco", "tls", "whu", "spv", "kep", "nms", "cch", "nuc", "kng", "bdo", "dhg", "ayo", "sxm", "acq", "bgt", "esk", "asj", "gvr", "itx", "sqx", "brq", "huu", "ndd", "bdn", "zbl", "bhi", "rxw", "aif", "wma", "ebo", "eya", "djc", "dmc", "vay", "vmp", "wei", "mnj", "twd", "xyj", "cnp", "ron", "tdq", "nds", "zpe", "fli", "mep", "nif", "rom", "taq", "qwh", "vif", "ljl", "zha", "isk", "kge", "kmh", "njr", "pri", "aea", "pis", "pny", "ncm", "xnq", "mzt", "spo", "bpi", "dza", "nhh", "thl", "ttj", "zar", "clc", "mom", "osx", "zlj", "xvi", "que", "bki", "xny", "tbr", "hin", "kae", "wbl", "koe", "mmh", "bam", "syc", "bul", "jim", "hnh", "atg", "dum", "hmt", "kzs", "lln", "mgs", "dhs", "nkw", "sag", "bei", "bns", "mmm", "mrh", "kvt", "phk", "sbz", "sjl", "bmi", "kjh", "xdk", "mjy", "hla", "dgt", "mpz", "mib", "nse", "rub", "tsp", "bcu", "cla", "jle", "tns", "wbv", "nii", "kfh", "dir", "qvc", "xxb", "yom", "tig", "kbi", "msb", "kmj", "ash", "awy", "otq", "asw", "aho", "pmj", "sdl", "siv", "fla", "ono", "pus", "gyi", "vem", "vig", "qxa", "scg", "sms", "aki", "lhm", "uda", "dic", "wbb", "ngb", "tch", "nal", "nww", "boe", "inj", "ehs", "haw", "tlm", "aks", "awi", "nwg", "cra", "zln", "gsw", "poy", "den", "rmb", "cst", "nha", "rog", "brm", "wap", "cic", "sxo", "alk", "bdi", "ayk", "btp", "gyn", "san", "grr", "gbv", "dbl", "gwd", "kww", "aud", "cey", "xkb", "anr", "sls", "tjl", "psg", "adt", "bdl", "kuh", "sar", "gad", "ctu", "krk", "vkj", "bzd", "mtn", "nyl", "lgh", "dhd", "sey", "ahg", "aiw", "cjs", "nxo", "ote", "pbr", "hum", "bsl", "yrn", "bfj", "mkt", "peb", "agb", "amf", "blm", "zbt", "mzg", "onj", "woe", "olm", "abk", "mzw", "rab", "thr", "gar", "khd", "bfo", "jks", "clm", "kcn", "mwq", "sue", "siq", "sma", "hed", "tyx", "coa", "mrw", "nyu", "thp", "txq", "kzr", "ugb", "asf", "akv", "thh", "gna", "oar", "bof", "xxk", "kct", "sxc", "kde", "wgy", "bnw", "lrr", "egm", "kih", "nlw", "spt", "arx", "lbn", "hoe", "agl", "bvg", "dor", "klh", "gbj", "kvr", "smq", "brn", "ldd", "mtq", "sps", "hui", "ttc", "wux", "grj", "ngn", "rod", "bms", "tue", "wil", "xsy", "lpn", "tuc", "mfu", "xmd", "ade", "tpe", "lri", "zrg", "nkr", "zte", "xgr", "mfh", "shy", "zay", "pan", "abn", "emp", "sru", "wob", "nhv", "peo", "kqx", "pso", "aen", "aza", "bve", "brj", "gbd", "geq", "gyr", "ima", "lic", "gib", "nsq", "phd", "lhn", "nie", "tfr", "wbq", "wik", "yan", "yno", "zgb", "zmu", "pov", "sra", "gok", "eaa", "wam", "wbw", "ksi", "gul", "juh", "mtf", "xpt", "bxu", "gkd", "mir", "ymb", "tql", "tbh", "tdj", "xme", "hai", "pem", "arq", "ani", "tll", "xar", "jig", "akr", "ktv", "omp", "ost", "bef", "mwi", "zkz", "mdx", "kyq", "sgd", "bip", "lbt", "aon", "zoh", "qxh", "kog", "mxw", "piw", "orn", "ind", "kdk", "wmb", "zpg", "jgk", "mgc", "ulb", "mfw", "nly", "bgr", "eit", "eve", "lzh", "tgn", "wii", "lrg", "czt", "bqu", "tou", "tqo", "nan", "avv", "wmw", "ygl", "dri", "ksz", "kya", "wnm", "tat", "kvf", "aot", "lae", "brh", "bkz", "ljw", "ssl", "ghs", "gmx", "cdy", "abr", "mxz", "nit", "huc", "wmh", "xra", "ebc", "wad", "ght", "fss", "ims", "jur", "kdq", "lio", "etr", "tsh", "xav", "zts", "bsq", "paq", "tno", "pub", "rax", "nku", "abc", "xmw", "kkb", "ccg", "kdh", "lap", "crq", "tly", "taa", "koz", "nhm", "pks", "sdp", "lon", "mmc", "wtw", "lua", "mpj", "tef", "yms", "yei", "yet", "csw", "dif", "ila", "hts", "mmq", "kyb", "eky", "psr", "hix", "ktw", "kes", "mba", "kiy", "bgq", "pia", "xma", "hau", "akx", "lni", "tdf", "xul", "glv", "wuh", "eiv", "blk", "rmg", "nlz", "kiz", "gbw", "amu", "ktu", "dmr", "srb", "kgl", "nxn", "dev"])
name_id = Dict("Nyangumarta" => "nna", "Riung" => "riu", "Gagu" => "ggu", "Lole" => "llg", "Patpatar" => "gfk", "Kahua" => "agw", "Modole" => "mqo", "Poqomchi'" => "poh", "Official Aramaic" => "arc", "West Central Oromo" => "gaz", "Benga" => "bng", "Tagbanwa" => "tbw", "Jaru" => "ddj", "Nyungwe" => "nyu", "New Zealand Sign Language" => "nzs", "Lokaa" => "yaz", "Lautu Chin" => "clt", "Yakan" => "yka", "Central Berawan" => "zbc", "Tchumbuli" => "bqa", "Rennell-Bellona" => "mnv", "Tabriak" => "tzx", "Mandobo Bawah" => "bwp", "Waru" => "wru", "Abellen Ayta" => "abp", "Ottawa" => "otw", "Kucong" => "lkc", "Wulna" => "wux", "Ngarinyman" => "nbj", "Edolo" => "etr", "Língua Gestual Guineense" => "lgs", "Sihuas Ancash Quechua" => "qws", "Lishán Didán" => "trg", "Bukit Malay" => "bvu", "Andegerebinha" => "adg", "Wiarumus" => "tua", "Lü" => "khb", "Akuku" => "ayk", "Segeju" => "seg", "Guhu-Samane" => "ghs", "Ncane" => "ncr", "Western Tunebo" => "tnb", "Maithili" => "mai", "Mingrelian" => "xmf", "Bisis" => "bnw", "Damakawa" => "dam", "Bimoba" => "bim", "Emilian" => "egl", "Narragansett" => "xnt", "Yauyos Quechua" => "qux", "Basay" => "byq", "Sicilian" => "scn", "Chickasaw" => "cic", "Ubang" => "uba", "Northern Qiang" => "cng", "Barí" => "mot", "Bosngun" => "bqs", "Kamta" => "rkt", "Tsucuba" => "cbq", "Kairiru" => "kxa", "Malavedan" => "mjr", "Kuwaa" => "blh", "Natanzi" => "ntz", "Saisiyat" => "xsy", "Southern Carrier" => "caf", "Chadong" => "cdy", "Kamayurá" => "kay", "Brokskat" => "bkk", "Northern Conchucos Ancash Quechua" => "qxn", "Tilung" => "tij", "Yipma" => "byr", "Lapaguía-Guivini Zapotec" => "ztl", "Rathwi Bareli" => "bgd", "Pare" => "ppt", "Iko" => "iki", "Kaitag" => "xdq", "Kepo'" => "kuk", "Kaiep" => "kbw", "Uzbek" => "uzb", "Kinabalian" => "cbw", "Tlamacazapa Nahuatl" => "nuz", "Selangor Sign Language" => "kgi", "Kija" => "gia", "Loncong" => "lce", "Mbulungish" => "mbv", "German" => "deu", "Obulom" => "obu", "Chantyal" => "chx", "Changriwa" => "cga", "Loun" => "lox", "Kirike" => "okr", "Wantoat" => "wnc", "Krevinian" => "zkv", "Saparua" => "spr", "Molengue" => "bxc", "Phunoi" => "pho", "Jiamao" => "jio", "Karakalpak" => "kaa", "Alsea" => "aes", "Bhatri" => "bgw", "Bukiyip" => "ape", "Southern Rengma Naga" => "nre", "Somali" => "som", "Jiba" => "juo", "Bolia" => "bli", "Teressa" => "tef", "East Limba" => "lma", "Rangi" => "lag", "Kanikkaran" => "kev", "Gergiko" => "moz", "El Nayar Cora" => "crn", "Lusengo" => "lse", "Papora" => "ppu", "Moroccan Sign Language" => "xms", "Jah Hut" => "jah", "Kambiwá" => "xbw", "Bacama" => "bcy", "Wadikali" => "wdk", "Rampi" => "lje", "Heung Kong Sau Yue" => "hks", "Dabarre" => "dbr", "Luba-Lulua" => "lua", "Lasalimu" => "llm", "Nimadi" => "noe", "Swahili" => "swh", "Yarawata" => "yrw", "Zaiwa" => "atb", "Tanema" => "tnx", "Huilliche" => "huh", "Early Tripuri" => "xtr", "Onondaga" => "ono", "Minriq" => "mnq", "Áncá" => "acb", "Uma' Lung" => "ulu", "Kurdish" => "kur", "Datooga" => "tcc", "Papua New Guinean Sign Language" => "pgz", "Akuntsu" => "aqz", "Lau" => "llu", "Kerewo" => "kxz", "Gonja" => "gjn", "Cashibo-Cacataibo" => "cbr", "Nyamal" => "nly", "Lombo" => "loo", "Timbe" => "tim", "Tecpatlán Totonac" => "tcw", "Mayoyao Ifugao" => "ifu", "Barclayville Grebo" => "gry", "Semai" => "sea", "Kula" => "tpg", "Tagalog" => "tgl", "Toposa" => "toq", "Tai Thanh" => "tmm", "Komi-Permyak" => "koi", "Sirmauri" => "srx", "Sherpa" => "xsr", "Ukue" => "uku", "Defi Gbe" => "gbh", "Wamesa" => "wad", "Mirandese" => "mwl", "Puinave" => "pui", "Maring Naga" => "nng", "So" => "soc", "Tama" => "tma", "Yasa" => "yko", "Kimaama" => "kig", "Alabat Island Agta" => "dul", "Odoodee" => "kkc", "Fon" => "fon", "Bulo Stieng" => "sti", "Sampang" => "rav", "Pinjarup" => "pnj", "Lwalu" => "lwa", "Dai Zhuang" => "zhd", "Tsaangi" => "tsa", "Lachixío Zapotec" => "zpl", "Rombo" => "rof", "Northern Dagara" => "dgi", "Dubu" => "dmu", "Limbu" => "lif", "Aluo" => "yna", "Toro Tegu Dogon" => "dtt", "Jejueo" => "jje", "Lelepa" => "lpa", "Bembe" => "bmb", "Chumburung" => "ncu", "Northern Gondi" => "gno", "Kutong" => "skm", "Guiberoua Béte" => "bet", "Sakao" => "sku", "Pirriya" => "xpa", "Jangkang" => "djo", "Guramalum" => "grz", "Hiw" => "hiw", "Huaulu" => "hud", "Southern Tidung" => "itd", "Ibatan" => "ivb", "Raute" => "rau", "Erave" => "kjy", "Rawo" => "rwa", "Mwimbi-Muthambi" => "mws", "Rejang" => "rej", "Nchumbulu" => "nlu", "Mondropolon" => "npn", "Sowa" => "sww", "Kala Lagaw Ya" => "mwp", "Eravallan" => "era", "Turi" => "trd", "Ap Ma" => "kbx", "Mru" => "mro", "Baure" => "brg", "Salt-Yui" => "sll", "Halbi" => "hlb", "Igwe" => "igw", "Itene" => "ite", "Interlingua" => "ina", "Malvi" => "mup", "Ede Idaca" => "idd", "Paunaka" => "pnk", "Manda" => "zma", "Tee" => "tkq", "Worimi" => "kda", "Nyanga-li" => "nyc", "Abai Sungai" => "abf", "Jabutí" => "jbt", "Pye Krumen" => "pye", "Sonde" => "shc", "Yanomámi" => "wca", "Subi" => "xsj", "Maringarr" => "zmt", "Yatay" => "yty", "Rincón Zapotec" => "zar", "Gude" => "gde", "Zyphe Chin" => "zyp", "Old Hittite" => "oht", "Sonha" => "soi", "A'ou" => "aou", "Landoma" => "ldm", "Icelandic" => "isl", "Aghu-Tharnggala" => "gtu", "Hattic" => "xht", "Khao" => "xao", "Apiaká" => "api", "Anuta" => "aud", "Mün Chin" => "mwq", "Yout Wam" => "ytw", "Agariya" => "agi", "Ciwogai" => "tgd", "Finland-Swedish Sign Language" => "fss", "Mashi" => "mho", "Alago" => "ala", "Yirandali" => "ljw", "Angosturas Tunebo" => "tnd", "Kumba" => "ksm", "Supyire Senoufo" => "spp", "Quiavicuzas Zapotec" => "zpj", "Pankhu" => "pkh", "Tomini" => "txm", "Judeo-Tripolitanian Arabic" => "yud", "Mawes" => "mgk", "Mbato" => "gwa", "Mainfränkisch" => "vmf", "Judeo-Georgian" => "jge", "Aushi" => "auh", "Guarani" => "grn", "Nukuoro" => "nkr", "Sumtu Chin" => "csv", "Gurung" => "gvr", "Numidian" => "nxm", "Betaf" => "bfe", "Iñapari" => "inp", "Swiss-French Sign Language" => "ssr", "Lwel" => "lvl", "Elepi" => "ele", "Kumam" => "kdi", "Mafea" => "mkv", "Bau Bidayuh" => "sne", "Aequian" => "xae", "North Marquesan" => "mrq", "Matu Chin" => "hlt", "Luidakho-Luisukha-Lutirichi" => "ida", "Giangan" => "bgi", "Indian Sign Language" => "ins", "Emem" => "enr", "Bua" => "bub", "Western Bru" => "brv", "Matengo" => "mgv", "Nez Perce" => "nez", "Pambia" => "pmb", "Bedjond" => "bjv", "Lengilu" => "lgi", "Nalik" => "nal", "Chincha Quechua" => "qxc", "Kombai" => "tyn", "Koropó" => "xxr", "Central Puebla Nahuatl" => "ncx", "Daga" => "dgz", "Dutton World Speedwords" => "dws", "Kanjobal" => "kjb", "Nobiin" => "fia", "Bozaba" => "bzo", "Cakchiquel-Quiché Mixed Language" => "ckz", "Angal" => "age", "Southern Binukidnon" => "mtw", "Aka" => "soh", "Banam Bay" => "vrt", "Mattole" => "mvb", "Panamint" => "par", "Alawa" => "alh", "Kunja" => "pep", "Northern Tutchone" => "ttm", "Galindan" => "xgl", "Northwest Pashai" => "glh", "Taroko" => "trv", "Asoa" => "asv", "Norn" => "nrn", "Sibu Melanau" => "sdx", "Northern Nuni" => "nuv", "Araona" => "aro", "Ayi" => "ayq", "Nuuchahnulth" => "nuk", "Yangum Mon" => "ymo", "Awngthim" => "gwm", "Bengali" => "ben", "Puquina" => "puq", "Hunjara-Kaina Ke" => "hkk", "Old Nubian" => "onw", "Ngumbarl" => "xnm", "Yameo" => "yme", "Chigmecatitlán Mixtec" => "mii", "Limassa" => "bme", "Maricopa" => "mrc", "Avava" => "tmb", "Machiguenga" => "mcb", "Urarina" => "ura", "Highland Popoluca" => "poi", "Tsimshian" => "tsi", "Zuojiang Zhuang" => "zzj", "Maden" => "xmx", "Eastern Lalu" => "yit", "Mbunga" => "mgy", "Vlaamse Gebarentaal" => "vgt", "Tsimané" => "cas", "Saponi" => "spi", "Qawasqar" => "alc", "Zul" => "zlu", "Papar" => "dpp", "Malayic Dayak" => "xdy", "Mid Grand Valley Dani" => "dnt", "Ghadamès" => "gha", "Ludian" => "lud", "Besisi" => "mhe", "Punan Batu 1" => "pnm", "Uda" => "uda", "Kasem" => "xsm", "Teke-Fuumu" => "ifm", "Hakha Chin" => "cnh", "Kaningra" => "knr", "Tirahi" => "tra", "Kedah Malay" => "meo", "Dzalakha" => "dzl", "Ibali Teke" => "tek", "Epigraphic Mayan" => "emy", "Ngarinyin" => "ung", "Boloki" => "bkt", "Marka" => "rkm", "Chalikha" => "tgf", "Churahi" => "cdj", "Akhvakh" => "akv", "Mintil" => "mzt", "Northern Toussian" => "tsp", "Sikiana" => "sik", "Ukwa" => "ukq", "Kembra" => "xkw", "Dyangadi" => "dyn", "Omotik" => "omt", "Aralle-Tabulahan" => "atq", "Nakwi" => "nax", "Senthang Chin" => "sez", "Bariji" => "bjc", "Bilbil" => "brz", "Banda-Banda" => "bpd", "Harzani" => "hrz", "Nek" => "nif", "Hiberno-Scottish Gaelic" => "ghc", "Orokolo" => "oro", "Chitimacha" => "ctm", "Russian Sign Language" => "rsl", "Zizilivakan" => "ziz", "Bahinemo" => "bjh", "Warao" => "wba", "Jennu Kurumba" => "xuj", "Kunza" => "kuz", "Minanibai" => "mcv", "Kaivi" => "kce", "Buxinhua" => "bgk", "Madhi Madhi" => "dmd", "Mobwa Karen" => "jkm", "Santa Teresa Cora" => "cok", "Harari" => "har", "Kpala" => "kpl", "Boon" => "bnl", "Asho Chin" => "csh", "Sakirabiá" => "skf", "Holikachuk" => "hoi", "Northern Yukaghir" => "ykg", "Polish Sign Language" => "pso", "Tasmate" => "tmt", "Margany" => "zmc", "Hértevin" => "hrt", "Nimanbur" => "nmp", "Songo" => "soo", "Iquito" => "iqu", "Nubri" => "kte", "Mbole" => "mdq", "Chuang" => "zha", "Lehali" => "tql", "Minz Zhuang" => "zgm", "Bambam" => "ptu", "Chitkuli Kinnauri" => "cik", "Northern Tepehuan" => "ntp", "Bangubangu" => "bnx", "Minkin" => "xxm", "Khah" => "hkh", "Tebi" => "dmu", "Gamo" => "gmv", "Old High German" => "goh", "Etebi" => "etb", "Rajong" => "rjg", "Traveller Danish" => "rmd", "Batyala" => "xby", "Meänkieli" => "fit", "Mt. Iraya Agta" => "atl", "Umanakaina" => "gdn", "Paku" => "pku", "Nyelâyu" => "yly", "Dabe" => "dbe", "Idere" => "ide", "Central Ojibwa" => "ojc", "Coatlán Mixe" => "mco", "Maaka" => "mew", "Taveta" => "tvs", "Arabana" => "ard", "Shekkacho" => "moy", "Quileute" => "qui", "Sensi" => "sni", "Djawi" => "djw", "Pingelapese" => "pif", "Tsuvadi" => "tvd", "Korafe-Yegha" => "kpr", "Miami" => "mia", "Chilcotin" => "clc", "Khün" => "kkh", "Sauri" => "srt", "Lao" => "lao", "Biangai" => "big", "Cross River Mbembe" => "mfn", "Dogosé" => "dos", "South Marquesan" => "mqm", "Abun" => "kgr", "Papi" => "ppe", "Aasáx" => "aas", "Bomboma" => "bws", "Sawai" => "szw", "Tiranige Diga Dogon" => "tde", "Blissymbols" => "zbl", "Aninka" => "aqk", "Nachering" => "ncd", "Gallurese Sardinian" => "sdn", "Sanga" => "xsn", "Mednyj Aleut" => "mud", "Heiban" => "hbn", "Sakata" => "skt", "Susu" => "sus", "Yessan-Mayo" => "yss", "Izii" => "izz", "Bakumpai" => "bkr", "Surbakhal" => "sbj", "Galo" => "adl", "Pudtol Atta" => "atp", "Iguta" => "nar", "Butmas-Tur" => "bnr", "San Blas Kuna" => "cuk", "Od" => "odk", "Mozambican Sign Language" => "mzy", "Kuanyama" => "kua", "Rusnak" => "rsk", "Sinagen" => "siu", "Turaka" => "trh", "Kuwema" => "woa", "Semnani" => "smy", "Judeo-Arabic" => "jrb", "Tocantins Asurini" => "asu", "Dijim-Bwilim" => "cfa", "Zaramo" => "zaj", "Tanimuca-Retuarã" => "tnc", "Marfa" => "mvu", "Bajan" => "bjs", "Arbëreshë Albanian" => "aae", "Eipomek" => "eip", "Senaya" => "syn", "Girawa" => "bbr", "Berik" => "bkl", "Júma" => "jua", "Ladji Ladji" => "llj", "Old Russian" => "orv", "Dimasa" => "dis", "Nganyaywana" => "nyx", "Turka" => "tuz", "Central Malay" => "pse", "Thu Lao" => "tyl", "Puruborá" => "pur", "Dia" => "dia", "Southern Conchucos Ancash Quechua" => "qxo", "Wajarri" => "wbv", "Haméa" => "cir", "Tày Tac" => "tyt", "Negidal" => "neg", "Bajjika" => "vjk", "Maridjabin" => "zmj", "Seluwasan" => "sws", "Bohtan Neo-Aramaic" => "bhn", "Kipsigis" => "sgc", "Bidiyo" => "bid", "Afar" => "aar", "Murupi" => "mqw", "Munji" => "mnj", "Sudanese Creole Arabic" => "pga", "Faliscan" => "xfa", "Andio" => "bzb", "Hyolmo" => "scp", "Siamou" => "sif", "Rajbanshi" => "rjs", "Andarum" => "aod", "San Martín Quechua" => "qvs", "Rajasthani" => "raj", "Talossan" => "tzl", "Bahamas Creole English" => "bah", "Suyá" => "suy", "Kwomtari" => "kwo", "Mayi-Thakurti" => "xyt", "Ta'izzi-Adeni Arabic" => "acq", "Karingani" => "kgn", "Nyika" => "nkv", "Dutch" => "nld", "Jofotek-Bromnya" => "jbr", "Mbo" => "zmw", "Lingua Franca" => "pml", "Kapauri" => "khp", "Gureng Gureng" => "gnr", "San Juan Colorado Mixtec" => "mjc", "Mapia" => "mpy", "Ubaghara" => "byc", "Lubila" => "kcc", "Kitharaka" => "thk", "Dhurga" => "dhu", "East Futuna" => "fud", "Lozi" => "loz", "Naro" => "nhr", "Tukang Besi South" => "bhq", "Agi" => "aif", "Duriankere" => "dbn", "English" => "eng", "Maremgi" => "mrx", "Leningitij" => "lnj", "Pwaamei" => "pme", "Noon" => "snf", "Ozolotepec Zapotec" => "zao", "Sangir" => "sxn", "Punan Merap" => "puc", "Shahrudi" => "shm", "Unubahe" => "unu", "Voro" => "vor", "Santa Catarina Albarradas Zapotec" => "ztn", "Tunni" => "tqq", "Kung-Ekoka" => "knw", "Kanamarí" => "knm", "Interlingue" => "ile", "Lamang" => "hia", "Church Slavic" => "chu", "Nepal Bhasa" => "new", "Kuan" => "uan", "Wangkumara" => "xwk", "Azerbaijani" => "aze", "Baras" => "brs", "South Watut" => "mcy", "Uzbeki Arabic" => "auz", "Nzadi" => "nzd", "Sa'ban" => "snv", "Adivasi Oriya" => "ort", "Chabu" => "sbf", "Akukem" => "spm", "Wagawaga" => "wgb", "Papantla Totonac" => "top", "Nkem-Nkum" => "isi", "Rundi" => "run", "Acatepec Tlapanec" => "tpx", "Oku" => "oku", "Bumang" => "bvp", "Leonese" => "ast", "Atampaya" => "amz", "Dagaari Dioula" => "dgd", "Seychelles Sign Language" => "lsw", "Northern One" => "onr", "Ngaliwurru" => "djd", "Koro Nulu" => "vkn", "Shwai" => "shw", "Krahô" => "xra", "Trumai" => "tpy", "Larike-Wakasihu" => "alo", "Bolgo" => "bvo", "Klias River Kadazan" => "kqt", "Kanoé" => "kxo", "Mapuche" => "arn", "Gwa" => "gwb", "Kaera" => "jka", "Lepcha" => "lep", "Dhanki" => "dhn", "Attapady Kurumba" => "pkr", "Abipon" => "axb", "Limos Kalinga" => "kmk", "Mongolia Buriat" => "bxm", "Tai Hongjin" => "tiz", "Ménik" => "tnr", "Latin" => "lat", "Indus Valley Language" => "xiv", "Yamna" => "ymn", "Kele" => "sbc", "Malawian Sign Language" => "lws", "Congo Swahili" => "swc", "Mairasi" => "zrs", "Bauchi" => "bsf", "Kalmyk" => "xal", "Northern Pastaza Quichua" => "qvz", "Barok" => "bjk", "Cun" => "cuq", "Lacandon" => "lac", "Ixcatec" => "ixc", "Northern Tasmanian" => "xpv", "Yurats" => "rts", "Odual" => "odu", "Luyia" => "luy", "Gorovu" => "grq", "Kibet" => "kie", "Titan" => "ttv", "Garingbal" => "xgi", "Zeem" => "zem", "Chilean Sign Language" => "csg", "Yambeta" => "yat", "Tamanaku" => "tmz", "Wailaki" => "wlk", "Nema" => "gsn", "Kyan-Karyaw Naga" => "nqq", "Haroi" => "hro", "Kuot" => "kto", "Ari" => "aac", "Bantik" => "bnq", "Northern Emberá" => "emp", "Kotafon Gbe" => "kqk", "Yelmek" => "jel", "Lowland Oaxaca Chontal" => "clo", "Mori Atas" => "mzq", "Sarangani Manobo" => "mbs", "Kayong" => "kxy", "Nyiyaparli" => "xny", "Dhangu" => "dhg", "Divehi" => "div", "Adonara" => "adr", "Southwestern Tepehuan" => "tla", "Buduma" => "bdm", "Olukhayo" => "lko", "Central Huasteca Nahuatl" => "nch", "Kola" => "kvv", "Dura" => "drq", "Baruya" => "byr", "Large Flowery Miao" => "hmd", "Chippewa" => "ciw", "Nengone" => "nen", "Kalou" => "ywa", "Eastern Maroon Creole" => "djk", "Ron" => "cla", "Kagayanen" => "cgc", "Northern Ngbandi" => "ngb", "U" => "uuu", "Kati" => "bsh", "Kamas" => "xas", "Angal Heneng" => "akh", "Boko" => "bqc", "Temoaya Otomi" => "ott", "Nicarao" => "ppl", "Cambodian Sign Language" => "csx", "Qaqet" => "byx", "Aulua" => "aul", "Baeggu" => "bvd", "Bongili" => "bui", "Awa-Cuaiquer" => "kwi", "Makayam" => "aup", "Lunda" => "lun", "Laz" => "lzz", "Mansi" => "mns", "Mvuba" => "mxh", "Western Mashan Hmong" => "hmw", "Krung" => "krr", "Iau" => "tmu", "Llengua de Signes Catalana" => "csc", "Puno Quechua" => "qxp", "Taliabu" => "tlv", "Wunambal" => "wub", "Yabula Yabula" => "yxy", "Tumshuqese" => "xtq", "Pero" => "pip", "Fungwa" => "ula", "Bura-Pabir" => "bwr", "Tuma-Irumu" => "iou", "Dhanwar" => "dhw", "Tibea" => "ngy", "Middle Korean" => "okm", "Belhariya" => "byw", "Teke-Laali" => "lli", "Baka" => "bkc", "finlandssvenskt teckenspråk" => "fss", "Kapriman" => "dju", "Kodeoha" => "vko", "Alanic" => "xln", "Kuke" => "ght", "Southwest Palawano" => "plv", "Northern Ping Chinese" => "cnp", "Kayabí" => "kyz", "Sango" => "sag", "Tutuba" => "tmi", "Kokata" => "ktd", "Thangal Naga" => "nki", "Ikposo" => "kpo", "Hamap" => "hmu", "Seimat" => "ssg", "Batjala" => "xby", "Loniu" => "los", "Bete" => "byf", "Alumu-Tesu" => "aab", "Miyakubo Sign Language" => "ehs", "Numbami" => "sij", "Leti" => "lti", "Marma" => "rmz", "Tsakhur" => "tkr", "Seit-Kaitetu" => "hik", "Mbre" => "mka", "Olekha" => "ole", "Kadu" => "zkd", "Tuyuca" => "tue", "Nsongo" => "nsx", "Ruwila" => "rwl", "Mpumpong" => "mgg", "Ndwewe" => "nww", "Daro-Matu Melanau" => "dro", "Enxet" => "enx", "Fanbak" => "fnb", "Otuke" => "otu", "Horom" => "hoe", "Binahari" => "bxz", "Western Bukidnon Manobo" => "mbb", "Korlai Creole Portuguese" => "vkp", "Tharaka" => "thk", "Tsishingini" => "tsw", "Madagascar Sign Language" => "mzc", "Bahnar" => "bdq", "Min Bei Chinese" => "mnp", "New Caledonian Javanese" => "jas", "Pu-Xian Chinese" => "cpx", "Liberia Kpelle" => "xpe", "Zande" => "zne", "Nyindrou" => "lid", "E" => "eee", "Laalaa" => "cae", "Bargam" => "mlp", "Chut" => "scb", "Morouas" => "mrp", "Tunzu" => "dza", "Enawené-Nawé" => "unk", "Northwestern ǃKung" => "vaj", "Sentani" => "set", "Breton" => "bre", "Siar-Lak" => "sjr", "T'apo" => "lgn", "Tutong" => "ttg", "Yagomi" => "ygm", "Koreguaje" => "coe", "Khonso" => "kxc", "Jwira-Pepesa" => "jwi", "Coeur d'Alene" => "crd", "Kochila Tharu" => "thq", "Eastern Yiddish" => "ydd", "Agavotaguerra" => "avo", "Bangi" => "bni", "Daho-Doo" => "das", "Korku" => "kfq", "El Alto Zapotec" => "zpp", "Torona" => "tqr", "Mili" => "ymh", "Yazgulyam" => "yah", "Warji" => "wji", "Ozumacín Chinantec" => "chz", "Awabakal" => "awk", "Bench" => "bcq", "Hlai" => "lic", "Bih" => "ibh", "Tuamotuan" => "pmt", "Jejara Naga" => "pzn", "So'a" => "ssq", "Ywom" => "gek", "Tobagonian Creole English" => "tgh", "Chuanqiandian Cluster Miao" => "cqd", "Meramera" => "mxm", "Loo" => "ldo", "Chittagonian" => "ctg", "Kungardutyi" => "gdt", "Kuni" => "kse", "Loup B" => "xlb", "Late Middle Chinese" => "ltc", "Cerma" => "cme", "Giryama" => "nyf", "Lycian" => "xlc", "Quebec Sign Language" => "fcs", "Mong Leng" => "hnj", "Kwaja" => "kdz", "Lushootseed" => "lut", "Cemuhî" => "cam", "Durop" => "krp", "Yutanduchi Mixtec" => "mab", "Virgin Islands Creole English" => "vic", "Akpa" => "akf", "Tangut" => "txg", "Kabras" => "lkb", "Nhuwala" => "nhf", "Logba" => "lgq", "Saxwe Gbe" => "sxw", "Ume Sami" => "sju", "Walmajarri" => "wmt", "Mendalam Kayan" => "xkd", "Birri" => "bvq", "Pongu" => "png", "Kemi Sami" => "sjk", "Marramaninyshi" => "zmm", "Marau" => "mvr", "Mamanwa" => "mmn", "Akoose" => "bss", "Ullatan" => "ull", "Grangali" => "nli", "Guanche" => "gnc", "West Goodenough" => "ddi", "Lere" => "gnh", "Nisa" => "njs", "Kgalagadi" => "xkv", "Watakataui" => "wtk", "Ukit" => "umi", "Foia Foia" => "ffi", "Bishuo" => "bwh", "Golpa" => "lja", "Syriac" => "syr", "Adangme" => "ada", "Nanai" => "gld", "Elfdalian" => "ovd", "Kwa" => "kwb", "Waima" => "rro", "Tuotomb" => "ttf", "Adygei" => "ady", "Akkadian" => "akk", "Hrangkhol" => "hra", "Bolgarian" => "xbo", "Huli" => "hui", "San Pedro Amuzgos Amuzgo" => "azg", "Mundabli" => "boe", "Amara" => "aie", "Viid" => "snu", "Aguano" => "aga", "Southeastern Nochixtlán Mixtec" => "mxy", "Ajawa" => "ajw", "Sikule" => "skh", "Yongbei Zhuang" => "zyb", "Hmong Dô" => "hmv", "Pyen" => "pyy", "Bandial" => "bqj", "Muna" => "mnb", "Puyo" => "xpy", "Tiéyaxo Bozo" => "boz", "Hwana" => "hwo", "Ili Turki" => "ili", "Thur" => "lth", "Iranian Persian" => "pes", "Pagu" => "pgu", "Suena" => "sue", "Piemontese" => "pms", "Tz'utujil" => "tzj", "Djambarrpuyngu" => "djr", "Kafa" => "kbr", "Barein" => "bva", "Sichuan Yi" => "iii", "Timbisha" => "par", "Liburnian" => "xli", "Meskwaki" => "sac", "Eblan" => "xeb", "Ahirani" => "ahr", "Southwestern Tlaxiaco Mixtec" => "meh", "Ito" => "itw", "Ho" => "hoc", "Hobyót" => "hoh", "Chokri Naga" => "nri", "Limburgan" => "lim", "Karon" => "krx", "Kuijau" => "dkr", "Mesaka" => "iyo", "Mapun" => "sjm", "Woleaian" => "woe", "Maiadomu" => "mzz", "Papiamento" => "pap", "Tulu" => "tcy", "Middle Khmer" => "xhm", "Southern Nago" => "nqg", "Hasha" => "ybj", "Northern Kissi" => "kqs", "Highland Puebla Nahuatl" => "azz", "Kölsch" => "ksh", "Judeo-Italian" => "itk", "Gurgula" => "ggg", "Tase Naga" => "nst", "Dyaabugay" => "dyy", "Adangbe" => "adq", "Kamwe" => "hig", "North Midlands Tasmanian" => "xph", "Polabian" => "pox", "Mzieme Naga" => "nme", "Hindi" => "hin", "Bati" => "bvt", "Changthang" => "cna", "Dahalik" => "dlk", "Medebur" => "mjm", "Casiguran Dumagat Agta" => "dgc", "Bung" => "bqd", "Northern Sorsoganon" => "bks", "Boro" => "xxb", "Kinnauri" => "kfk", "Kinga" => "zga", "Ditammari" => "tbz", "Sihan" => "snr", "Gunditjmara" => "gjm", "Umeda" => "upi", "Shilluk" => "shk", "Kaur" => "vkk", "Kriol" => "rop", "Adioukrou" => "adj", "Bankan Tey Dogon" => "dbw", "Yandjibara" => "xyb", "Tiwi" => "tiw", "Pilipino" => "fil", "Kurtokha" => "xkz", "Löyöp" => "urr", "Highland Konjo" => "kjk", "Suganga" => "sug", "Daza" => "dzd", "Bassossi" => "bsi", "Quinqui" => "quq", "Kapinawá" => "xpn", "Waorani" => "auc", "Animere" => "anf", "Albanian Sign Language" => "sqk", "Kutchi" => "kfr", "Nadëb" => "mbj", "Miji" => "sjl", "Siksika" => "bla", "Gobasi" => "goi", "Chimila" => "cbg", "Kinamiging Manobo" => "mkx", "Nyangbo" => "nyb", "Arumanian" => "rup", "Lutos" => "ndy", "Wambule" => "wme", "Nigerian Sign Language" => "nsi", "Gurr-goni" => "gge", "Ede Ije" => "ijj", "Tlacoatzintepec Chinantec" => "ctl", "Bintulu" => "bny", "Casuarina Coast Asmat" => "asc", "Bisa" => "bib", "Ixcatlán Mazatec" => "mzi", "Kabatei" => "xkp", "Kaian" => "kct", "Southern Sami" => "sma", "Utu" => "utu", "Kosli" => "spv", "Yoruba" => "yor", "Askopan" => "eiv", "Broome Pearling Lugger Pidgin" => "bpl", "Vlaams" => "vls", "Gbin" => "xgb", "Asturleonese" => "ast", "Obolo" => "ann", "Kuku-Yalanji" => "gvn", "Northern Mashan Hmong" => "hmp", "Western Frisian" => "fry", "Koromira" => "kqj", "Pahi" => "lgt", "Mokilese" => "mkj", "Maxakalí" => "mbl", "Jakattoe" => "jrt", "Aoheng" => "pni", "Maiwa" => "wmm", "Pileni" => "piv", "Gros Ventre" => "ats", "Panyi Bai" => "bfc", "Towei" => "ttn", "Kuanhua" => "xnh", "Angami Naga" => "njm", "Kein" => "bmh", "Kairak" => "ckr", "Yan-nhangu" => "jay", "Bankal" => "jjr", "Banda Malay" => "bpq", "Luba-Katanga" => "lub", "White Lachi" => "lwh", "Nisga'a" => "ncg", "Pakaásnovos" => "pav", "Lorediakarkar" => "lnn", "Yangum Gel" => "ygl", "Kwese" => "kws", "Koro Zuba" => "vkz", "Ci Gbe" => "cib", "Bira" => "brf", "Northern Hindko" => "hno", "Pacaraos Quechua" => "qvp", "Tswana" => "tsn", "Maba" => "mqa", "Mag-Indi Ayta" => "blx", "Hano" => "lml", "Western Tlacolula Valley Zapotec" => "zab", "Moksha" => "mdf", "Kugbo" => "kes", "Southern Tutchone" => "tce", "Dumi" => "dus", "Eastern Bolivian Guaraní" => "gui", "Kalo Finnish Romani" => "rmf", "Embaloh" => "emb", "Judeo-Yemeni Arabic" => "jye", "Bawm Chin" => "bgr", "Dolpo" => "dre", "Corongo Ancash Quechua" => "qwa", "Siculo Arabic" => "sqr", "Wè Northern" => "wob", "Dawawa" => "dww", "Ngantangarra" => "ntg", "Baga Manduri" => "bmd", "Hya" => "hya", "Jilbe" => "jie", "Ormu" => "orz", "Kerek" => "krk", "Eastern Ngad'a" => "nea", "Xwela Gbe" => "xwe", "Choapan Zapotec" => "zpc", "Jungle Inga" => "inj", "Fedan" => "pdn", "Marwari" => "rwr", "Bacanese Malay" => "btj", "Bumbita Arapesh" => "aon", "Matngala" => "zml", "Mayeka" => "myc", "Kwinsu" => "kuc", "Lohorung" => "lbr", "Akolet" => "akt", "Mozarabic" => "mxi", "Rangpuri" => "rkt", "Arosi" => "aia", "Ai-Cham" => "aih", "Arawá" => "aru", "Piratapuyo" => "pir", "Wadiyara Koli" => "kxp", "Idesa" => "ids", "Hazaragi" => "haz", "Galician" => "glg", "Sara" => "sre", "Yakaikeke" => "ykk", "Chamorro" => "cha", "Lahta" => "kvt", "Ayoreo" => "ayo", "Santa María Del Mar Huave" => "hvv", "Cypriot Arabic" => "acy", "Lakota Dida" => "dic", "North Mofu" => "mfk", "Herdé" => "hed", "Maltese Sign Language" => "mdl", "Saliba" => "sbe", "Besme" => "bes", "Central Tarahumara" => "tar", "West Coast Bajau" => "bdr", "Candoshi-Shapra" => "cbu", "Dangaura Tharu" => "thl", "Yukpa" => "yup", "Eastern Meohang" => "emg", "Gugu Badhun" => "gdc", "Motu" => "meu", "Miwa" => "vmi", "Tifal" => "tif", "Myanmar Sign Language" => "ysm", "Nyishi" => "njz", "Gudang" => "xgd", "Central Awyu" => "awu", "ut-Ma'in" => "gel", "Yalahatan" => "jal", "Karelian" => "krl", "Wannu" => "jub", "Bolyu" => "ply", "Southwestern Fars" => "fay", "Kandas" => "kqw", "Burun" => "bdi", "Aiome" => "aki", "Mainstream Kenyah" => "xkl", "Taabwa" => "tap", "Gwandara" => "gwn", "Anamgura" => "imi", "Mugom" => "muk", "Rabha" => "rah", "Mexican Sign Language" => "mfs", "Cree" => "cre", "Secoya" => "sey", "Kagoma" => "kdm", "Mokole" => "mkl", "Kasanga" => "ccj", "Purisimeño" => "puy", "Biao-Jiao Mien" => "bje", "Haitian Creole" => "hat", "Bahonsuai" => "bsu", "Olumarachi" => "lri", "Quiché" => "quc", "Ticuna" => "tca", "Southeastern Tarahumara" => "tcu", "Aringa" => "luc", "Nyikina" => "nyh", "Wangkangurru" => "wgg", "Wilawila" => "wil", "Kuk" => "kfn", "Ahtena" => "aht", "Karata" => "kpt", "Kansa" => "ksk", "Czech" => "ces", "Masbatenyo" => "msb", "Yindjibarndi" => "yij", "Lakota" => "lkt", "Bauria" => "bge", "Magbukun Ayta" => "ayt", "Japanese" => "jpn", "Wondama" => "wad", "Ayizo Gbe" => "ayb", "Kosare" => "kiq", "Innu" => "moe", "Neve'ei" => "vnm", "Afade" => "aal", "Hurrian" => "xhu", "Langue des Signes Seychelloise" => "lsw", "Khmer" => "khm", "Gedaged" => "gdd", "Ngurimi" => "ngq", "Seberuang" => "sbx", "Tariana" => "tae", "Sapo" => "krn", "Central Yupik" => "esu", "Logo" => "log", "Agob" => "kit", "Tause" => "tad", "Parakanã" => "pak", "Forak" => "frq", "Gozarkhani" => "goz", "Taushiro" => "trr", "Humene" => "huf", "Old Provençal" => "pro", "Lungalunga" => "vmg", "Akrukay" => "afi", "Pular" => "fuf", "Western Juxtlahuaca Mixtec" => "jmx", "North Junín Quechua" => "qvn", "Rasawa" => "rac", "Nkutu" => "nkw", "Dyirbal" => "dbl", "Ikhin-Arokho" => "ikh", "Sateré-Mawé" => "mav", "Khiamniungan Naga" => "kix", "Urat" => "urt", "Mesopotamian Arabic" => "acm", "Gagadu" => "gbu", "Longuda" => "lnu", "Chinali" => "cih", "Phupa" => "ypp", "Koroni" => "xkq", "Ache" => "yif", "Ngul" => "nlo", "Tjungundji" => "tjj", "Pima Bajo" => "pia", "Yamphu" => "ybi", "Majhi" => "mjz", "Sengseng" => "ssz", "Kou" => "snz", "Dakota" => "dak", "Batak Karo" => "btx", "Monumbo" => "mxk", "Dixon Reef" => "dix", "Mpalitjanh" => "xpj", "Morigi" => "mdb", "Polonombauk" => "plb", "Villa Viciosa Agta" => "dyg", "Marimanindji" => "zmm", "Urapmin" => "urm", "Greenlandic" => "kal", "Keley-I Kallahan" => "ify", "Sagala" => "sbm", "Wutunhua" => "wuh", "Manangkari" => "znk", "Kumaoni" => "kfy", "Duli-Gey" => "duz", "Eastern Hongshuihe Zhuang" => "zeh", "Talaud" => "tld", "Southeastern Puebla Nahuatl" => "npl", "Crimean Tatar" => "crh", "Hadrami Arabic" => "ayh", "Tsoa" => "hio", "Lhaovo" => "mhx", "Kamang" => "woi", "Mirgan" => "zrg", "Krongo" => "kgo", "Mócheno" => "mhn", "Pattapu" => "ptq", "Ulch" => "ulc", "Guruntum-Mbaaru" => "grd", "Gudjal" => "wrg", "South Bolivian Quechua" => "quh", "Serua" => "srw", "Apalaí" => "apy", "Masimasi" => "ism", "Wagiman" => "waq", "Ararandewára" => "xaj", "Minjungbal" => "xjb", "Bokyi" => "bky", "Wogeo" => "woc", "Taman" => "tmn", "Eshtehardi" => "esh", "Kabola" => "klz", "Simbali" => "smg", "Tambas" => "tdk", "Buamu" => "box", "Lonwolwol" => "crc", "Chechen" => "che", "Garo" => "grt", "Kenyang" => "ken", "Marind" => "mrz", "Kumbainggar" => "kgs", "Vale" => "vae", "Balangao" => "blw", "Ekit" => "eke", "Classical Nahuatl" => "nci", "Máku" => "xak", "Chipaya" => "cap", "Elkei" => "elk", "Chácobo" => "cao", "Khvarshi" => "khv", "Kenyan Sign Language" => "xki", "Chambri" => "can", "Musasa" => "smm", "Tolomako" => "tlm", "Avikam" => "avi", "Kamaru" => "kgx", "Lambayeque Quechua" => "quf", "Sipacapense" => "qum", "Kwa'" => "bko", "Hanga Hundi" => "wos", "Shasta" => "sht", "Ngazidja Comorian" => "zdj", "Old Lithuanian" => "olt", "East Makian" => "mky", "Masai" => "mas", "Sáliba" => "slc", "Tahitian" => "tah", "Sora" => "srb", "Mohawk" => "moh", "Badui" => "bac", "Clallam" => "clm", "Upper Grand Valley Dani" => "dna", "Ngizim" => "ngi", "Central Grebo" => "grv", "Nankina" => "nnk", "Ngas" => "anc", "Atatláhuca Mixtec" => "mib", "Ocotepec Mixtec" => "mie", "Sanglechi" => "sgy", "Kumukio" => "kuo", "Torricelli" => "tei", "Central Okinawan" => "ryu", "Judeo-Moroccan Arabic" => "aju", "Tasawaq" => "twq", "Fijian" => "fij", "Teke-Kukuya" => "kkw", "Limburger" => "lim", "Arop-Lokep" => "apr", "Sharanahua" => "mcd", "Kukna" => "kex", "Phola" => "ypg", "Taiap" => "gpn", "Hunzib" => "huz", "Zayein Karen" => "kxk", "Aka-Kol" => "aky", "Ik" => "ikx", "Kwaya" => "kya", "Kovai" => "kqb", "Gunya" => "gyy", "Nyanja" => "nya", "Dyula" => "dyu", "Oblo" => "obl", "Sabu" => "hvn", "Lake Miwok" => "lmw", "Aiton" => "aio", "Shambala" => "ksb", "Zoogocho Zapotec" => "zpq", "Kalasha" => "kls", "Hamba" => "hba", "Nyore" => "nyd", "Kubu" => "kvb", "Ndogo" => "ndz", "Punan Bah-Biau" => "pna", "Tucano" => "tuo", "Wotapuri-Katarqalai" => "wsv", "Barai" => "bbb", "Ghodoberi" => "gdo", "Morokodo" => "mgc", "Kaurna" => "zku", "Bantawa" => "bap", "Borna" => "bwo", "Mogholi" => "mhj", "Hanoi Sign Language" => "hab", "Romano-Serbian" => "rsb", "Koyo" => "koh", "Cocama-Cocamilla" => "cod", "Kalabakan" => "kve", "Pa'O" => "blk", "Tommeginne" => "xpv", "Bariai" => "bch", "Estonian Sign Language" => "eso", "Tunisian Sign Language" => "tse", "Wallisian" => "wls", "Khotanese" => "kho", "Yalálag Zapotec" => "zpu", "Balti" => "bft", "Ontenu" => "ont", "Foi" => "foi", "Wolane" => "wle", "Efutop" => "ofu", "Unami" => "unm", "Engenni" => "enn", "Folopa" => "ppo", "Wadjiginy" => "wdj", "Southern Pumi" => "pmj", "Yukuben" => "ybl", "Sinhalese" => "sin", "Axi Yi" => "yix", "Phom Naga" => "nph", "Cao Miao" => "cov", "Meroitic" => "xmr", "Northern Qiandong Miao" => "hea", "Bulgarian" => "bul", "Bahing" => "bhj", "Güilá Zapotec" => "ztu", "Seselwa Creole French" => "crs", "Mangayat" => "myj", "She" => "shx", "Zazaki" => "zza", "Malaccan Creole Malay" => "ccm", "Norwegian Sign Language" => "nsl", "Gugubera" => "kkp", "Tumak" => "tmc", "Western Dani" => "dnw", "Patep" => "ptp", "Soga" => "xog", "Modang" => "mxd", "Mangareva" => "mrv", "Tikopia" => "tkp", "Tulehu" => "tlu", "Hangaza" => "han", "Lingua Franca Nova" => "lfn", "Bugan" => "bbh", "Mampruli" => "maw", "Klao" => "klu", "Southeastern Ixtlán Zapotec" => "zpd", "Sabah Bisaya" => "bsy", "Ngardi" => "rxd", "Selkup" => "sel", "Chaura" => "crv", "Amahai" => "amq", "Inabaknon" => "abx", "Gedeo" => "drs", "Mbati" => "mdn", "Ivbie North-Okpela-Arhe" => "atg", "Songoora" => "sod", "Nenets" => "yrk", "North Efate" => "llp", "Bauni" => "bpe", "Aka-Jeru" => "akj", "Samaritan" => "smp", "Shahmirzadi" => "srz", "Oorlams" => "oor", "Bilin" => "byn", "Hebrew" => "heb", "Bwe Karen" => "bwe", "Minoan" => "omn", "Kuria" => "kuj", "Eten" => "etx", "Lusitanian" => "xls", "Udmurt" => "udm", "Oluluyia" => "luy", "Suau" => "swp", "Hmong Shua" => "hmz", "Falam Chin" => "cfm", "Moroccan Arabic" => "ary", "Sea Island Creole English" => "gul", "Kunjen" => "kjn", "Lamma" => "lev", "Sonaga" => "ysg", "Abar" => "mij", "Quenya" => "qya", "Adamorobe Sign Language" => "ads", "Abé" => "aba", "Kelon" => "kyo", "Xipaya" => "xiy", "Jiru" => "jrr", "Grass Koiari" => "kbk", "Malaynon" => "mlz", "Yabaâna" => "ybn", "Southern Subanen" => "laa", "Northern Amami-Oshima" => "ryn", "Kaxararí" => "ktx", "Sirionó" => "srq", "Guguyimidjir" => "kky", "Biwat" => "bwm", "Labir" => "jku", "Pauserna" => "psm", "Achagua" => "aca", "Sar" => "mwm", "Anserma" => "ans", "Auwe" => "smf", "Vishavan" => "vis", "Kott" => "zko", "Old Norse" => "non", "Woiwurrung" => "wyi", "Romam" => "rmx", "Ranglong" => "rnl", "Vitou" => "vto", "Kairui-Midiki" => "krd", "Adang" => "adn", "Middle Irish" => "mga", "Demta" => "dmy", "Coptic" => "cop", "Rishiwa" => "rsw", "Taikat" => "aos", "Flaaitaal" => "fly", "Befang" => "bby", "Ruga" => "ruh", "Maku'a" => "lva", "Makwe" => "ymk", "Jarai" => "jra", "Tajiki Arabic" => "abh", "Mbuk" => "bpc", "Fali" => "fli", "Pardhan" => "pch", "Thao" => "ssf", "Pijin" => "pis", "Central Siberian Yupik" => "ess", "Kembayan" => "xem", "Maklew" => "mgf", "Moikodi" => "mkp", "Judeo-Tat" => "jdt", "Quiripi" => "qyp", "Chiduruma" => "dug", "Celtiberian" => "xce", "Blang" => "blr", "Coatzospan Mixtec" => "miz", "Southeast Pashai" => "psi", "Old Irish" => "sga", "Mambwe-Lungu" => "mgr", "Yerukula" => "yeu", "Mysian" => "yms", "Nyengo" => "nye", "Andh" => "anr", "Chokwe" => "cjk", "Dameli" => "dml", "Areba" => "aea", "Bhalay" => "bhx", "Humburi Senni Songhay" => "hmb", "Tene Kan Dogon" => "dtk", "Shiki" => "gua", "Pa Di" => "pdi", "Pochutec" => "xpo", "Makhuwa" => "vmw", "Kosena" => "kze", "Alladian" => "ald", "Dungu" => "dbv", "Ikwo" => "iqw", "Daur" => "dta", "Hmar" => "hmr", "Finongan" => "fag", "Navaho" => "nav", "Tocho" => "taz", "Dwang" => "nnu", "Simte" => "smt", "Smärky Kanum" => "kxq", "Mulaha" => "mfw", "Tetela" => "tll", "Kamoro" => "kgq", "Wayana" => "way", "Ashéninka Pajonal" => "cjo", "Dek" => "dek", "Jumjum" => "jum", "Kakabai" => "kqf", "Abanyom" => "abm", "Bainouk-Gunyuño" => "bab", "Sowari" => "dmy", "Amami Koniya Sign Language" => "jks", "Kove" => "kvc", "Mundat" => "mmf", "Lasgerdi" => "lsa", "Manombai" => "woo", "Alviri-Vidari" => "avd", "Buriat" => "bua", "Ere" => "twp", "Cuneiform Luwian" => "xlu", "Gweno" => "gwe", "Kurama" => "krh", "Cinta Larga" => "cin", "Old Uighur" => "oui", "Eyak" => "eya", "Santa María La Alta Nahuatl" => "nhz", "Ebrié" => "ebr", "Bookan" => "bnb", "Santa Lucía Monteverde Mixtec" => "mdv", "Tombulu" => "tom", "Baruga" => "bjz", "Kubachi" => "ugh", "German Sign Language" => "gsg", "Banggai" => "bgz", "Ambo-Pasco Quechua" => "qva", "Chetco" => "ctc", "Kepkiriwát" => "kpn", "Kamarian" => "kzx", "Darkinyung" => "xda", "Jola-Fonyi" => "dyo", "Old Cornish" => "oco", "Migabac" => "mpp", "Chicahuaxtla Triqui" => "trs", "Ghandruk Sign Language" => "gds", "Abua" => "abn", "Tshangla" => "tsj", "Tai Dam" => "blt", "Osing" => "osi", "Bukar-Sadung Bidayuh" => "sdo", "Longgu" => "lgu", "Waja" => "wja", "A'tong" => "aot", "Phukha" => "phh", "North Watut" => "una", "Embu" => "ebu", "Nanerigé Sénoufo" => "sen", "Nyaturu" => "rim", "Ralte" => "ral", "Owenia" => "wsr", "Pará Gavião" => "gvp", "Nukuria" => "nur", "Haitian Vodoun Culture Language" => "hvc", "Uruangnirin" => "urn", "Rawat" => "jnl", "Amo" => "amo", "Lomavren" => "rmi", "Kwere" => "cwe", "Wagaya" => "wga", "Koitabu" => "kqi", "Waling" => "wly", "Orang Seletar" => "ors", "Ghotuo" => "aaa", "Beginci" => "ebc", "Copala Triqui" => "trc", "Wipi" => "gdr", "Bamali" => "bbq", "Guahibo" => "guh", "Ujir" => "udj", "Danish" => "dan", "Bangala" => "bxg", "Mum" => "kqa", "Nicaragua Creole English" => "bzk", "Komodo" => "kvh", "Valpei" => "vlp", "Kamantan" => "kci", "Kadiwéu" => "kbc", "Kalkutung" => "ktg", "Tomadino" => "tdi", "Negeri Sembilan Malay" => "zmi", "Bakole" => "kme", "Niksek" => "gbe", "Wik-Iiyanh" => "wij", "Kumarbhag Paharia" => "kmj", "Niuafo'ou" => "num", "Brokpake" => "sgt", "Binji" => "bpj", "Yonaguni" => "yoi", "Konyak Naga" => "nbe", "Chakali" => "cli", "Malol" => "mbk", "Cibak" => "ckl", "Tojolabal" => "toj", "Braj" => "bra", "Mafa" => "maf", "Gikuyu" => "kik", "Izora" => "cbo", "Simeulue" => "smr", "Tagin" => "tgj", "Bijori" => "bix", "Luwati" => "luv", "'Are'are" => "alu", "Makasae" => "mkz", "Palaka Senoufo" => "plr", "Gamilaraay" => "kld", "Tututepec Mixtec" => "mtu", "Guevea De Humboldt Zapotec" => "zpg", "Kildin Sami" => "sjd", "Mpade" => "mpi", "Ngamo" => "nbh", "Oring" => "org", "Ibaloi" => "ibl", "Urningangg" => "urc", "Zeeuws" => "zea", "Trió" => "tri", "Makaa" => "mcp", "Cakchiquel" => "cak", "Urim" => "uri", "Tejalapan Zapotec" => "ztt", "Lobi" => "lob", "East Ambae" => "omb", "Mountain Koiali" => "kpx", "Na" => "nbt", "Kwinti" => "kww", "Kaco'" => "xkk", "Thuri" => "thu", "Ghomálá'" => "bbj", "Mouwase" => "jmw", "Suki" => "sui", "Pamosu" => "hih", "Wampar" => "lbq", "Mudu Koraga" => "vmd", "Duhwa" => "kbz", "Cua" => "cua", "Rungwa" => "rnw", "Takuu" => "nho", "ǂUngkue" => "gku", "Pinigura" => "pnv", "Gahri" => "bfu", "Guwamu" => "gwu", "Itonama" => "ito", "Eton" => "eto", "Iwam" => "iwm", "Fam" => "fam", "Rukai" => "dru", "Zacatepec Chatino" => "ctz", "Koyaga" => "kga", "Sunwar" => "suz", "Vanuma" => "vau", "Narom" => "nrm", "Xhosa" => "xho", "Novial" => "nov", "Tanglang" => "ytl", "Te'un" => "tve", "Awad Bing" => "bcu", "Istriot" => "ist", "Thaypan" => "typ", "Nande" => "nnb", "Ewondo" => "ewo", "Crimean Turkish" => "crh", "Adiwasi Garasia" => "gas", "Ndengereko" => "ndg", "Rāziḥī" => "rzh", "Mator" => "mtm", "Azoyú Tlapanec" => "tpc", "Zhuang" => "zha", "Thawa" => "xtv", "Lugbara" => "lgg", "Bädi Kanum" => "khd", "Barbareño" => "boi", "Malecite-Passamaquoddy" => "pqm", "Nalögo" => "nlz", "Salar" => "slr", "Nhanda" => "nha", "Basketo" => "bst", "Jair Awyu" => "awv", "Kupsabiny" => "kpz", "Azhe" => "yiz", "Mgbolizhia" => "gmz", "Pomo" => "pmm", "Bhattiyali" => "bht", "Guyanese Creole English" => "gyn", "Maring" => "mbw", "Sula" => "szn", "Imperial Aramaic" => "arc", "Tukpa" => "tpq", "Borong" => "ksr", "Phake" => "phk", "Nung" => "nut", "Savosavo" => "svs", "Botlikh" => "bph", "Foma" => "fom", "Morisyen" => "mfe", "Noric" => "nrc", "Cimbrian" => "cim", "Buso" => "bso", "Gungu" => "rub", "Wunumara" => "wnn", "Bomwali" => "bmw", "Koyra Chiini Songhay" => "khq", "ǁXegwi" => "xeg", "Luguru" => "ruf", "Sundanese" => "sun", "Angloromani" => "rme", "Pahanan Agta" => "apf", "Kayan Mahakam" => "xay", "Amto" => "amt", "Kuikúro-Kalapálo" => "kui", "Lingarak" => "lgk", "Samtao" => "stu", "Tarjumo" => "txj", "Upper Necaxa Totonac" => "tku", "Amoltepec Mixtec" => "mbz", "Lavukaleve" => "lvk", "Malaccan Creole Portuguese" => "mcm", "Newari" => "new", "Nanubae" => "afk", "Lanima" => "lnw", "Sadri" => "sck", "Klingon" => "tlh", "Sekele" => "vaj", "Vure" => "lkn", "Wanga" => "lwg", "Malo" => "mla", "Adasen" => "tiu", "Ngambay" => "sba", "Otank" => "uta", "Northern Luri" => "lrc", "Kurmukar" => "kfv", "Chemakum" => "xch", "Mbelime" => "mql", "Koro Wachi" => "bqv", "Rembarrnga" => "rmb", "Loup A" => "xlo", "Serrano" => "ser", "Gola" => "gol", "Marra" => "mec", "Aka-Bea" => "abj", "Esselen" => "esq", "Sorkhei" => "sqo", "Pumé" => "yae", "Assangori" => "sjg", "Middle Mongolian" => "xng", "Tinputz" => "tpz", "Nen" => "nqn", "Yelogu" => "ylg", "Makuri Naga" => "jmn", "Lalang Siny Seselwa" => "lsw", "Ejagham" => "etu", "Qila Muji" => "ymq", "Old Persian" => "peo", "Sene" => "sej", "Ndonga" => "ndo", "Kikai" => "kzg", "Arritinngithigh" => "rrt", "Tonjon" => "tjn", "Temacine Tamazight" => "tjo", "Tulai" => "tvi", "Wemale" => "weo", "Mehek" => "nux", "Swedish" => "swe", "Serbian" => "srp", "Gabi-Gabi" => "gbw", "Kalenjin" => "kln", "Liberian English" => "lir", "Cutchi-Swahili" => "ccl", "Ubykh" => "uby", "Gundungurra" => "xrd", "Kelo" => "xel", "Dorze" => "doz", "Khoibu Naga" => "nkb", "Retta" => "ret", "Buwal" => "bhs", "Extremaduran" => "ext", "Kachari" => "xac", "West Masela" => "mss", "Ngalakgan" => "nig", "Nyindu" => "nyg", "Plateau Malagasy" => "plt", "Andaqui" => "ana", "Kosraean" => "kos", "Khisa" => "kqm", "Swiss-German Sign Language" => "sgg", "Kaingang" => "kgp", "Urak Lawoi'" => "urk", "Loarki" => "lrk", "Võro" => "vro", "Wae Rana" => "wrx", "Rao" => "rao", "Quechua" => "que", "Tübatulabal" => "tub", "Narim" => "loh", "Chung" => "cnq", "Urdu" => "urd", "Kalabra" => "kzz", "Ghulfan" => "ghl", "Serui-Laut" => "seu", "Ona" => "ona", "Alur" => "alz", "Micmac" => "mic", "Pinji" => "pic", "Western Balochi" => "bgn", "Beothuk" => "bue", "Luri" => "ldd", "Temiar" => "tea", "Andalusian Arabic" => "xaa", "Purepecha" => "tsz", "Karey" => "kyd", "Ngbundu" => "nuu", "Nyankpa" => "yes", "Karipuna" => "kuq", "Koronadal Blaan" => "bpr", "Paiwan" => "pwn", "Dewoin" => "dee", "Kryts" => "kry", "Yom" => "pil", "Wardaman" => "wrr", "Nage" => "nxe", "Jita" => "jit", "Gogodala" => "ggw", "Wara" => "wbf", "Tanzanian Sign Language" => "tza", "Garus" => "gyb", "Malayo" => "mbp", "North Ndebele" => "nde", "Rangkas" => "rgk", "Cavineña" => "cav", "Nyong" => "muo", "Lopa" => "lop", "Aweer" => "bob", "Lewo" => "lww", "Toda" => "tcx", "Bugawac" => "buk", "Vili" => "vif", "Mandarin Chinese" => "cmn", "Central Huishui Miao" => "hmc", "Chinese Pidgin English" => "cpi", "Haruai" => "tmd", "Lewotobi" => "lwt", "ut-Hun" => "uth", "Angika" => "anp", "Guriaso" => "grx", "Riang" => "ril", "Mofu-Gudur" => "mif", "Mada" => "mxu", "Northern Paiute" => "pao", "Cebuano" => "ceb", "Murle" => "mur", "Yuhup" => "yab", "Duwai" => "dbp", "Southern Nambikuára" => "nab", "Sileibi" => "sbq", "Central Tagbanwa" => "tgt", "Sabine" => "sbv", "Khirwar" => "kwx", "Sindihui Mixtec" => "xts", "Aka-Kede" => "akx", "Eastern Muria" => "emu", "Kalam" => "kmh", "Kaeku" => "kkq", "Kura Ede Nago" => "nqk", "Lindu" => "klw", "Yendang" => "ynq", "Dakka" => "dkk", "Old Cham" => "ocm", "Phende" => "pem", "Southern Altai" => "alt", "Nkoroo" => "nkx", "Usku" => "ulf", "Gizrra" => "tof", "Libyan Arabic" => "ayl", "Southern Sotho" => "sot", "Iha Based Pidgin" => "ihb", "Chiangmai Sign Language" => "csd", "Tarao Naga" => "tro", "Low Saxon" => "nds", "Tsetsaut" => "txc", "Libon Bikol" => "lbl", "Georgian" => "kat", "China Buriat" => "bxu", "Madak" => "mmx", "Margu" => "mhg", "Somyev" => "kgt", "Duma" => "dma", "Lydian" => "xld", "Iatmul" => "ian", "Sumariup" => "siv", "Rufiji" => "rui", "Bantayanon" => "bfx", "Caluyanun" => "clu", "Aighon" => "aix", "Bondum Dom Dogon" => "dbu", "Migaama" => "mmy", "Pite Sami" => "sje", "Nigerian Pidgin" => "pcm", "Bumaji" => "byp", "Nyaneka" => "nyk", "Danaru" => "dnr", "Rempi" => "rmp", "Chara" => "cra", "Degexit'an" => "ing", "Riantana" => "ran", "Rang" => "rax", "Flinders Island" => "fln", "Kosadle" => "kiq", "Bushi" => "buc", "Mamasa" => "mqj", "Siberian Tatar" => "sty", "Basap" => "bdb", "Pagibete" => "pae", "Sika" => "ski", "Lepontic" => "xlp", "Ronga" => "rng", "Nǁng" => "ngh", "Namuyi" => "nmy", "Wolani" => "wod", "Abau" => "aau", "Dyarim" => "dyr", "Bete-Bendi" => "btt", "Manyawa" => "mny", "San Vicente Coatlán Zapotec" => "zpt", "Aeka" => "aez", "Iyo" => "nca", "Phu Thai" => "pht", "Ometepec Nahuatl" => "nht", "Tlachichilco Tepehua" => "tpt", "Pecheneg" => "xpc", "Atong" => "ato", "Oromo" => "orm", "Bayono" => "byl", "Israeli Sign Language" => "isr", "Bagvalal" => "kva", "Mangue" => "mom", "Awngi" => "awn", "Western Ojibwa" => "ojw", "Muluridyi" => "vmu", "Yaygir" => "xya", "Lamatuka" => "lmq", "Mao Naga" => "nbi", "Lahnda" => "lah", "Iteri" => "itr", "French Sign Language" => "fsl", "Nggwahyi" => "ngx", "Garza" => "xgr", "Saafi-Saafi" => "sav", "Makalero" => "mjb", "Mualang" => "mtd", "Kimbu" => "kiv", "Buol" => "blf", "Muinane" => "bmr", "Mudhili Gadaba" => "gau", "Baham" => "bdw", "Tawala" => "tbo", "Uduk" => "udu", "Birwa" => "brl", "Southern Yukaghir" => "yux", "Khandesi" => "khn", "Moken" => "mwt", "Siwi" => "siz", "Massalat" => "mdg", "Iwur" => "iwo", "Tenis" => "tns", "Ge" => "hmj", "Chuwabu" => "chw", "Yoba" => "yob", "Ekpeye" => "ekp", "Savi" => "sdg", "Wumeng Nasu" => "ywu", "Balinese" => "ban", "Kajali" => "xkj", "Nipsan" => "nps", "Ebughu" => "ebg", "Sininkere" => "skq", "Campalagian" => "cml", "Cofán" => "con", "Hmong Don" => "hmf", "Patwin" => "pwi", "Chinook jargon" => "chn", "Huautla Mazatec" => "mau", "Pogolo" => "poy", "Kofei" => "kpi", "Old Welsh" => "owl", "Sabanê" => "sae", "Amele" => "aey", "Dangaléat" => "daa", "Disa" => "dsi", "Fipa" => "fip", "Aghem" => "agq", "Mwera" => "mwe", "Ngadjunmaya" => "nju", "Serer" => "srr", "Southern Sama" => "ssb", "Bolondo" => "bzm", "Southern Bobo Madaré" => "bwq", "Turkmen" => "tuk", "Maek" => "hmk", "Shama-Sambuga" => "sqa", "Slovakian Sign Language" => "svk", "Bouni" => "suo", "Chhulung" => "cur", "Uhami" => "uha", "Wumboko" => "bqm", "Idaté" => "idt", "Mer" => "mnu", "Tindi" => "tin", "Hunsrik" => "hrx", "Moresada" => "msx", "Wolaitta" => "wal", "Wakabunga" => "wwb", "Nkoya" => "nka", "Aruek" => "aur", "Eteocretan" => "ecr", "Mirning" => "gmr", "Hamtai" => "hmt", "Ndau" => "ndc", "Wamey" => "cou", "Gula Iro" => "glj", "Mewari" => "mtr", "Sebat Bet Gurage" => "sgw", "Scottish Gaelic" => "gla", "Munsee" => "umu", "San Salvador Kongo" => "kwy", "Tulu-Bohuai" => "rak", "Nanga Dama Dogon" => "nzz", "Atohwaim" => "aqm", "Italian Sign Language" => "ise", "Lenca" => "len", "Cuba Sign Language" => "csf", "Önge" => "oon", "Nari Nari" => "rnr", "Mwali Comorian" => "wlc", "Matbat" => "xmt", "Lelak" => "llk", "Megleno Romanian" => "ruq", "Bhili" => "bhb", "Jju" => "kaj", "Alugu" => "aub", "Galibi Carib" => "car", "Yagua" => "yad", "Inga" => "inb", "Powhatan" => "pim", "Mawukakan" => "mxx", "Punjabi" => "pan", "Rakahanga-Manihiki" => "rkh", "Lengo" => "lgr", "Pankararé" => "pax", "Tedaga" => "tuq", "Mongo" => "lol", "Arem" => "aem", "Ninde" => "mwi", "Masmaje" => "mes", "North Asmat" => "nks", "Argobba" => "agj", "Mbongno" => "bgu", "Nyam" => "nmi", "San Agustín Mixtepec Zapotec" => "ztm", "Phai" => "prt", "Adamawa Fulfulde" => "fub", "Nigeria Mambila" => "mzk", "Dama" => "dmm", "Aklanon" => "akl", "Eastern Xwla Gbe" => "gbx", "East Tarangan" => "tre", "Firan" => "fir", "Koke" => "kou", "Archi" => "aqc", "Ulwa" => "ulw", "Lahanan" => "lhn", "Khmu" => "kjg", "Pa-Hng" => "pha", "Libido" => "liq", "Korubo" => "xor", "Southern Hindko" => "hnd", "Settla" => "sta", "Ocotlán Zapotec" => "zac", "Dghwede" => "dgh", "Neko" => "nej", "Nawathinehena" => "nwa", "Aikanã" => "tba", "Kibiri" => "prm", "Toro So Dogon" => "dts", "Seraiki" => "skr", "Tay Boi" => "tas", "Khasi" => "kha", "Betawi" => "bew", "Pulabu" => "pup", "Izere" => "izr", "Dumun" => "dui", "Pochuri Naga" => "npo", "Nanti" => "cox", "Tlazoyaltepec Mixtec" => "mqh", "Gibanawa" => "gib", "Haveke" => "hvk", "Mahou" => "mxx", "Tawoyan" => "twy", "Ayabadhu" => "ayd", "Jandai" => "jan", "Tboli" => "tbl", "Halang" => "hal", "Marshallese" => "mah", "Mango" => "mge", "Oy" => "oyb", "Wauyai" => "wuy", "Classical Nepal Bhasa" => "nwc", "Tilapa Otomi" => "otl", "Enga" => "enq", "Xanaguía Zapotec" => "ztg", "Bobongko" => "bgb", "Aimele" => "ail", "Bomboli" => "bml", "Busoa" => "bup", "Ixtayutla Mixtec" => "vmj", "Kayagar" => "kyt", "Lari" => "lrl", "Aimol" => "aim", "Yimchungru Naga" => "yim", "Digaro-Mishmi" => "mhu", "Tlacoapa Me'phaa" => "tpl", "Ghomara" => "gho", "Northern Tiwa" => "twf", "Kayupulau" => "kzu", "Nocte Naga" => "njb", "Nakanai" => "nak", "Roon" => "rnn", "Wiraféd" => "wir", "Pawaia" => "pwa", "Abidji" => "abi", "Chodri" => "cdi", "Northeast Kiwai" => "kiw", "Darlong" => "dln", "Thayore" => "thd", "Bondo" => "bfw", "Kushi" => "kuh", "Umiray Dumaget Agta" => "due", "Musey" => "mse", "Kemtuik" => "kmt", "Kpati" => "koc", "Eastern Qiandong Miao" => "hmq", "Nomlaki" => "nol", "Chinook" => "chh", "Duupa" => "dae", "Keapara" => "khz", "Aruamu" => "msy", "Xukurú" => "xoo", "Hinukh" => "gin", "Arequipa-La Unión Quechua" => "qxu", "Awadhi" => "awa", "Surubu" => "sde", "Oune" => "oue", "Northwestern Nisu" => "nsf", "Quetzaltepec Mixe" => "pxm", "Central Mnong" => "cmo", "Bangwinji" => "bsj", "Okobo" => "okb", "Gamale Kham" => "kgj", "Truká" => "tka", "Barro Negro Tunebo" => "tbn", "Ifè" => "ife", "Brithenig" => "bzt", "Timne" => "tem", "Borana-Arsi-Guji Oromo" => "gax", "Yongkom" => "yon", "Wutung" => "wut", "Western Cham" => "cja", "Lijili" => "mgi", "Southern Puget Sound Salish" => "slh", "Idon" => "idc", "Chiquihuitlán Mazatec" => "maq", "Tobanga" => "tng", "Nabi" => "mty", "Bongu" => "bpu", "San Luís Temalacayuca Popoloca" => "pps", "Igana" => "igg", "Biga" => "bhc", "Kendem" => "kvm", "Barababaraba" => "rbp", "Tenino" => "tqn", "Coahuilteco" => "xcw", "Cuyamecalco Mixtec" => "xtu", "Solos" => "sol", "North Tairora" => "tbg", "Goaria" => "gig", "Tofin Gbe" => "tfi", "Upper Ta'oih" => "tth", "Adnyamathanha" => "adt", "Mboko" => "mdu", "Urigina" => "urg", "Shamang" => "xsh", "Karawa" => "xrw", "North Awyu" => "yir", "Dolgan" => "dlg", "Bhilali" => "bhi", "Polari" => "pld", "Matipuhy" => "mzo", "Nunukul" => "xul", "Dhao" => "nfa", "Nsenga" => "nse", "Kaxuiâna" => "kbb", "Badimaya" => "bia", "Kare" => "kmf", "Hupla" => "hap", "Suarmin" => "seo", "Negerhollands" => "dcr", "Konai" => "kxw", "Chenoua" => "cnu", "Bhunjia" => "bhu", "Gula'alaa" => "gmb", "Batui" => "zbt", "Badaga" => "bfq", "Tepo Krumen" => "ted", "Chini" => "afi", "Nanticoke" => "nnt", "Moingi" => "mwz", "Iresim" => "ire", "Ombo" => "oml", "Kiunum" => "wei", "Ruching Palaung" => "pce", "Woccon" => "xwc", "Kilivila" => "kij", "Yuchi" => "yuc", "Krache" => "kye", "Mefele" => "mfj", "Kungarakany" => "ggk", "Mitla Zapotec" => "zaw", "Nafaanra" => "nfr", "Gichuka" => "cuh", "Cogui" => "kog", "Dominican Sign Language" => "doq", "Gundi" => "gdi", "Yosondúa Mixtec" => "mpm", "Southwestern Guiyang Hmong" => "hmg", "Munda" => "unx", "Nume" => "tgs", "Moro" => "mor", "Buginese" => "bug", "Muak Sa-aak" => "ukk", "Temascaltepec Nahuatl" => "nhv", "Arabic" => "ara", "Baima" => "bqh", "Nüpode Huitoto" => "hux", "Marba" => "mpg", "Ancient Zapotec" => "xzp", "Lamu-Lamu" => "lby", "Hema" => "nix", "Manangba" => "nmm", "Achuar-Shiwiar" => "acu", "Tondi Songway Kiini" => "tst", "Koko-Bera" => "kkp", "Culina" => "cul", "Hadiyya" => "hdy", "Suruí Do Pará" => "mdz", "Ngbinda" => "nbd", "Gbanziri" => "gbg", "Kajakse" => "ckq", "Spanish Sign Language" => "ssp", "Sian" => "spg", "Wardandi" => "wxw", "Djangu" => "dhg", "Lamkang" => "lmk", "Evenki" => "evn", "Latu" => "ltu", "Tu" => "mjg", "Saweru" => "swr", "Koba" => "kpd", "Jakalteko" => "jac", "Lambichhong" => "lmh", "Caac" => "msq", "Tolaki" => "lbw", "Romanian Sign Language" => "rms", "Skolt Sami" => "sms", "Orejón" => "ore", "Wayoró" => "wyr", "Paulohi" => "plh", "Forest Enets" => "enf", "Ndut" => "ndv", "Beng" => "nhb", "Makhuwa-Meetto" => "mgh", "Karajarri" => "gbd", "Rwa" => "rwk", "Tungag" => "lcm", "Hixkaryána" => "hix", "Papapana" => "ppn", "Olunyole" => "nyd", "Groma" => "gro", "Tembé" => "tqb", "Biseni" => "ije", "Kisar" => "kje", "Faita" => "faj", "Kla-Dan" => "lda", "Biri" => "bzr", "Mazatlán Mazatec" => "vmz", "Tuparí" => "tpr", "Godwari" => "gdx", "Baniwa" => "bwi", "Khwedam" => "xuu", "Ketangalan" => "kae", "Lo-Toga" => "lht", "Awbono" => "awh", "Ganang" => "gne", "Kua-nsi" => "ykn", "Ilwana" => "mlk", "Sandawe" => "sad", "Cubeo" => "cub", "Vera'a" => "vra", "Mangas" => "zns", "Marathi" => "mar", "Cahuarano" => "cah", "Varhadi-Nagpuri" => "vah", "Ikaranggal" => "ikr", "Türk İşaret Dili" => "tsm", "Kuranko" => "knk", "Rongpo" => "rnp", "Goemai" => "ank", "Mochi" => "old", "Ukwuani-Aboh-Ndoni" => "ukw", "Kaidipang" => "kzp", "Northern Kankanay" => "xnn", "Southwestern Dinka" => "dik", "Uzekwe" => "eze", "Lengua de señas catalana" => "csc", "Tirmaga-Chai Suri" => "suq", "Holiya" => "hoy", "Mantsi" => "nty", "Lauje" => "law", "Neapolitan" => "nap", "Besoa" => "bep", "Wakhi" => "wbl", "Mombo Dogon" => "dmb", "Belning" => "glb", "Yafi" => "wfg", "Eleme" => "elm", "Koyukon" => "koy", "Classical Quechua" => "qwc", "Kol" => "kol", "Dongolawi" => "dgl", "North Alaskan Inupiatun" => "esi", "Kajaman" => "kag", "La'bi" => "lbi", "Laiyolo" => "lji", "Guernésiais" => "nrf", "West Ambae" => "nnd", "Shau" => "sqh", "Haji" => "hji", "Carpathian Romani" => "rmc", "Sunum" => "ymn", "Esan" => "ish", "Chimborazo Highland Quichua" => "qug", "Pisabo" => "pig", "Teanu" => "tkw", "Gua" => "gwx", "Old Hungarian" => "ohu", "Tswa" => "tsc", "Arop-Sissano" => "aps", "Yauma" => "yax", "Mambae" => "mgm", "Papuma" => "ppm", "Konni" => "kma", "Central Masela" => "mxz", "Ngoni" => "xnq", "Paku Karen" => "jkp", "Kanite" => "kmu", "Araweté" => "awt", "Rema" => "bow", "Shihhi Arabic" => "ssh", "Manusela" => "wha", "Khlula" => "ykl", "Soi" => "soj", "Boma" => "boh", "Koalib" => "kib", "Rumu" => "klq", "Chipewyan" => "chp", "Bola" => "bnp", "Huaylas Ancash Quechua" => "qwh", "Langbashe" => "lna", "Baniva" => "bvv", "Cherokee" => "chr", "Ngaanyatjarra" => "ntj", "Mapudungun" => "arn", "Ganda" => "lug", "Ilue" => "ilv", "Baga Sobané" => "bsv", "Mwotlap" => "mlv", "Shanenawa" => "swo", "Yintale" => "kvy", "En" => "enc", "Yiningayi" => "ygi", "Mpur" => "akc", "Tai Ya" => "cuu", "Mangbutu" => "mdk", "Alagwa" => "wbj", "Keoru-Ahia" => "xeu", "Ido" => "ido", "Makolkol" => "zmh", "French" => "fra", "Safeyoka" => "apz", "As" => "asz", "Ninggerum" => "nxr", "Dilling" => "dil", "Wuvulu-Aua" => "wuv", "Mbukushu" => "mhw", "Moi" => "mxn", "Alu Kurumba" => "xua", "Monzombo" => "moj", "Hunnic" => "xhc", "Paleni" => "pnl", "Northern Haida" => "hdn", "Numèè" => "kdk", "Motlav" => "mlv", "Ronji" => "roe", "Eastern Xiangxi Miao" => "muq", "Puluwatese" => "puw", "Dayi" => "dax", "Surgujia" => "sgj", "Numana" => "nbr", "Jonkor Bourmataguil" => "jeu", "Kibala" => "blv", "Breri" => "brq", "Gengle" => "geg", "Eastern Highland Chatino" => "cly", "Kam" => "kdx", "Esperanto" => "epo", "Kamar" => "keq", "Yakama" => "yak", "Oirata" => "oia", "Dhaiso" => "dhs", "Southern Uzbek" => "uzs", "Ainu" => "ain", "Usila Chinantec" => "cuc", "Acheron" => "acz", "Central Mashan Hmong" => "hmm", "Chichonyi-Chidzihana-Chikauma" => "coh", "Katabaga" => "ktq", "Brahui" => "brh", "North Ambrym" => "mmg", "Vame" => "mlr", "Myene" => "mye", "Saaroa" => "sxr", "Arawum" => "awm", "Haigwai" => "hgw", "Old Breton" => "obt", "Likuba" => "kxx", "Bualkhaw Chin" => "cbl", "Kraol" => "rka", "Japanese Sign Language" => "jsl", "Tsotsitaal" => "fly", "Turumsa" => "tqm", "Angoram" => "aog", "Tetun Dili" => "tdt", "Teop" => "tio", "Nong Zhuang" => "zhn", "Wersing" => "kvw", "Lemnian" => "xle", "Maranunggu" => "zmr", "Tol" => "jic", "Bun" => "buv", "Mumuye" => "mzm", "Bella Coola" => "blc", "Fordata" => "frd", "Rmeet" => "lbn", "Mi'kmaq" => "mic", "Pangseng" => "pgs", "Eastern Kayah" => "eky", "Binongan Itneg" => "itb", "Nefamese" => "nef", "Ossetic" => "oss", "Patani" => "ptn", "Wawa" => "www", "Putukwam" => "afe", "Sirenik Yupik" => "ysr", "Aguaruna" => "agr", "Vanimo" => "vam", "Mburku" => "bbt", "Chiquián Ancash Quechua" => "qxa", "Ekajuk" => "eka", "Tringgus-Sembaan Bidayuh" => "trx", "Buruwai" => "asi", "Nyambo" => "now", "Efai" => "efa", "Rendille" => "rel", "Achumawi" => "acv", "Tira" => "tic", "Huachipaeri" => "hug", "Old Occitan" => "pro", "Nimbari" => "nmr", "Northeastern Pomo" => "pef", "Lou" => "loj", "Duau" => "dva", "Kete" => "kcv", "Arakwal" => "rkw", "Andi" => "ani", "Puma" => "pum", "Mycenaean Greek" => "gmy", "Kyak" => "bka", "Ati" => "atk", "East Damar" => "dmr", "Yagnobi" => "yai", "Kpan" => "kpk", "Dzùùngoo" => "dnn", "Marsian" => "ims", "Cheyenne" => "chy", "Southern Bontok" => "obk", "Bongo" => "bot", "Ika" => "ikk", "Central-Eastern Niger Fulfulde" => "fuq", "Naxi" => "nxq", "Notsi" => "ncf", "Ekari" => "ekg", "Hong Kong Sign Language" => "hks", "Agarabi" => "agd", "Southern Mashan Miao" => "hma", "Woods Cree" => "cwd", "Hre" => "hre", "Mombum" => "mso", "Bidhawal" => "ihw", "Tiang" => "tbj", "Hpon" => "hpo", "Kplang" => "kph", "Samba" => "smx", "Man Met" => "mml", "Kadaru" => "kdu", "Yug" => "yug", "Ulukwumi" => "ulb", "Cahuilla" => "chl", "North Moluccan Malay" => "max", "Erzya" => "myv", "Orya" => "ury", "Tilquiapan Zapotec" => "zts", "Wemba Wemba" => "xww", "Tachawit" => "shy", "Bamwe" => "bmg", "Paipai" => "ppi", "Tengger" => "tes", "Okpe" => "okx", "Southern Kalapuya" => "sxk", "Laua" => "luf", "Kim Mun" => "mji", "Dela-Oenale" => "row", "Kasiguranin" => "ksn", "Tsum" => "ttz", "Longto" => "wok", "Tondano" => "tdn", "Bardi" => "bcj", "Lingao" => "onb", "Lagwan" => "kot", "Ben Tey Dogon" => "dbt", "Babanki" => "bbk", "Tillamook" => "til", "Austral" => "aut", "Western Xwla Gbe" => "xwl", "Yagara" => "yxg", "Nagarchal" => "nbg", "Martuyhunira" => "vma", "Mina" => "hna", "Nungali" => "nug", "Minica Huitoto" => "hto", "Sediq" => "trv", "Mamusi" => "kdf", "Kaike" => "kzq", "Northwestern Dinka" => "diw", "Yankunytjatjara" => "kdd", "Shuswap" => "shs", "Tamazola Mixtec" => "vmx", "Yevanic" => "yej", "Qiubei Zhuang" => "zqe", "Eastern Oromo" => "hae", "Ngamini" => "nmv", "Limilngan" => "lmc", "Ligurian" => "xlg", "Pennsylvania German" => "pdc", "Balkan Romani" => "rmn", "Àhàn" => "ahn", "Lenje" => "leh", "Kikuyu" => "kik", "Sanaani Arabic" => "ayn", "Moraid" => "msg", "Biete" => "biu", "Bouna Kulango" => "nku", "Takelma" => "tkm", "Futuna-Aniwa" => "fut", "Kuo" => "xuo", "Piapoco" => "pio", "Tho" => "tou", "Iwal" => "kbm", "Geba Karen" => "kvq", "Danu" => "dnv", "Bhadrawahi" => "bhd", "Gangulu" => "gnl", "Pnar" => "pbv", "Ivatan" => "ivv", "Ogbia" => "ogb", "Levantine Arabic" => "apc", "Mufian" => "aoj", "Luna" => "luj", "Catalan Sign Language" => "csc", "Angor" => "agg", "Capiznon" => "cps", "Old Marathi" => "omr", "Odia" => "ory", "Parkwa" => "pbi", "Méa" => "cir", "Selayar" => "sly", "Waka" => "wav", "Isirawa" => "srl", "Ankave" => "aak", "Vono" => "kch", "Isinai" => "inn", "Goo" => "gov", "Tswapong" => "two", "Tosk Albanian" => "als", "Kango" => "kzy", "Daungwurrung" => "dgw", "Bolon" => "bof", "Fanagalo" => "fng", "Ikoma-Nata-Isenye" => "ntk", "Jamaican Creole English" => "jam", "Gourmanchéma" => "gux", "Parsi-Dari" => "prd", "Miriwoong Sign Language" => "rsm", "Chimakum" => "xch", "Pontic" => "pnt", "Mongolian Sign Language" => "msr", "Kukatja" => "kux", "Gawwada" => "gwd", "Xamtanga" => "xan", "Barikewa" => "jbk", "Aari" => "aiw", "Buli" => "uly", "Seri" => "sei", "Enggano" => "eno", "Mbugwe" => "mgz", "Wik-Keyangan" => "wif", "Ndaka" => "ndk", "Chenchu" => "cde", "Iraqw" => "irk", "Labo" => "mwi", "Lama" => "las", "Maraghei" => "vmh", "Phalura" => "phl", "Nasal" => "nsy", "Pahari-Potwari" => "phr", "Bayungu" => "bxj", "Persian Sign Language" => "psc", "Mangga Buang" => "mmo", "Southern Nisu" => "nsd", "Simbo" => "sbb", "Bhujel" => "byh", "Kabwa" => "cwa", "Luvale" => "lue", "Maranao" => "mrw", "Sagalla" => "tga", "Lemerig" => "lrz", "Da-Hua Miao" => "hmd", "Ngandi" => "nid", "Olrat" => "olr", "Susuami" => "ssu", "Queyu" => "qvy", "Mahongwe" => "mhb", "Phana'" => "phq", "Xetá" => "xet", "Amatlán Zapotec" => "zpo", "Barama" => "bbg", "Olumarama" => "lrm", "Kudu-Camo" => "kov", "Ayutla Mixtec" => "miy", "Valencian" => "cat", "Chrau" => "crw", "Jawoyn" => "djn", "Dhofari Arabic" => "adf", "Dungra Bhil" => "duh", "Psikye" => "kvj", "Sorsogon Ayta" => "ays", "Balaibalan" => "zba", "Yoke" => "yki", "Awutu" => "afu", "Loma" => "lom", "Chonyi-Dzihana-Kauma" => "coh", "Siraya" => "fos", "Klamath-Modoc" => "kla", "Larevat" => "lrv", "Eastern Bru" => "bru", "Mongol" => "mgt", "Alngith" => "aid", "I-Wak" => "iwk", "Banda-Ndélé" => "bfl", "Mossi" => "mos", "Peruvian Sign Language" => "prl", "Lelemi" => "lef", "Khamba" => "kbg", "Laarim" => "loh", "Nimi" => "nis", "Ampari Dogon" => "aqd", "Mba" => "mfc", "Chorasmian" => "xco", "Ambai" => "amk", "Tulishi" => "tey", "Keiyo" => "eyo", "Tohono O'odham" => "ood", "Akaselem" => "aks", "Are" => "mwc", "Faroese" => "fao", "Hmong Njua" => "hnj", "Taino" => "tnq", "Kayaw" => "kvl", "Komering" => "kge", "Southern Aymara" => "ayc", "Nusa Laut" => "nul", "Mariyedi" => "zmy", "Czech Sign Language" => "cse", "Fe'fe'" => "fmp", "Krikati-Timbira" => "xri", "Hawaiian" => "haw", "Yao" => "yao", "Rohingya" => "rhg", "Wolof" => "wol", "Tetelcingo Nahuatl" => "nhg", "Naami" => "bzv", "Chavacano" => "cbk", "Anindilyakwa" => "aoi", "Okanagan" => "oka", "Uni" => "uni", "Northeast Pashai" => "aee", "Takua" => "tkz", "Kais" => "kzm", "Doga" => "dgg", "Karankawa" => "zkk", "Kalabari" => "ijn", "Kensiu" => "kns", "Khowar" => "khw", "Pande" => "bkj", "Pele-Ata" => "ata", "Northern Pinghua" => "cnp", "Tày Sa Pa" => "tys", "Khamnigan Mongol" => "ykh", "Uripiv-Wala-Rano-Atchin" => "upv", "Norra" => "nrr", "Madurese" => "mad", "Anglo-Norman" => "xno", "Atzingo Matlatzinca" => "ocu", "Parkari Koli" => "kvx", "Laitu Chin" => "clj", "Gafat" => "gft", "Kwamera" => "tnk", "Nakame" => "nib", "Tornedalen Finnish" => "fit", "Nauete" => "nxa", "Lower Burdekin" => "xbb", "Teribe" => "tfr", "Lamja-Dengsa-Tola" => "ldh", "East Masela" => "vme", "Bogaya" => "boq", "Lukpa" => "dop", "O'chi'chi'" => "xoc", "Suba-Simbiti" => "ssc", "Bidyogo" => "bjg", "Domung" => "dev", "Dawik Kui" => "dwk", "Gusan" => "gsn", "Ngile" => "jle", "Olulumo-Ikom" => "iko", "Northern Tlaxiaco Mixtec" => "xtn", "Col" => "liw", "Sila" => "slt", "Cineni" => "cie", "Athpariya" => "aph", "Pampanga" => "pam", "Uruguayan Sign Language" => "ugy", "Wichí Lhamtés Vejoz" => "wlv", "Dhatki" => "mki", "Balaesang" => "bls", "Ogbogolo" => "ogg", "Punan Aput" => "pud", "Mullu Kurumba" => "kpb", "Tawr Chin" => "tcp", "Malua Bay" => "mll", "Djiwarli" => "dze", "Biali" => "beh", "Far Western Muria" => "fmu", "Telugu" => "tel", "Antakarinya" => "ant", "Karachay-Balkar" => "krc", "Tupinambá" => "tpn", "Wakoná" => "waf", "Osage" => "osa", "Chesu" => "ych", "Nali" => "nss", "Crow" => "cro", "Northeastern Tasmanian" => "xpb", "Nkhumbi" => "khu", "Yela" => "yel", "Lezghian" => "lez", "Bafia" => "ksf", "Fas" => "fqs", "Kpeego" => "cpo", "Tutelo" => "tta", "Lika" => "lik", "Tiene" => "tii", "Narungga" => "nnr", "Kachin" => "kac", "Badjiri" => "jbi", "Basa-Gumna" => "bsl", "Nêlêmwa-Nixumwak" => "nee", "Indo-Portuguese" => "idb", "Mudburra" => "dmw", "Rayón Zoque" => "zor", "Hutterisch" => "geh", "Kabuverdianu" => "kea", "Somrai" => "sor", "Jebero" => "jeb", "Dezfuli" => "def", "Middle Breton" => "xbm", "Armenian" => "hye", "Bile" => "bil", "Tepeuxila Cuicatec" => "cux", "Huichol" => "hch", "Burmese" => "mya", "Fanamaket" => "bjp", "Suruí" => "sru", "Gambian Wolof" => "wof", "Vestinian" => "xvs", "Efe" => "efe", "Wadi Wadi" => "xwd", "Ndra'ngith" => "dgt", "Chadian Sign Language" => "cds", "Mulam" => "mlm", "Fuyug" => "fuy", "Plains Cree" => "crk", "Etulo" => "utr", "Wadjabangayi" => "wdy", "Suwawa" => "swu", "War-Jaintia" => "aml", "Sarangani Blaan" => "bps", "Hoia Hoia" => "hhi", "Agoi" => "ibm", "Jamiltepec Mixtec" => "mxt", "Pallanganmiddang" => "pmd", "Cabécar" => "cjp", "Antikarinya" => "ant", "Gban" => "ggu", "Ngundi" => "ndn", "Samarokena" => "tmj", "Tumi" => "kku", "Pará Arára" => "aap", "Sori-Harengan" => "sbh", "Okolod" => "kqv", "Logudorese Sardinian" => "src", "Northeastern Dinka" => "dip", "Apali" => "ena", "Lewo Eleng" => "lwe", "Peripheral Mongolian" => "mvf", "Mangerr" => "zme", "Berta" => "wti", "Piame" => "pin", "Kurichiya" => "kfh", "Havu" => "hav", "Denya" => "anv", "Bomu" => "bmq", "Maragus" => "mrs", "Central Pame" => "pbs", "Bouyei" => "pcc", "Safwa" => "sbk", "Vinmavis" => "vnm", "Majhwar" => "mmj", "Sabaean" => "xsa", "Ma'anyan" => "mhy", "Gbayi" => "gyg", "Eteocypriot" => "ecy", "Saep" => "spd", "Lumun" => "lmd", "Tewa" => "twe", "Punic" => "xpu", "Liuqian Zhuang" => "zlq", "Quiotepec Chinantec" => "chq", "Cañar Highland Quichua" => "qxr", "North Tanna" => "tnn", "Tajuasohn" => "tja", "Ladino" => "lad", "Tsuvan" => "tsh", "Biafada" => "bif", "Lomwe" => "ngl", "Mbesa" => "zms", "Lower Grand Valley Dani" => "dni", "Keak" => "keh", "Kangean" => "kkv", "West Makian" => "mqs", "Nandi" => "niq", "Yoron" => "yox", "Turkana" => "tuv", "Tehuelche" => "teh", "Talieng" => "tdf", "Kutu" => "kdc", "Dugun" => "ndu", "Lotud" => "dtr", "Bade" => "bde", "Sause" => "sao", "Dampelas" => "dms", "Kâte" => "kmg", "Komi-Zyrian" => "kpv", "Kaonde" => "kqn", "Sengele" => "szg", "Sanie" => "ysy", "Ashe" => "ahs", "Zialo" => "zil", "Kiowa" => "kio", "Baluchi" => "bal", "Tonkawa" => "tqw", "Garre" => "gex", "Hawai'i Pidgin Sign Language" => "hps", "Kis" => "kis", "Moo" => "gwg", "Mbangala" => "mxg", "Teso" => "teo", "Not applicable" => "zxx", "Bolango" => "bld", "Dzando" => "dzn", "Giyug" => "giy", "Para Naga" => "pzn", "Bwanabwana" => "tte", "Old Malay" => "omy", "Spiti Bhoti" => "spt", "Ao Naga" => "njo", "Hanga" => "hag", "Pana" => "pnz", "Kwanja" => "knp", "Moldovan" => "ron", "Ma Manda" => "skc", "Njalgulgule" => "njl", "Benamanga" => "egm", "Manipa" => "mqp", "Sogdian" => "sog", "Tampuan" => "tpu", "Wolio" => "wlo", "Ojitlán Chinantec" => "chj", "Grenadian Creole English" => "gcl", "Migum" => "klm", "Cochimi" => "coj", "Gyele" => "gyi", "Tuscarora" => "tus", "Pam" => "pmn", "Pech" => "pay", "Chepya" => "ycp", "Gudanji" => "nji", "Livvi" => "olo", "Koi" => "kkt", "Venetian" => "vec", "Opao" => "opo", "Columbia-Wenatchi" => "col", "Arapaho" => "arp", "Mixtepec Zapotec" => "zpm", "Neku" => "nek", "Guinea Kpelle" => "gkp", "Pidgin Delaware" => "dep", "Nokuku" => "nkk", "Ngiemboon" => "nnh", "Paekche" => "pkc", "Daonda" => "dnd", "Malayalam" => "mal", "Ding" => "diz", "Urubú-Kaapor" => "urb", "Mwan" => "moa", "Chidigo" => "dig", "Italian" => "ita", "Muthuvan" => "muv", "Comanche" => "com", "Tremembé" => "tme", "Sekak" => "lce", "Jowulu" => "jow", "Sakan" => "kho", "Ambala Ayta" => "abc", "Lemolang" => "ley", "Pangu" => "png", "Semaq Beri" => "szc", "Kuturmi" => "khj", "Afro-Seminole Creole" => "afs", "Wom" => "wom", "Waris" => "wrs", "Tai Do" => "tyj", "Noone" => "nhu", "Port Vato" => "ptv", "Angguruk Yali" => "yli", "Fortsenal" => "frt", "Baatonum" => "bba", "Majukayang Kalinga" => "kmd", "Niellim" => "nie", "Azoyú Me'phaa" => "tpc", "Mabaan" => "mfz", "Ardhamāgadhī Prākrit" => "pka", "Thulung" => "tdh", "Maldivian" => "div", "Songe" => "sop", "Dar Fur Daju" => "daj", "Leyigha" => "ayi", "Tring" => "tgq", "Vitu" => "wiv", "Zokhuo" => "yzk", "Rapting" => "rpt", "Omani Arabic" => "acx", "Gende" => "gaf", "Matigsalug Manobo" => "mbt", "Lowland Tarahumara" => "tac", "Magdalena Peñasco Mixtec" => "xtm", "Aranadan" => "aaf", "Kabyle" => "kab", "Mwaghavul" => "sur", "Northwestern Ojibwa" => "ojb", "Mehináku" => "mmh", "Kiliwa" => "klb", "Tabaru" => "tby", "Helong" => "heg", "Kwang" => "kvi", "Votic" => "vot", "Kekchí" => "kek", "Pokangá" => "pok", "Kohumono" => "bcs", "Podena" => "pdn", "Mpiemo" => "mcx", "Eastern Minyag" => "emq", "Anaang" => "anw", "Dori'o" => "dor", "Miriwoong" => "mep", "Duri" => "mvp", "Puerto Rican Sign Language" => "psl", "Pwo Western Karen" => "pwo", "Kurukh" => "kru", "Sempan" => "xse", "Texmelucan Zapotec" => "zpz", "Penchal" => "pek", "Vietnamese" => "vie", "North Slavey" => "scs", "Lepki" => "lpe", "Cusco Quechua" => "quz", "Pass Valley Yali" => "yac", "Northern Ohlone" => "cst", "Sop" => "urw", "Lame" => "bma", "Samba Daka" => "ccg", "Eastern Khumi Chin" => "cek", "Dogul Dom Dogon" => "dbg", "Toku-No-Shima" => "tkn", "Puelche" => "pue", "Akeu" => "aeu", "Leelau" => "ldk", "Maridan" => "zmd", "Laurentian" => "lre", "Anem" => "anz", "Juquila Mixe" => "mxq", "Takia" => "tbc", "Waritai" => "wbe", "Ila" => "ilb", "Menya" => "mcr", "Aekyom" => "awi", "Gade Lohar" => "gda", "Jaqaru" => "jqr", "Repanbitip" => "rpn", "Tyaraity" => "woa", "Manza" => "mzv", "Nalu" => "naj", "Western Lalu" => "ywl", "Michoacán Nahuatl" => "ncl", "Marti Ke" => "zmg", "West-Central Limba" => "lia", "Arutani" => "atx", "Kafoa" => "kpu", "Balo" => "bqo", "Ömie" => "aom", "Mbe'" => "mtk", "Bassari" => "bsc", "Minaean" => "inm", "Juxtlahuaca Mixtec" => "vmc", "Kayeli" => "kzl", "Tzotzil" => "tzo", "Ngandyera" => "nne", "Carolina Algonquian" => "crr", "Godié" => "god", "Santa Ana de Tusi Pasco Quechua" => "qxt", "Tomoip" => "tqp", "Laghuu" => "lgh", "Njerep" => "njr", "Dadi Dadi" => "dda", "Turkish" => "tur", "Uvbie" => "evh", "Muyang" => "muy", "Maasina Fulfulde" => "ffm", "Matís" => "mpq", "Ga'dang" => "gdg", "Khamyang" => "ksu", "Puoc" => "puo", "Iduna" => "viv", "Alamblak" => "amp", "Kapori" => "khp", "Nemi" => "nem", "Miju-Mishmi" => "mxj", "Mara Chin" => "mrh", "Kuni-Boazi" => "kvg", "Tanahmerah" => "tcm", "Tsotso" => "lto", "Ufim" => "ufi", "Chinese" => "zho", "Oruma" => "orr", "Twents" => "twd", "Dii" => "dur", "Yaul" => "yla", "Rumai Palaung" => "rbb", "Karipúna Creole French" => "kmv", "Occitan" => "oci", "Sauria Paharia" => "mjt", "Enrekang" => "ptt", "Kimki" => "sbt", "Wintu" => "wnw", "Kpessi" => "kef", "Olusamia" => "lsm", "Muzi" => "ymz", "Saam" => "raq", "Niwer Mil" => "hrc", "Dibabawon Manobo" => "mbd", "Emae" => "mmw", "Loja Highland Quichua" => "qvj", "Jandavra" => "jnd", "Ishkashimi" => "isk", "West Tarangan" => "txn", "Bhele" => "bhy", "Slave" => "den", "Mala Malasar" => "ima", "Matepi" => "mqe", "Mokerang" => "mft", "Burushaski" => "bsk", "Apinayé" => "apn", "Prussian" => "prg", "Paliyan" => "pcf", "Sou Nama" => "tlt", "Bahau" => "bhv", "Muruwari" => "zmu", "Achinese" => "ace", "Gwak" => "jgk", "Warumungu" => "wrm", "Jamsay Dogon" => "djm", "Sani" => "ysn", "Chimalapa Zoque" => "zoh", "Kanauji" => "bjj", "Yucatec Maya" => "yua", "Ogbah" => "ogc", "Agusan Manobo" => "msm", "Uruava" => "urv", "Usarufa" => "usa", "Berti" => "byt", "Galambu" => "glo", "Ansus" => "and", "Tainae" => "ago", "Pattani" => "lae", "Northern Sierra Miwok" => "nsq", "Malagasy" => "mlg", "Ngulu" => "ngp", "Gamo-Ningi" => "bte", "Nahari" => "nhh", "Enu" => "enu", "Kamara" => "jmr", "Bharia" => "bha", "Ma'ya" => "slz", "Hani" => "hni", "Old Spanish" => "osp", "West Uvean" => "uve", "Busuu" => "bju", "Yambes" => "ymb", "Lopi" => "lov", "Miahuatlán Zapotec" => "zam", "Paranan" => "prf", "Liujiang Zhuang" => "zlj", "Desano" => "des", "Balangingi" => "sse", "Khoekhoe" => "naq", "Sekar" => "skz", "Edo" => "bin", "Panasuan" => "psn", "Amganad Ifugao" => "ifa", "Jalapa De Díaz Mazatec" => "maj", "Swiss German" => "gsw", "Leipon" => "lek", "Gofa" => "gof", "Portuguese Sign Language" => "psr", "Isekiri" => "its", "Buraka" => "bkg", "Ukpet-Ehom" => "akd", "Iceve-Maci" => "bec", "Spokane" => "spo", "Bagirmi Fulfulde" => "fui", "Lenakel" => "tnl", "Haitian" => "hat", "Tijaltepec Mixtec" => "xtl", "Pannei" => "pnc", "Ewe" => "ewe", "Warluwara" => "wrb", "Yanyuwa" => "jao", "Gaam" => "tbi", "Rerep" => "pgk", "Bulu" => "bum", "Hmong" => "hmn", "Mlabri" => "mra", "Sehwi" => "sfw", "Guduf-Gava" => "gdf", "Kaibobo" => "kzb", "Temein" => "teq", "Standard Arabic" => "arb", "Horned Miao" => "hrm", "Mocho" => "mhc", "Picard" => "pcd", "Whitesands" => "tnp", "Kusaghe" => "ksg", "Doondo" => "dde", "Kofa" => "kso", "Lengua de señas Albarradas" => "lsc", "Tai Long" => "thi", "Marrucinian" => "umc", "Port Sorell Tasmanian" => "xpl", "sTodsde" => "jih", "Kholok" => "ktc", "Taungyo" => "tco", "Hozo" => "hoz", "Zumbun" => "jmb", "Balkan Gagauz Turkish" => "bgx", "Kachi Koli" => "gjk", "Hieroglyphic Luwian" => "hlu", "Puroik" => "suv", "Yorta Yorta" => "xyy", "Bullom So" => "buy", "Yareba" => "yrb", "Pengo" => "peg", "Gowli" => "gok", "Ipiko" => "ipo", "Ani Phowa" => "ypn", "Mündü" => "muh", "Kathu" => "ykt", "Sa'och" => "scq", "Yocoboué Dida" => "gud", "Mauwake" => "mhl", "Chakavian" => "ckm", "Makhuwa-Moniga" => "mhm", "Ugong" => "ugo", "Momuna" => "mqf", "Kotava" => "avk", "Ihievbe" => "ihi", "Lambya" => "lai", "Lala-Bisa" => "leb", "Yong" => "yno", "Buhi'non Bikol" => "ubl", "Hulaulá" => "huy", "Southern Birifor" => "biv", "Kereho" => "xke", "Navut" => "nsw", "Dzao Min" => "bpn", "Northern Pumi" => "pmi", "Shall-Zwall" => "sha", "Igbo" => "ibo", "Rahambuu" => "raz", "Eastern Maninkakan" => "emk", "Amundava" => "adw", "Antigua and Barbuda Creole English" => "aig", "Bakwé" => "bjw", "Kusu" => "ksv", "Amio-Gelimi" => "let", "Ndombe" => "ndq", "Pekal" => "pel", "Lianshan Zhuang" => "zln", "Suma" => "sqm", "Anor" => "anj", "Huba" => "hbb", "Kariya" => "kil", "Paraujano" => "pbg", "Udihe" => "ude", "Moklen" => "mkm", "Old English" => "ang", "Michoacán Mazahua" => "mmc", "Oksapmin" => "opm", "Sursurunga" => "sgz", "Ukhwejo" => "ukh", "Nake" => "nbk", "Soninke" => "snk", "Afitti" => "aft", "Tagabawa" => "bgs", "Northeast Pashayi" => "aee", "Kwer" => "kwr", "Wares" => "wai", "Ipili" => "ipi", "Ofayé" => "opy", "Mamvu" => "mdi", "Termanu" => "twu", "Traveller Scottish" => "trl", "A-hmaos" => "hmd", "Sabüm" => "sbo", "Moldova Sign Language" => "vsi", "Emerillon" => "eme", "Kakwa" => "keo", "Sugut Dusun" => "kzs", "Trinidad and Tobago Sign Language" => "lst", "Lundayeh" => "lnd", "Gela" => "nlg", "Ata Manobo" => "atd", "Kpagua" => "kuw", "Arvanitika Albanian" => "aat", "Dobu" => "dob", "Ngbee" => "jgb", "Keder" => "kdy", "Kanasi" => "soq", "Northern Tujia" => "tji", "Oluwanga" => "lwg", "Ancient Hebrew" => "hbo", "Jinyu Chinese" => "cjy", "Kamayo" => "kyk", "Mori Bawah" => "xmz", "Classical Tibetan" => "xct", "Farefare" => "gur", "Ket" => "ket", "Blissymbolics" => "zbl", "Chiapanec" => "cip", "Nukak Makú" => "mbr", "Middle English" => "enm", "Central Aymara" => "ayr", "Ososo" => "oso", "Mbule" => "mlb", "Paloor" => "fap", "Yuwana" => "yau", "Kemberano" => "bzp", "Comox" => "coo", "Mulao" => "giu", "Bo-Rukul" => "mae", "Dũya" => "ldb", "Bilaspuri" => "kfs", "Dineor" => "mrx", "Mouk-Aria" => "mwh", "Ancient Greek" => "grc", "Kohistani Shina" => "plk", "Moose Cree" => "crm", "Eastern Mari" => "mhr", "Krisa" => "ksi", "Tiyaa" => "tyy", "Mushungulu" => "xma", "West Yugur" => "ybe", "Kuruáya" => "kyr", "Tarok" => "yer", "Jina" => "jia", "Molale" => "mbe", "Riang Lai" => "yin", "Yuyu" => "yxu", "Lote" => "uvl", "Fore" => "for", "Algerian Saharan Arabic" => "aao", "Duruwa" => "pci", "Shwe Palaung" => "pll", "Airoran" => "air", "Vaiphei" => "vap", "Burate" => "bti", "Baygo" => "byg", "West Bengal Sign Language" => "wbs", "Anasi" => "bpo", "Tomo Kan Dogon" => "dtm", "Sie" => "erg", "Semimi" => "etz", "Inuktitut" => "iku", "Dhuwal" => "dwu", "Rongmei Naga" => "nbu", "Sabaot" => "spy", "Wurrugu" => "wur", "Anyin Morofo" => "mtb", "Trimuris" => "tip", "Lavi" => "lvi", "Ningera" => "nby", "Ukuriguma" => "ukg", "Morerebi" => "xmo", "Karko" => "kko", "Gurdjar" => "gdj", "Sota Kanum" => "krz", "Kinyarwanda" => "kin", "Ndyuka-Trio Pidgin" => "njt", "Zigula" => "ziw", "Kamasa" => "klp", "Ottoman Turkish" => "ota", "Manyika" => "mxc", "Yemsa" => "jnj", "Aka-Kora" => "ack", "Boano" => "bzn", "American Sign Language" => "ase", "Busami" => "bsm", "Urubú-Kaapor Sign Language" => "uks", "Bliss" => "zbl", "Kumzari" => "zum", "Welsh Romani" => "rmw", "Nyangga" => "nny", "Ternateño" => "tmg", "Sranan Tongo" => "srn", "Teme" => "tdo", "Oya'oya" => "oyy", "Bakaka" => "bqz", "Dar Daju Daju" => "djc", "Dadiya" => "dbd", "Albarradas Sign Language" => "lsc", "Naaba" => "nao", "Ratagnon" => "btn", "Konomala" => "koa", "Joba" => "job", "Muskum" => "mje", "Kela" => "kel", "Mpi" => "mpz", "Sansi" => "ssi", "Korana" => "kqz", "Seke" => "skj", "Puri" => "prr", "Beaver" => "bea", "Cameroon Pidgin" => "wes", "Daai Chin" => "dao", "Tonsawang" => "tnw", "Banggarla" => "bjb", "Yardliyawarra" => "yxl", "Yiddish" => "yid", "Maeng Itneg" => "itt", "Majang" => "mpe", "Tawandê" => "xtw", "Talinga-Bwisi" => "tlj", "Northern Catanduanes Bikol" => "cts", "Mezontla Popoloca" => "pbe", "Kaimbulawa" => "zka", "Tatuyo" => "tav", "Cherepon" => "cpn", "Koy Sanjaq Surat" => "kqd", "Horo" => "hor", "Stod Bhoti" => "sbu", "Sharwa" => "swq", "Toram" => "trj", "Obispeño" => "obi", "Ong" => "oog", "Tem" => "kdh", "Lamenu" => "lmu", "Old Newari" => "nwc", "Ventureño" => "veo", "Atemble" => "ate", "Tumtum" => "tbr", "Viemo" => "vig", "Kunbarlang" => "wlg", "Tena Lowland Quichua" => "quw", "Bure" => "bvh", "Moyon Naga" => "nmo", "Puyo-Paekche" => "xpp", "Ibu" => "ibu", "Anguthimri" => "awg", "Tunggare" => "trt", "Southeast Babar" => "vbb", "Nedebang" => "nec", "Dimli" => "zza", "Businenge Tongo" => "djk", "Aka-Bo" => "akm", "Middle Cornish" => "cnx", "Mbula" => "mna", "Safaliba" => "saf", "Dair" => "drb", "Arammba" => "stk", "Friulian" => "fur", "Sapuan" => "spu", "Memoni" => "mby", "Mohegan-Pequot" => "xpq", "Neo" => "neu", "Boselewa" => "bwf", "Lish" => "lsh", "Lisela" => "lcl", "Tagargrent" => "oua", "Faifi" => "fif", "Kwini" => "gww", "Southern Dong" => "kmc", "Wyandot" => "wyn", "Western Apache" => "apw", "Bankon" => "abb", "Bafut" => "bfd", "Jurchen" => "juc", "Kaqchikel" => "cak", "Gaddi" => "gbk", "Ribun" => "rir", "Phrygian" => "xpg", "Fagani" => "faf", "Najdi Arabic" => "ars", "Northern Khmer" => "kxm", "Bonerate" => "bna", "Itundujia Mixtec" => "mce", "Tangkhul Naga" => "ntx", "Avestan" => "ave", "Egyptian" => "egy", "Laura" => "lur", "Old Frisian" => "ofs", "Tacana" => "tna", "Brao" => "brb", "Camtho" => "cmt", "Southwest Gbaya" => "gso", "Mundurukú" => "myu", "Standard Estonian" => "ekk", "Tandroy-Mahafaly Malagasy" => "tdx", "Tombelala" => "ttp", "Bonerif" => "bnv", "Tokelau" => "tkl", "Taivoan" => "tvx", "Blafe" => "bfh", "Juwal" => "mwb", "Bintauna" => "bne", "Gothic" => "got", "Sierra de Juárez Zapotec" => "zaa", "Plains Miwok" => "pmw", "Romano-Greek" => "rge", "Burusu" => "bqr", "Turiwára" => "twt", "Hitu" => "htu", "Tuki" => "bag", "Dom" => "doa", "Láadan" => "ldn", "Tsakonian" => "tsd", "Norwegian Nynorsk" => "nno", "Songomeno" => "soe", "Mal Paharia" => "mkb", "Zaghawa" => "zag", "Mwani" => "wmw", "Makyan Naga" => "umn", "Caló" => "rmq", "Biak" => "bhw", "Hoyahoya" => "hhy", "Kwadi" => "kwz", "Molo" => "zmo", "Uspanteco" => "usp", "Ofo" => "ofo", "Abureni" => "mgj", "Upper Guinea Crioulo" => "pov", "Khinalugh" => "kjj", "Gugu Warra" => "wrw", "Upper Kuskokwim" => "kuu", "Tregami" => "trm", "Seediq" => "trv", "Bangingih Sama" => "sse", "Sarasira" => "zsa", "Karirí-Xocó" => "kzw", "Jauja Wanca Quechua" => "qxw", "Kisa" => "lks", "Konkani" => "kok", "Salasaca Highland Quichua" => "qxl", "Inpui Naga" => "nkf", "Bassa-Kontagora" => "bsr", "Taulil" => "tuh", "Hlersu" => "hle", "Awu" => "yiu", "Bolo" => "blv", "Tereno" => "ter", "Gorowa" => "gow", "Malas" => "mkr", "Zangwal" => "zah", "Armenian Sign Language" => "aen", "Cacua" => "cbv", "Tanggu" => "tgu", "Western Huasteca Nahuatl" => "nhw", "Zan Gula" => "zna", "Chiltepec Chinantec" => "csa", "Tapei" => "afp", "Northwest Oaxaca Mixtec" => "mxa", "Yurok" => "yur", "Ndrulo" => "dno", "Mongondow" => "mog", "Deg" => "mzw", "Tabassaran" => "tab", "Botolan Sambal" => "sbl", "Chiquitano" => "cax", "Juǀʼhoansi" => "ktz", "Moma" => "myl", "Yekhee" => "ets", "Walak" => "wlw", "Cao Lan" => "mlc", "Bodo" => "brx", "Lak" => "lbe", "Singpho" => "sgp", "Haisla" => "has", "Southern Roglai" => "rgs", "Jenaama Bozo" => "bze", "Talise" => "tlr", "Adara" => "kad", "Tsaukambo" => "kvz", "Urum" => "uum", "Biem" => "bmc", "Asuri" => "asr", "Southern Dagaare" => "dga", "Konda-Dora" => "kfc", "Vaghua" => "tva", "Baissa Fali" => "fah", "Southern Bai" => "bfs", "Guibei Zhuang" => "zgb", "Standard Malay" => "zsm", "Nding" => "eli", "Pumpokol" => "xpm", "Alo Phola" => "ypo", "Venda" => "ven", "Kur" => "kuv", "Western Mari" => "mrj", "Wiru" => "wiu", "Adzera" => "adz", "Remun" => "lkj", "ǀXam" => "xam", "Sapé" => "spc", "Ibanag" => "ibg", "Li'o" => "ljl", "Nias" => "nia", "Mashco Piro" => "cuj", "Welsh" => "cym", "Mong" => "hmn", "Noipx" => "npx", "Ngarla" => "nrk", "Gorap" => "goq", "Kehu" => "khh", "Malaryan" => "mjq", "Nottoway-Meherrin" => "nwy", "Bomitaba" => "zmx", "Qashqa'i" => "qxq", "Yang Zhuang" => "zyg", "Umbrian" => "xum", "Nayi" => "noz", "Middle Dutch" => "dum", "Puare" => "pux", "Monom" => "moo", "Miltu" => "mlj", "Gane" => "gzn", "Matal" => "mfh", "Southern Sierra Miwok" => "skd", "Mukulu" => "moz", "Borgu Fulfulde" => "fue", "Mahasu Pahari" => "bfz", "Yakut" => "sah", "Umbu-Ungu" => "ubu", "Samoan" => "smo", "Kadung" => "dkg", "Label" => "lbb", "Anus" => "auq", "Esuma" => "esm", "Margos-Yarowilca-Lauricocha Quechua" => "qvm", "Jimi" => "jmi", "Sulka" => "sua", "Zimakani" => "zik", "San Juan Guelavía Zapotec" => "zab", "Batak Dairi" => "btd", "Martu Wangka" => "mpj", "Santiago Xanica Zapotec" => "zpr", "Naki" => "mff", "Kwami" => "ktf", "Literary Chinese" => "lzh", "Mato" => "met", "Eastern Tawbuid" => "bnj", "Northwest Gbaya" => "gya", "Veluws" => "vel", "Xingú Asuriní" => "asn", "Oneida" => "one", "Wappo" => "wao", "Andaandi" => "dgl", "Delo" => "ntr", "Katbol" => "tmb", "Yaweyuha" => "yby", "Kwamtim One" => "okk", "Alsatian" => "gsw", "Gawar-Bati" => "gwt", "Laka" => "lap", "Nde-Nsele-Nta" => "ndd", "Aribwatsa" => "laz", "Nnam" => "nbp", "Umbundu" => "umb", "Chuvash" => "chv", "Bambassi" => "myf", "Northern Pame" => "pmq", "Providencia Sign Language" => "prz", "Tesaka Malagasy" => "tkg", "Vwanji" => "wbi", "Dhalandji" => "dhl", "Panjabi" => "pan", "Jemez" => "tow", "Panytyima" => "pnw", "Haruku" => "hrk", "Walla Walla" => "waa", "Siona" => "snn", "Yanda" => "yda", "Waffa" => "waj", "Ake" => "aik", "Dholuo" => "luo", "Fyam" => "pym", "Kara" => "zra", "Kachama-Ganjule" => "kcx", "Ancient North Arabian" => "xna", "Yongnan Zhuang" => "zyn", "Makassar Malay" => "mfp", "Gulf Arabic" => "afb", "Bolongan" => "blj", "Toki Pona" => "tok", "Hungu" => "hng", "Tatana" => "txx", "Baangi" => "bqx", "Lengua de Señas Panameñas" => "lsp", "Tagakaulo" => "klg", "Western Niger Fulfulde" => "fuh", "Tigrinya" => "tir", "Alege" => "alf", "Tommo So Dogon" => "dto", "Mondé" => "mnd", "Thakali" => "ths", "Midob" => "mei", "Dumbea" => "duf", "Northwestern Kolami" => "kfb", "Hungarian Sign Language" => "hsh", "Ancient Macedonian" => "xmk", "Central Lalo" => "ywt", "Nyungar" => "nys", "Pak-Tong" => "pkg", "Wik Ngathan" => "wig", "Mfumte" => "nfu", "Ngombe" => "nmj", "Sembakung Murut" => "sbr", "Ho Chi Minh City Sign Language" => "hos", "Jirel" => "jul", "Lesing-Gelimi" => "let", "Oloma" => "olm", "Badyara" => "pbp", "Budong-Budong" => "bdx", "Matsés" => "mcf", "Mogum" => "mou", "Kitsai" => "kii", "Baetora" => "btr", "Kutang Ghale" => "ght", "Siuslaw" => "sis", "Southern Thai" => "sou", "Kenati" => "gat", "Cuitlatec" => "cuy", "Drents" => "drt", "Kodi" => "kod", "Warkay-Bipim" => "bgv", "Somray" => "smu", "Birrpayi" => "xbj", "Sinyar" => "sys", "Goundo" => "goy", "Dombe" => "dov", "Menka" => "mea", "Oroko" => "bdu", "Waxianghua" => "wxa", "Yuanga" => "nua", "Epie" => "epi", "Bughotu" => "bgt", "Nuosu" => "iii", "Kintaq" => "knq", "Olo" => "ong", "Manambu" => "mle", "Tangale" => "tan", "Nar Phu" => "npa", "Maya Samo" => "sym", "Las Delicias Zapotec" => "zcd", "Alak" => "alk", "Isconahua" => "isc", "Ngemba" => "nge", "Northern Tidung" => "ntd", "Tareng" => "tgr", "Moronene" => "mqn", "Ixil" => "ixl", "Janji" => "jni", "Dema" => "dmx", "Mazatlán Mixe" => "mzl", "Pentlatch" => "ptw", "Kariyarra" => "vka", "Vinza" => "vin", "Bofi" => "bff", "Lhomi" => "lhm", "Oyda" => "oyd", "Azha" => "aza", "Batak" => "bya", "Gor" => "gqr", "Zarphatic" => "zrp", "Yaroamë" => "yro", "Khaling" => "klr", "Birgit" => "btf", "Waanyi" => "wny", "Anuak" => "anu", "Duna" => "duc", "Luimbi" => "lum", "Nalca" => "nlc", "Paama" => "pma", "Aer" => "aeq", "Langue des Signes Burundaise" => "lsb", "Mengaka" => "xmg", "Halia" => "hla", "Githabul" => "gih", "Kpatili" => "kym", "Tumleo" => "tmq", "Nukunul" => "xnu", "Bobot" => "bty", "Nambya" => "nmq", "Aputai" => "apx", "Mpoto" => "mpa", "Djinang" => "dji", "Kara-Kalpak" => "kaa", "Yangman" => "jng", "Bulgebi" => "bmp", "Northern Oaxaca Nahuatl" => "nhy", "Sangu" => "snq", "Moabite" => "obm", "Erokwanas" => "erw", "Bikol" => "bik", "Ndoe" => "nbb", "Jilim" => "jil", "Mandjak" => "mfv", "Lulogooli" => "rag", "Alor" => "aol", "Igede" => "ige", "Letemboi" => "nms", "Southeastern Dinka" => "dks", "Budibud" => "btp", "Sasak" => "sas", "San Juan Teita Mixtec" => "xtj", "Apma" => "app", "Yatzachi Zapotec" => "zav", "Enwan" => "enw", "Tuwuli" => "bov", "Mekeo" => "mek", "West Lembata" => "lmj", "Awing" => "azo", "Oluta Popoluca" => "plo", "Islander Creole English" => "icr", "Mikasuki" => "mik", "Norwegian" => "nor", "Toba-Maskoy" => "tmf", "Belait" => "beg", "Lithuanian Sign Language" => "lls", "Bamunka" => "bvm", "Danau" => "dnu", "Plapo Krumen" => "ktj", "Gebe" => "gei", "Ndobo" => "ndw", "Westphalien" => "wep", "Silacayoapan Mixtec" => "mks", "Dzodinka" => "add", "Sou Upaa" => "wha", "Abon" => "abo", "Dzongkha" => "dzo", "Pwo Eastern Karen" => "kjp", "Classical Armenian" => "xcl", "Gurindji Kriol" => "gjr", "Latvian" => "lav", "Eritai" => "ert", "Seko Padang" => "skx", "Batak Alas-Kluet" => "btz", "Awetí" => "awe", "Siane" => "snp", "North Mesopotamian Arabic" => "ayp", "Mengisa" => "mct", "Ngoshie" => "nsh", "Saek" => "skb", "Manam" => "mva", "Zimbabwe Sign Language" => "zib", "Interglossa" => "igs", "Male" => "mdy", "Ushojo" => "ush", "Coatecas Altas Zapotec" => "zca", "Saint Lucian Creole French" => "acf", "Old Bulgarian" => "chu", "Limburgish" => "lim", "Algonquin" => "alq", "Marachi" => "lri", "Nyoro" => "nyo", "Southern Muji" => "ymc", "Lashi" => "lsi", "Korowai" => "khe", "Cayuga" => "cay", "Gujarati" => "guj", "Samatao" => "ysd", "Anii" => "blo", "Pattani Malay" => "mfa", "Northern Ghale" => "ghh", "Wangganguru" => "wgg", "Daba" => "dbq", "Tennet" => "tex", "Berinomo" => "bit", "Akum" => "aku", "Classical Newari" => "nwc", "Valman" => "van", "Lisu" => "lis", "Emberá-Chamí" => "cmi", "Central Bontok" => "lbk", "Shor" => "cjs", "Guajá" => "gvj", "Kir-Balar" => "kkr", "Maung" => "mph", "Eastern Canadian Inuktitut" => "ike", "South Ndebele" => "nbl", "Ngoreme" => "ngq", "Watubela" => "wah", "Nivaclé" => "cag", "Yaur" => "jau", "Kuvi" => "kxv", "Chachapoyas Quechua" => "quk", "Korupun-Sela" => "kpq", "Piu" => "pix", "Arin" => "xrn", "Lafofa" => "laf", "Gbiri-Niragu" => "grh", "Northeast Maidu" => "nmu", "Pitcairn-Norfolk" => "pih", "Boor" => "bvf", "Tadaksahak" => "dsq", "Daatsʼíin" => "dtn", "Kurti" => "ktm", "Samaritan Aramaic" => "sam", "Fongoro" => "fgr", "Rer Bare" => "rer", "Tatar" => "tat", "Ngatik Men's Creole" => "ngm", "Asumboa" => "aua", "Beezen" => "bnz", "Sekpele" => "lip", "Mlap" => "kja", "Korra Koraga" => "kfd", "Dungmali" => "raa", "Seneca" => "see", "Oraon Sadri" => "sdr", "Gal" => "gap", "Hausa" => "hau", "Koonzime" => "ozm", "Tyerrenoterpanner" => "xph", "Soyaltepec Mazatec" => "vmp", "Kaki Ae" => "tbd", "Hulung" => "huk", "Umbugarla" => "umr", "Bunama" => "bdd", "Eskayan" => "esy", "Juray" => "juy", "Tami" => "tmy", "Kuuk-Yak" => "uky", "Kodava" => "kfa", "Sherdukpen" => "sdp", "Banda-Yangere" => "yaj", "Yeni" => "yei", "Jurúna" => "jur", "Wanbasana" => "alw", "Kwerisa" => "kkb", "Western Neo-Aramaic" => "amw", "Fagauvea" => "uve", "Phrae Pwo Karen" => "kjt", "Kumiai" => "dih", "Rifao" => "nmw", "Sudest" => "tgo", "Torau" => "ttu", "Demisa" => "dei", "Chazumba Mixtec" => "xtb", "Beembe" => "beq", "Fanti" => "fat", "Kei" => "kei", "Shughni" => "sgh", "Oscan" => "osc", "Mixed Great Andamanese" => "gac", "Tiéfo" => "tiq", "Takestani" => "tks", "'Auhelawa" => "kud", "Kanggape" => "igm", "Gun" => "guw", "Kamakan" => "vkm", "Gusilay" => "gsl", "Kunggari" => "kgl", "Southeast Tasmanian" => "xpf", "Akurio" => "ako", "Dinka" => "din", "Santiago del Estero Quichua" => "qus", "Nehan" => "nsn", "Judeo-Iraqi Arabic" => "yhd", "Natchez" => "ncz", "Mulgi" => "mvh", "Banda" => "bnd", "Yassic" => "ysc", "Enlhet" => "enl", "Monastic Sign Language" => "mzg", "Morelos Nahuatl" => "nhm", "Rungtu Chin" => "rtc", "Bay Miwok" => "mkq", "Xibe" => "sjo", "Alutor" => "alr", "Hidatsa" => "hid", "Jaunsari" => "jns", "Yintale Karen" => "kvy", "Walangama" => "nlw", "Skou" => "skv", "Khuen" => "khf", "Shom Peng" => "sii", "Wichí Lhamtés Nocten" => "mtp", "Gronings" => "gos", "Mentawai" => "mwv", "Purum" => "pub", "Nyang'i" => "nyp", "Masiwang" => "bnf", "Hewa" => "ham", "Nabak" => "naf", "Homa" => "hom", "Murkim" => "rmh", "Kaapor" => "urb", "Mosimo" => "mqv", "Warrgamay" => "wgy", "Aruop" => "lsr", "Xerénte" => "xer", "Callawalla" => "caw", "Rarotongan" => "rar", "Highland Oaxaca Chontal" => "chd", "Kinalakna" => "kco", "Curripaco" => "kpc", "Murik" => "mxr", "Keijar" => "kdy", "Indonesian Bajau" => "bdl", "Middle Hittite" => "htx", "Kalanga" => "kck", "South Ucayali Ashéninka" => "cpy", "Tepecano" => "tep", "Ulithian" => "uli", "Fwe" => "fwe", "Samburu" => "saq", "Sivia Sign Language" => "lsv", "Hawai'i Sign Language" => "hps", "Afrihili" => "afh", "Suba" => "sxb", "Subtiaba" => "sut", "Atsam" => "cch", "Maquiritari" => "mch", "Palauan" => "pau", "Kunama" => "kun", "Ghanaian Pidgin English" => "gpe", "Maiwala" => "mum", "Umon" => "umm", "Kayapó" => "txu", "Gamit" => "gbl", "Ama" => "nyi", "Bable" => "ast", "Bekwarra" => "bkv", "Tado" => "klw", "Dokshi" => "dsk", "Lenyima" => "ldg", "Alune" => "alp", "Katcha-Kadugli-Miri" => "xtc", "Karenggapa" => "eaa", "Ambakich" => "aew", "Bebil" => "bxp", "Ignaciano" => "ign", "Ngan'gityemerri" => "nam", "Avaric" => "ava", "Pacahuara" => "pcp", "Awiyaana" => "auy", "Karagas" => "kim", "Simbari" => "smb", "Wymysorys" => "wym", "Yangum Dey" => "yde", "Mandandanyi" => "zmk", "Southern Haida" => "hax", "Ngamambo" => "nbv", "Coast Miwok" => "csi", "Salampasu" => "slx", "Gaddang" => "gad", "Taloki" => "tlk", "Djauan" => "djn", "Jukun Takum" => "jbu", "Kambaata" => "ktb", "Beeke" => "bkf", "Esimbi" => "ags", "Nupbikha" => "npb", "Lawu" => "lwu", "Central Sierra Miwok" => "csm", "Odut" => "oda", "Burji" => "bji", "Kominimung" => "xoi", "Tha" => "thy", "Suga" => "sgi", "Zire" => "sih", "Teke-Ebo" => "ebo", "Inuinnaqtun" => "ikt", "Pirlatapa" => "bxi", "Samba Leko" => "ndi", "Pe" => "pai", "Ndai" => "gke", "Chinese Sign Language" => "csl", "Romanova" => "rmv", "Cia-Cia" => "cia", "Osatu" => "ost", "Lumba-Yakkha" => "luu", "Nasarian" => "nvh", "Geji" => "gyz", "Nyanga" => "nyj", "Kanakanabu" => "xnb", "Turung" => "try", "Uma" => "ppk", "Sheshi Kham" => "kip", "Central Kanuri" => "knc", "Primitive Irish" => "pgl", "Latgalian" => "ltg", "Chopi" => "cce", "Mawayana" => "mzx", "Torres Strait Creole" => "tcs", "Mandara" => "tbf", "Tamki" => "tax", "Kurrama" => "vku", "Bangka" => "mfb", "West Albay Bikol" => "fbl", "Dera" => "kna", "Suku" => "sub", "Luopohe Hmong" => "hml", "Waddar" => "wbq", "Trinitario" => "trn", "Cornish" => "cor", "Hmong Daw" => "mww", "Otoro" => "otr", "Phala" => "ypa", "Sokoro" => "sok", "Lengua de Señas del Paraguay" => "pys", "Cheke Holo" => "mrn", "Vumbu" => "vum", "Zapotec" => "zap", "Ngie" => "ngj", "Nkongho" => "nkc", "Totomachapan Zapotec" => "zph", "Tahaggart Tamahaq" => "thv", "Achterhoeks" => "act", "Kiowa Apache" => "apk", "Bedoanas" => "bed", "Limbum" => "lmp", "Northern Katang" => "ncq", "Minangkabau" => "min", "K'iche'" => "quc", "Singa" => "sgm", "Cumbric" => "xcb", "Tsat" => "huq", "Korak" => "koz", "Bom-Kim" => "bmf", "Kɛlɛngaxo Bozo" => "bzx", "Mbwela" => "mfu", "Saya" => "say", "Pahlavani" => "phv", "Konzo" => "koo", "Mussau-Emira" => "emi", "Kwaami" => "ksq", "Santali" => "sat", "Lusi" => "khl", "A-Pucikwar" => "apq", "Pukapuka" => "pkp", "Guarequena" => "gae", "Trinidadian Creole English" => "trf", "Rajput Garasia" => "gra", "Yaouré" => "yre", "Bungain" => "but", "Bokoto" => "bdt", "Lala-Roba" => "lla", "Boga" => "bvw", "Nai" => "bio", "Yabarana" => "yar", "Hijazi Arabic" => "acw", "Isu" => "szv", "Dongxiang" => "sce", "Baramu" => "bmz", "Emai-Iuleha-Ora" => "ema", "Ngombale" => "nla", "Wala" => "lgl", "Likum" => "lib", "Kakanda" => "kka", "Filipino" => "fil", "Biatah Bidayuh" => "bth", "Onin Based Pidgin" => "onx", "Abaga" => "abg", "Jicarilla Apache" => "apj", "Shabo" => "sbf", "O'du" => "tyh", "Koasati" => "cku", "Glaro-Twabo" => "glr", "Mankiyali" => "nlm", "Ajië" => "aji", "Southern Guiyang Miao" => "hmy", "Zabana" => "kji", "Lubuagan Kalinga" => "knb", "South Central Banda" => "lnl", "Nyawaygi" => "nyt", "Thai Song" => "soa", "Geruma" => "gea", "Lombard" => "lmo", "Baki" => "bki", "Viti" => "vit", "Bislama" => "bis", "Dime" => "dim", "Muyuw" => "myw", "Arabela" => "arl", "Tidikelt Tamazight" => "tia", "Manem" => "jet", "Ndoola" => "ndr", "Kari" => "kbj", "Fulniô" => "fun", "Yucuañe Mixtec" => "mvg", "Chug" => "cvg", "Simba" => "sbw", "Jingulu" => "jig", "Medefaidrin" => "dmf", "Latvian Sign Language" => "lsl", "Inor" => "ior", "Harami" => "xha", "Urali" => "url", "Tairaha" => "bxa", "Bussa" => "dox", "Kachhi" => "kfr", "Ledo Kaili" => "lew", "Central Tunebo" => "tuf", "Mvanip" => "mcj", "Gurindji" => "gue", "Carijona" => "cbd", "Guya" => "gka", "Batak Simalungun" => "bts", "Gayil" => "gyl", "Yoidik" => "ydk", "Zauzou" => "zal", "Kunimaipa" => "kup", "Dawera-Daweloor" => "ddw", "Malinaltepec Me'phaa" => "tcf", "Tarpia" => "tpf", "Dharawal" => "tbh", "Chaudangsi" => "cdn", "Cen" => "cen", "Pali" => "pli", "Huitepec Mixtec" => "mxs", "Choctaw" => "cho", "Wampanoag" => "wam", "Mirniny" => "gmr", "Sos Kundi" => "sdk", "Nyamusa-Molo" => "nwm", "Raetic" => "xrr", "Kiong" => "kkm", "Girirra" => "gii", "Atakapa" => "aqp", "Halkomelem" => "hur", "Blagar" => "beu", "Dyaberdyaber" => "dyb", "Jewish Palestinian Aramaic" => "jpa", "El Hugeirat" => "elh", "Lengola" => "lej", "Kenyi" => "lke", "Malyangapa" => "yga", "Malasar" => "ymr", "Ngawn Chin" => "cnw", "Sinicahua Mixtec" => "xti", "Mungaka" => "mhk", "Aribwaung" => "ylu", "Reli" => "rei", "Dusun Witu" => "duw", "Yolŋu Sign Language" => "ygs", "Phudagi" => "phd", "Batak Angkola" => "akb", "Teke-Tyee" => "tyx", "Vagla" => "vag", "Waimaha" => "bao", "Pijao" => "pij", "Pitjantjatjara" => "pjt", "Central Nahuatl" => "nhn", "Ketengban" => "xte", "Angolar" => "aoa", "Edopi" => "dbf", "Parecís" => "pab", "Lavrung" => "jiq", "Southwest Pashayi" => "psh", "Old Church Slavonic" => "chu", "Acroá" => "acs", "Multiple languages" => "mul", "Linear A" => "lab", "Ligbi" => "lig", "Qatabanian" => "xqt", "Kupia" => "key", "Sindarin" => "sjn", "Eastern Tamang" => "taj", "Chambeali" => "cdh", "Abaza" => "abq", "Paluan" => "plz", "Karo" => "kxh", "Baloi" => "biz", "Masaaba" => "myx", "Lawangan" => "lbx", "Yanomamö" => "guu", "Standard Latvian" => "lvs", "Gaina" => "gcn", "Varisi" => "vrs", "Wusa Nasu" => "yig", "Kagoro" => "xkg", "Lombi" => "lmi", "North Bolivian Quechua" => "qul", "Canichana" => "caz", "Fwâi" => "fwa", "Southern Nicobarese" => "nik", "Gyem" => "gye", "Karamojong" => "kdj", "Mangbetu" => "mdj", "Pirahã" => "myp", "Kho'ini" => "xkc", "Thiin" => "iin", "Yansi" => "yns", "Bina" => "byj", "Agatu" => "agc", "Tobati" => "tti", "Teshenawa" => "twc", "Ingush" => "inh", "Boruca" => "brn", "Lampung Nyo" => "abl", "Baimak" => "bmx", "Guerrero Nahuatl" => "ngu", "Cisalpine Gaulish" => "xcg", "Rajah Kabunsuwan Manobo" => "mqk", "Sira" => "swj", "Gooniyandi" => "gni", "Khazar" => "zkz", "Tsikimba" => "kdl", "Lule Sami" => "smj", "Bonan" => "peh", "Nguôn" => "nuo", "Bendi" => "bct", "Huambisa" => "hub", "Guató" => "gta", "Mitlatongo Mixtec" => "vmm", "Kimré" => "kqp", "S'gaw Karen" => "ksw", "Seko Tengah" => "sko", "Drehu" => "dhv", "Wayu" => "vay", "Lalia" => "lal", "Dhodia" => "dho", "Western Highland Purepecha" => "pua", "Kunda" => "kdn", "Nkari" => "nkz", "Rigwe" => "iri", "Adele" => "ade", "South Central Dinka" => "dib", "International Sign" => "ils", "Lakondê" => "lkd", "Parachi" => "prc", "Khams Tibetan" => "khg", "Tai Daeng" => "tyr", "Desiya" => "dso", "Eastern Arrernte" => "aer", "Molof" => "msl", "Kullu Pahari" => "kfx", "Quioquitani-Quierí Zapotec" => "ztq", "Amarasi" => "aaz", "Māhārāṣṭri Prākrit" => "pmh", "Wampur" => "waz", "Manichaean Middle Persian" => "xmn", "Lalana Chinantec" => "cnl", "Mewati" => "wtm", "Kiwilwana" => "mlk", "Ocaina" => "oca", "Wasco-Wishram" => "wac", "Milyan" => "imy", "Kubi" => "kof", "Kwerba Mamberamo" => "xwr", "North Nuaulu" => "nni", "Sukur" => "syk", "Ajumbu" => "muc", "San Felipe Otlaltepec Popoloca" => "pow", "Ju" => "juu", "Sambalpuri" => "spv", "Norwegian Bokmål" => "nob", "Benyadu'" => "byd", "Northern Guiyang Hmong" => "huj", "Malgbe" => "mxf", "Jakun" => "jak", "Gavak" => "dmc", "Zeme Naga" => "nzm", "Mwerlap" => "mrm", "Lampung Api" => "ljp", "Pitta Pitta" => "pit", "Tagish" => "tgx", "Gungabula" => "gyf", "Matumbi" => "mgw", "Con" => "cno", "Bilakura" => "bql", "Ningil" => "niz", "Lala" => "nrz", "Ot Danum" => "otd", "Slavomolisano" => "svm", "Madi" => "grg", "Eudeve" => "eud", "Mbessa" => "emz", "Iyayu" => "iya", "Unggaranggu" => "xun", "Javindo" => "jvd", "Liki" => "lio", "Jewish Babylonian Aramaic" => "tmr", "Wahau Kayan" => "whu", "Panoan Katukína" => "knt", "Evant" => "bzz", "Gavar" => "gou", "Mandinka" => "mnk", "Vai" => "vai", "Kuvale" => "olu", "Southern Katang" => "sct", "Cappadocian Greek" => "cpg", "Bube" => "bvb", "Taita" => "dav", "Inonhan" => "loc", "Narak" => "nac", "Shina" => "scl", "Torá" => "trz", "Ngete" => "nnn", "Dagoman" => "dgn", "Barrow Point" => "bpt", "Mamuju" => "mqx", "Dutch Sign Language" => "dse", "Sekani" => "sek", "Megam" => "mef", "Eastern Mnong" => "mng", "Meriam Mir" => "ulk", "Xakriabá" => "xkr", "North Picene" => "nrp", "Ngkâlmpw Kanum" => "kcd", "Kankanaey" => "kne", "Akebu" => "keu", "Navajo" => "nav", "Yabem" => "jae", "Lun Bawang" => "lnd", "Guerrero Amuzgo" => "amu", "Moundadan Chetty" => "cty", "Santa Inés Ahuatempan Popoloca" => "pca", "Gresi" => "grs", "Darai" => "dry", "Ganggalida" => "gcd", "Tonga" => "ton", "Bini" => "bin", "Láá Láá Bwamu" => "bwj", "Eastern Karaboro" => "xrb", "Upper Sorbian" => "hsb", "Guébie" => "gie", "Mundari" => "unr", "Dambi" => "dac", "Hassaniyya" => "mey", "West Damar" => "drn", "Yaqay" => "jaq", "Bekati'" => "bei", "Kinuku" => "kkd", "Modern Greek" => "ell", "Rana Tharu" => "thr", "Dompo" => "doy", "Lolo" => "llb", "Lakurumau" => "lxm", "Tagalaka" => "tgz", "Mituku" => "zmq", "Tsakwambo" => "kvz", "Benabena" => "bef", "Knaanic" => "czk", "Zemgalian" => "xzm", "Amdo Tibetan" => "adx", "Maltese" => "mlt", "Manikion" => "mnx", "Pipil" => "ppl", "Eastern Katu" => "ktv", "Lamalera" => "lmr", "Quinault" => "qun", "Ouma" => "oum", "Malinaltepec Tlapanec" => "tcf", "Ha" => "haq", "Karkin" => "krb", "Albanian" => "sqi", "Kamu" => "xmu", "Oki-No-Erabu" => "okn", "Konso" => "kxc", "Nhengatu" => "yrl", "Lakon" => "lkn", "Central Kurdish" => "ckb", "Molmo One" => "aun", "Bebele" => "beb", "Gao" => "gga", "Wa'ema" => "wag", "Kukatha" => "ktd", "Ngongo" => "noq", "Grebo" => "grb", "Old Tamil" => "oty", "Costa Rican Sign Language" => "csr", "Iyive" => "uiv", "Burduna" => "bxn", "Olkol" => "olk", "Shumashti" => "sts", "Dengka" => "dnk", "ǂ'Amkhoe" => "huc", "Waigali" => "wbk", "Upper Kinabatangan" => "dmg", "Tunen" => "tvu", "Zerenkel" => "zrn", "Kala" => "kcl", "Tajik" => "tgk", "Seti" => "sbi", "Kamo" => "kcq", "Ndo" => "ndp", "Mo'da" => "gbn", "Ambrak" => "aag", "Amal" => "aad", "Old Sundanese" => "osn", "Siwu" => "akp", "Rerau" => "rea", "Flemish Sign Language" => "vgt", "Warnman" => "wbt", "Penrhyn" => "pnh", "Karnai" => "bbv", "Tayart Tamajeq" => "thz", "Kháng" => "kjm", "Gongduk" => "goe", "Old Korean" => "oko", "Ampanang" => "apg", "Otuho" => "lot", "Nuer" => "nus", "Nafusi" => "jbn", "Kirdki" => "zza", "Bandi" => "bza", "Isthmus Zapotec" => "zai", "Nhirrpi" => "hrp", "Cocopa" => "coc", "Lasi" => "lss", "Muong" => "mtq", "Magɨ" => "gkd", "Classical Syriac" => "syc", "Lobala" => "loq", "Ubir" => "ubr", "Yau" => "yyu", "Sedang" => "sed", "Mala" => "ruy", "Nilamba" => "nim", "Ibuoro" => "ibr", "Zayse-Zergulla" => "zay", "Bhojpuri" => "bho", "Ixtenco Otomi" => "otz", "Bathari" => "bhm", "Geman Deng" => "mxj", "Romagnol" => "rgn", "Boguru" => "bqu", "Rongga" => "ror", "Kao" => "kax", "Guyani" => "gvy", "Jehai" => "jhi", "Koroshi" => "ktl", "Huaylla Wanca Quechua" => "qvw", "Southern Kisi" => "kss", "Huehuetla Tepehua" => "tee", "Wanda" => "wbh", "Wahgi" => "wgi", "Guwinmal" => "xgm", "Meyah" => "mej", "Muslim Tat" => "ttt", "Texcatepec Otomi" => "otx", "Bezhta" => "kap", "Rungus" => "drg", "Mom Jango" => "ver", "Gitonga" => "toh", "Panao Huánuco Quechua" => "qxh", "Amaimon" => "ali", "Kwerba" => "kwe", "Toba" => "tob", "Kalispel-Pend d'Oreille" => "fla", "Balanta-Kentohe" => "ble", "Mbosi" => "mdw", "Amis" => "ami", "Keningau Murut" => "kxi", "Bata" => "bta", "Nyulnyul" => "nyv", "South West Bay" => "sns", "Siang" => "sya", "Mlahsö" => "lhs", "San Francisco Matlatzinca" => "mat", "Senara Sénoufo" => "seq", "Ega" => "ega", "Komyandaret" => "kzv", "Yaqui" => "yaq", "Akoye" => "miw", "Estonian" => "est", "Zorop" => "wfg", "Sikkimese" => "sip", "Carabayo" => "cby", "Pinotepa Nacional Mixtec" => "mio", "Russia Buriat" => "bxr", "Como Karim" => "cfg", "Bosnian" => "bos", "Upper Umpqua" => "xup", "Tubar" => "tbu", "Halang Doan" => "hld", "Bian Marind" => "bpv", "Central Pomo" => "poo", "Metlatónoc Mixtec" => "mxv", "Birhor" => "biy", "Kobiana" => "kcj", "Ulau-Suain" => "svb", "Yoloxochitl Mixtec" => "xty", "Terebu" => "trb", "Vunjo" => "vun", "Sukurum" => "zsu", "Konda" => "knd", "Kunduvadi" => "wku", "British Sign Language" => "bfi", "Andajin" => "ajn", "Mixtepec Mixtec" => "mix", "Kaulong" => "pss", "Efik" => "efi", "Northwest Maidu" => "mjd", "Rwandan Sign Language" => "rsn", "Mag-antsi Ayta" => "sgb", "Makasar" => "mak", "Northern Sami" => "sme", "Edomite" => "xdm", "Hiligaynon" => "hil", "Cishingini" => "asg", "Taruma" => "tdm", "Toma" => "tod", "Tii" => "txq", "Mailu" => "mgu", "Kita Maninkakan" => "mwk", "Horpa" => "ero", "Namibian Sign Language" => "nbs", "Yawarawarga" => "yww", "Tadyawan" => "tdy", "Buyu" => "byi", "Cajonos Zapotec" => "zad", "Zay" => "zwa", "Bebeli" => "bek", "Valle Nacional Chinantec" => "cvn", "Krobu" => "kxb", "Utarmbung" => "omo", "Kulisusu" => "vkl", "Lemio" => "lei", "Warlmanpa" => "wrl", "Uncoded languages" => "mis", "Téén" => "lor", "Maa" => "cma", "Cha'ari" => "cxh", "Juǀʼhoan" => "ktz", "Jere" => "jer", "Malila" => "mgq", "Jamaican Country Sign Language" => "jcs", "Minang" => "xrg", "Jamaican Sign Language" => "jls", "Bagri" => "bgq", "Petats" => "pex", "Southern Nuni" => "nnw", "Sobei" => "sob", "Manado Malay" => "xmm", "Waima'a" => "wmh", "Ata" => "atm", "Persian" => "fas", "Tsimihety Malagasy" => "xmw", "Pökoot" => "pko", "Karon Dori" => "kgw", "Cafundo Creole" => "ccd", "Eman" => "emn", "Waray" => "wrz", "Iwaidja" => "ibd", "Kalaktang Monpa" => "kkf", "Southern Luri" => "luz", "Poguli" => "hkh", "Potiguára" => "pog", "Mahali" => "mjx", "Nawaru" => "nwr", "Ndam" => "ndm", "Tanguat" => "tbs", "Tokharian A" => "xto", "Chibcha" => "chb", "Selian" => "sxl", "Badeshi" => "bdz", "Isthmus-Mecayapan Nahuatl" => "nhx", "Southern Pomo" => "peq", "Hlepho Phowa" => "yhl", "Matagalpa" => "mtn", "Anong" => "nun", "Waiwai" => "waw", "Mato Grosso Arára" => "axg", "Kharam Naga" => "kfw", "Caramanta" => "crf", "Batek" => "btq", "Bana" => "bcw", "Kopar" => "xop", "Kono" => "knu", "Classical Mandaic" => "myz", "Gwere" => "gwr", "Ndambomo" => "nxo", "Zazao" => "jaj", "Kahe" => "hka", "Kilmeri" => "kih", "North Wahgi" => "whg", "Mekmek" => "mvk", "Northern Subanen" => "stb", "Eloyi" => "afo", "Anakalangu" => "akg", "Bon Gula" => "glc", "Chaima" => "ciy", "Aquitanian" => "xaq", "Yirrk-Mel" => "yrm", "Hiri Motu" => "hmo", "Ngiti" => "niy", "Jèrriais" => "nrf", "Neo-Hittite" => "nei", "Mortlockese" => "mrl", "Kopkaka" => "opk", "Eastern Cham" => "cjm", "Ginuman" => "gnm", "Masalit" => "mls", "Yaben" => "ybm", "Brem" => "buq", "Kolibugan Subanon" => "skn", "Sio" => "xsi", "Mandan" => "mhq", "Barasana-Eduria" => "bsn", "Min Zhong Chinese" => "czo", "Old Saxon" => "osx", "Dotyali" => "dty", "Gamkonora" => "gak", "Ke'o" => "xxk", "Pamplona Atta" => "att", "Mbangi" => "mgn", "Selee" => "snw", "Furu" => "fuu", "Emberá-Catío" => "cto", "Kokota" => "kkk", "Mandeali" => "mjl", "Solano" => "xso", "Kavet" => "krv", "Mandaya" => "mry", "Kako" => "kkj", "Samogitian" => "sgs", "Thurawal" => "tbh", "Duguri" => "dbm", "Alacatlatzala Mixtec" => "mim", "Kathoriya Tharu" => "tkt", "Southern Ngbandi" => "nbw", "Lachi" => "lbt", "Choni" => "cda", "Northern Nago" => "xkb", "Dandami Maria" => "daq", "Quechan" => "yum", "Bukitan" => "bkn", "Liv" => "liv", "Dimbong" => "dii", "Macedonian" => "mkd", "Gan Chinese" => "gan", "Bantoanon" => "bno", "Marriammu" => "xru", "Guarayu" => "gyr", "Silesian" => "szl", "Engdewu" => "ngr", "Sumi Naga" => "nsm", "Thai Sign Language" => "tsq", "Kaska" => "kkz", "Oroha" => "ora", "Sacapulteco" => "quv", "Konkomba" => "xon", "Garifuna" => "cab", "Muduga" => "udg", "Kagate" => "syw", "Mehri" => "gdq", "Skalvian" => "svx", "Aheri Gondi" => "esg", "Pathiya" => "pty", "Laal" => "gdm", "Senhaja De Srair" => "sjs", "Päri" => "lkr", "Tày" => "tyz", "Maria" => "mrr", "White Gelao" => "giw", "Habu" => "hbu", "Ma" => "msj", "Ndolo" => "ndl", "Car Nicobarese" => "caq", "Paynamar" => "pmr", "Trieng" => "stg", "Womo" => "wmx", "Bayali" => "bjy", "Tandaganon" => "tgn", "Eastern Magar" => "mgp", "Nathembo" => "nte", "Mazaltepec Zapotec" => "zpy", "Old Mon" => "omx", "Transalpine Gaulish" => "xtg", "San Miguel Creole French" => "scf", "Walser" => "wae", "Burak" => "bys", "Garlali" => "gll", "Bissa" => "bib", "Loko" => "lok", "Jeri Kuo" => "jek", "Halh Mongolian" => "khk", "Gerai" => "gef", "Mochica" => "omc", "Pankararú" => "paz", "Mid-Southern Banda" => "bjo", "Namia" => "nnm", "Traveller Norwegian" => "rmg", "South Azerbaijani" => "azb", "E'ma Buyang" => "yzg", "Louisiana Creole" => "lou", "Quapaw" => "qua", "Tay Khang" => "tnu", "Nisenan" => "nsz", "San Martín Itunyoso Triqui" => "trq", "Bunuba" => "bck", "Wathawurrung" => "wth", "Nawuri" => "naw", "Kap" => "ykm", "Northern Frisian" => "frr", "Ikwere" => "ikw", "Iyojwa'ja Chorote" => "crt", "Fulah" => "ful", "Thado Chin" => "tcz", "Kpasam" => "pbn", "Singapore Sign Language" => "sls", "Tonsea" => "txs", "Adyghe" => "ady", "Central Nicobarese" => "ncb", "Bara Malagasy" => "bhr", "Miqie" => "yiq", "Domu" => "dof", "Uru" => "ure", "Pamona" => "pmf", "Antankarana Malagasy" => "xmv", "Hõne" => "juh", "Old Georgian" => "oge", "Tehit" => "kps", "Khumi Chin" => "cnk", "Western Parbate Kham" => "kjl", "Javanese" => "jav", "Vangunu" => "mpr", "Ngwe" => "nwe", "Byep" => "mkk", "San Dionisio Del Mar Huave" => "hve", "Hanunoo" => "hnn", "Mendankwe-Nkwen" => "mfd", "Bagupi" => "bpi", "Caddo" => "cad", "Ngwo" => "ngn", "Tseku" => "tsk", "Morrobalama" => "umg", "Ho-Chunk" => "win", "Pohnpeian" => "pon", "Wusi" => "wsi", "Ikobi" => "meb", "Saurashtra" => "saz", "Moksela" => "vms", "Ojibwa" => "oji", "Central Hongshuihe Zhuang" => "zch", "Romansh" => "roh", "Carian" => "xcr", "Western Krahn" => "krw", "Zo'é" => "pto", "Biage" => "bdf", "Kudmali" => "kyw", "Namat" => "nkm", "Sala" => "shq", "Tapieté" => "tpj", "Irish Sign Language" => "isg", "Leco" => "lec", "Abishira" => "ash", "Ambul" => "apo", "Dâw" => "kwa", "Hungana" => "hum", "Guro" => "goa", "Middle Newar" => "nwx", "Ladakhi" => "lbj", "Oirat" => "xal", "Phuong" => "phg", "Kuku" => "ukv", "Unggumi" => "xgu", "Yir Yoront" => "yyr", "Iku-Gora-Ankwa" => "ikv", "South Awyu" => "aws", "Kumyk" => "kum", "Mbula-Bwazza" => "mbu", "Sankaran Maninka" => "msc", "Yapese" => "yap", "Kendayan" => "knx", "Talysh" => "tly", "Luyana" => "lyn", "Hakö" => "hao", "Wasa" => "wss", "Alapmunte" => "apv", "Delaware" => "del", "Butbut Kalinga" => "kyb", "Yanesha'" => "ame", "Pwo Northern Karen" => "pww", "Ter Sami" => "sjt", "ǃXóõ" => "nmn", "Nend" => "anh", "Yaaku" => "muu", "Tai Dón" => "twh", "Lahu Shi" => "lhi", "Bunak" => "bfn", "Sikaiana" => "sky", "Burundian Sign Language" => "lsb", "Mutu" => "tuc", "Mbara" => "mvl", "Finnish Sign Language" => "fse", "Bellari" => "brw", "Atsugewi" => "atw", "Ganglau" => "ggl", "Igo" => "ahl", "Kawi" => "kaw", "Korean Sign Language" => "kvk", "Kundal Shahi" => "shd", "Karami" => "xar", "Umbindhamu" => "umd", "Tal" => "tal", "Nganasan" => "nio", "Abu" => "ado", "Uare" => "ksj", "Mong Njua" => "hnj", "Zarma" => "dje", "Barwe" => "bwg", "Wotu" => "wtw", "Pawnee" => "paw", "Kedang" => "ksx", "Beti" => "eot", "Oroch" => "oac", "Aleut" => "ale", "Mungbam" => "mij", "Brokkat" => "bro", "Mukha-Dora" => "mmk", "Mpotovoro" => "mvt", "Southern Pinghua" => "csp", "Gilyak" => "niv", "Namiae" => "nvm", "Southern Mashan Hmong" => "hma", "Opuuo" => "lgn", "Southern Ghale" => "ghe", "Hibito" => "hib", "Dogri" => "doi", "Suruahá" => "swx", "Musgu" => "mug", "Mubami" => "tsx", "Kota Marudu Talantang" => "grm", "Magoma" => "gmx", "Nauna" => "ncn", "Chala" => "cll", "Labu" => "lbu", "Epena" => "sja", "Karkar-Yuri" => "yuj", "Bambili-Bambui" => "baw", "Kulere" => "kul", "Inebu One" => "oin", "San Marcos Tlalcoyalco Popoloca" => "pls", "Occidental" => "ile", "Australian Sign Language" => "asf", "Aduge" => "adu", "Atsahuaca" => "atc", "Caquinte" => "cot", "Sajalong" => "sjl", "Ukrainian" => "ukr", "Ngawun" => "nxn", "Gimi" => "gip", "Mághdì" => "gmd", "Krenak" => "kqq", "Ponam" => "ncc", "Niuean" => "niu", "Qabiao" => "laq", "Xinca" => "xin", "Kituba" => "mkw", "Yeniche" => "yec", "Bokobaru" => "bus", "Loloda" => "loa", "Pacific Gulf Yupik" => "ems", "Abadi" => "kbt", "Wapishana" => "wap", "Watiwa" => "wtf", "Western Armenian" => "hyw", "Attié" => "ati", "Abron" => "abr", "Arandai" => "jbj", "Loke" => "loy", "Garuwali" => "rxw", "Bankagooma" => "bxw", "Wu Chinese" => "wuu", "Kutenai" => "kut", "ǂHua" => "huc", "Texistepec Popoluca" => "poq", "Bolinao" => "smk", "Semandang" => "sdq", "Segai" => "sge", "Marino" => "mrb", "Bumthangkha" => "kjz", "Rade" => "rad", "Kipfokomo" => "pkb", "Abkhazian" => "abk", "Toto" => "txo", "Daakaka" => "bpa", "Etkywan" => "ich", "Ko" => "fuj", "Ndali" => "ndh", "Bungku" => "bkz", "Nafri" => "nxx", "Western Totonac" => "tqt", "Frankish" => "frk", "Ikpeng" => "txi", "Namakura" => "nmk", "Luopohe Miao" => "hml", "Selaru" => "slu", "Soqotri" => "sqt", "Tairuma" => "uar", "Kapingamarangi" => "kpg", "Kande" => "kbs", "Tso" => "ldp", "Dumpas" => "dmv", "Nukna" => "klt", "Sikaritai" => "tty", "Palu'e" => "ple", "Malê" => "hot", "Pfaelzisch" => "pfl", "Igala" => "igl", "Nomu" => "noh", "Maguindanaon" => "mdh", "Larantuka Malay" => "lrt", "Romkun" => "rmk", "Saraveca" => "sar", "Pulaar" => "fuc", "Algerian Sign Language" => "asp", "Tanimbili" => "tbe", "Sidetic" => "xsd", "Yulu" => "yul", "Standard Moroccan Tamazight" => "zgh", "Roria" => "rga", "Khanty" => "kca", "Avokaya" => "avu", "Moru" => "mgd", "Kuamasi" => "yku", "Atorada" => "aox", "South Tairora" => "omw", "Ngeq" => "ngt", "Western Yiddish" => "yih", "Wãpha" => "juw", "T'en" => "tct", "Ingrian" => "izh", "Mang" => "zng", "Medumba" => "byv", "Mangala" => "mem", "Orizaba Nahuatl" => "nlv", "Kuuk Thaayorre" => "thd", "North Azerbaijani" => "azj", "Gowlan" => "goj", "Kutep" => "kub", "Oyster Bay Tasmanian" => "xpd", "Etruscan" => "ett", "Kirmanjki" => "zza", "Begbere-Ejar" => "bqv", "Zenag" => "zeg", "Ekai Chin" => "cey", "Gade" => "ged", "Bafaw-Balong" => "bwt", "Hajong" => "haj", "Dene Suline" => "chp", "Tachelhit" => "shi", "Northern Huishui Miao" => "hmi", "Arawak" => "arw", "Kumalu" => "ksl", "Magahi" => "mag", "Meoswar" => "mvx", "Zaniza Zapotec" => "zpw", "Ndasa" => "nda", "Andaman Creole Hindi" => "hca", "Kanembu" => "kbl", "Riverain Sango" => "snj", "Namosi-Naitasiri-Serua" => "bwb", "Marangis" => "wax", "Duala" => "dua", "Koko Babangk" => "okg", "Northwestern Tasmanian" => "xpw", "Narua" => "nru", "Cholón" => "cht", "Mok" => "mqt", "Thaiphum Chin" => "cth", "Upper Taromi" => "tov", "Silimo" => "wul", "Tugun" => "tzn", "Sakachep" => "sch", "Hmwaveke" => "mrk", "Lang'e" => "yne", "Chuave" => "cjv", "Kabiyè" => "kbp", "Uneme" => "une", "Mattoki" => "xnz", "Murui Huitoto" => "huu", "Yabong" => "ybo", "Gidar" => "gid", "Lunanakha" => "luk", "Kapampangan" => "pam", "Batu" => "btu", "Gepo" => "ygp", "Mandahuaca" => "mht", "Wè Western" => "wec", "Kxoe" => "xuu", "Vengo" => "bav", "Nkonya" => "nko", "Old Avar" => "oav", "Dalabon" => "ngk", "Cajatambo North Lima Quechua" => "qvl", "Kalumpang" => "kli", "Darmiya" => "drd", "Bakairí" => "bkq", "Bulgarian Sign Language" => "bqn", "Kabalai" => "kvf", "Mano" => "mev", "Ono" => "ons", "Saruga" => "sra", "Djeebbana" => "djj", "Koireng" => "nkd", "Poke" => "pof", "Indonesian Sign Language" => "inl", "Kélé" => "keb", "Chagatai" => "chg", "Weliki" => "klh", "Nzakara" => "nzk", "Aromanian" => "rup", "Soo" => "teu", "Mur Pano" => "tkv", "Anam" => "pda", "Rembong" => "reb", "Guianese Creole French" => "gcr", "Wedau" => "wed", "Warnang" => "wrn", "Levuka" => "lvu", "Arhuaco" => "arh", "Guiqiong" => "gqi", "Lega-Mwenga" => "lgm", "E'ñapa Woromaipu" => "pbh", "Kato" => "ktw", "Sha" => "scw", "Nopala Chatino" => "cya", "Wuding-Luquan Yi" => "ywq", "Keerray-Woorroong" => "wkr", "Waimiri-Atroari" => "atr", "Imotong" => "imt", "Carrier" => "crx", "Jhankot Sign Language" => "jhs", "Kera" => "ker", "Kayort" => "kyv", "Saposa" => "sps", "Dusun Malang" => "duq", "Irarutu" => "irh", "Mbay" => "myb", "Djinba" => "djb", "Khetrani" => "xhe", "Gants" => "gao", "Icelandic Sign Language" => "icl", "Akawaio" => "ake", "Napu" => "npy", "Kaptiau" => "kbi", "Mbowe" => "mxo", "Sake" => "sak", "To" => "toz", "Francisco León Zoque" => "zos", "Naskapi" => "nsk", "Moldavian" => "ron", "Gunwinggu" => "gup", "San Miguel Piedras Mixtec" => "xtp", "Serili" => "sve", "Amol" => "alx", "Bo" => "bpw", "Feroge" => "fer", "Ilongot" => "ilk", "Elotepec Zapotec" => "zte", "Lehar" => "cae", "Kirikiri" => "kiy", "Ndemli" => "nml", "Poqomam" => "poc", "Tumzabt" => "mzb", "Tukumanféd" => "tkf", "Rawa" => "rwo", "Tese" => "keg", "Saluan" => "loe", "Gitua" => "ggt", "Umatilla" => "uma", "Imroing" => "imr", "Saidi Arabic" => "aec", "Gumatj" => "gnn", "Temi" => "soz", "Gnau" => "gnu", "Akan" => "aka", "Umbuygamu" => "umg", "ǀGwi" => "gwj", "Jibu" => "jib", "Kerewe" => "ked", "Western Kayah" => "kyu", "Côông" => "cnc", "Magori" => "zgr", "Michif" => "crg", "Jara" => "jaf", "Moyadan Itneg" => "ity", "Yurutí" => "yui", "Iranian Sign Language" => "psc", "Yaleba" => "ylb", "Piamatsina" => "ptr", "Yue Chinese" => "yue", "Bishnupriya" => "bpy", "Bangandu" => "bgf", "Ditidaht" => "dtd", "Gagauz" => "gag", "Zimba" => "zmb", "Portuguese" => "por", "Ponosakan" => "pns", "Mwatebu" => "mwa", "Southern Yamphu" => "lrr", "Mungkip" => "mpv", "Ashkun" => "ask", "Eastern Huishui Hmong" => "hme", "Upper Chehalis" => "cjh", "Lungga" => "lga", "Semnam" => "ssm", "Ayiwo" => "nfl", "Fa d'Ambu" => "fab", "Kyanga" => "tye", "Gilaki" => "glk", "Lola" => "lcd", "Isthmus Mixe" => "mir", "Egypt Sign Language" => "esl", "Oro Win" => "orw", "Yawanawa" => "ywn", "Yotti" => "yot", "Waamwang" => "wmn", "Dusun Deyah" => "dun", "Nhangu" => "jay", "Svan" => "sva", "Nupe-Nupe-Tako" => "nup", "Gaɓogbo" => "gie", "Nindi" => "nxi", "Zacatlán-Ahuacatlán-Tepetzintla Nahuatl" => "nhi", "Samre" => "sxm", "Wambon" => "wms", "Duano" => "dup", "Baraamu" => "brd", "Tjupany" => "tjp", "Cakfem-Mushere" => "cky", "Musi" => "mui", "Aproumu Aizi" => "ahp", "Mamara Senoufo" => "myk", "Saba" => "saa", "Tututni" => "tuu", "Eastern Keres" => "kee", "Yerakai" => "yra", "Buyuan Jinuo" => "jiy", "Chayuco Mixtec" => "mih", "Bwatoo" => "bwa", "Ruma" => "ruz", "Santo Domingo Albarradas Zapotec" => "zas", "Waurá" => "wau", "Elseng" => "mrf", "Northern Pashto" => "pbu", "Ainbai" => "aic", "Kyerung" => "kgy", "Angal Enen" => "aoe", "Walloon" => "wln", "To'abaita" => "mlu", "Yinggarda" => "yia", "Ontong Java" => "ojv", "Masadiit Itneg" => "tis", "Phangduwali" => "phw", "Unde Kaili" => "unz", "Western Minyag" => "wmg", "Kanowit-Tanjong Melanau" => "kxn", "Bragat" => "aof", "Nyenkha" => "neh", "Oro" => "orx", "Central Pashto" => "pst", "Holu" => "hol", "Acoli" => "ach", "Biao Mon" => "bmt", "Kaiy" => "tcq", "Wamin" => "wmi", "Korwa" => "kfp", "Cocos Islands Malay" => "coa", "Yola" => "yol", "Drung" => "duu", "Cacgia Roglai" => "roc", "Zhang-Zhung" => "xzh", "Kavalan" => "ckv", "Pintupi-Luritja" => "piu", "Northern Alta" => "aqn", "Swiss-Italian Sign Language" => "slf", "Bungu" => "wun", "Ninam" => "shb", "Reshe" => "res", "Morom" => "bdo", "Batak Mandailing" => "btm", "Koryak" => "kpy", "Dawro" => "dwr", "Dehwari" => "deh", "Parya" => "paq", "Mbangwe" => "zmn", "Musar" => "mmi", "Bamu" => "bcf", "Hukumina" => "huw", "Southern Amami-Oshima" => "ams", "Kaimbé" => "xai", "Oroqen" => "orh", "Paite Chin" => "pck", "Palantla Chinantec" => "cpa", "Tokharian B" => "txb", "Kisan" => "xis", "Ganzi" => "gnz", "Kawe" => "kgb", "Salvadoran Sign Language" => "esn", "Dhuwaya" => "dwy", "Kugu-Muminh" => "xmh", "Busang Kayan" => "bfg", "Ede Ica" => "ica", "Tetete" => "teb", "Dibiyaso" => "dby", "Ngäbere" => "gym", "Apasco-Apoala Mixtec" => "mip", "Yaeyama" => "rys", "Ngangam" => "gng", "Mískito" => "miq", "Dedua" => "ded", "Markweeta" => "enb", "Cabiyarí" => "cbb", "Bundeli" => "bns", "San Francisco Del Mar Huave" => "hue", "Lidzonka" => "add", "Birale" => "bxe", "Tobilung" => "tgb", "Macedo-Romanian" => "rup", "Todrah" => "tdr", "Tangoa" => "tgp", "Wandarang" => "wnd", "Degema" => "deg", "Nkami" => "nkq", "Asilulu" => "asl", "Luhu" => "lcq", "Kven Finnish" => "fkv", "Shelta" => "sth", "Gowro" => "gwf", "Bambalang" => "bmo", "Kendeje" => "klf", "Nawdm" => "nmz", "South Efate" => "erk", "Youle Jinuo" => "jiu", "Solomon Islands Sign Language" => "szs", "Tampulma" => "tpm", "Kaamba" => "xku", "Bokha" => "ybk", "Sibe" => "nco", "Maleu-Kilenge" => "mgl", "Punan Merah" => "puf", "Hijuk" => "hij", "Abui" => "abz", "Sylheti" => "syl", "Tamagario" => "tcg", "Aore" => "aor", "Gāndhārī" => "pgd", "Wuliwuli" => "wlu", "Nii" => "nii", "Guwa" => "xgw", "Birked" => "brk", "Tobelo" => "tlb", "Amahuaca" => "amc", "Laimbue" => "lmx", "Seroa" => "kqu", "Kanan" => "zkn", "Cebaara Senoufo" => "sef", "South Lembata" => "lmf", "Xishanba Lalo" => "ywt", "Pangwali" => "pgg", "Bashkir" => "bak", "Fataleka" => "far", "Nzakambay" => "nzy", "Jumla Sign Language" => "jus", "Ucayali-Yurúa Ashéninka" => "cpb", "Ketum" => "ktt", "Chewa" => "nya", "Naga Pidgin" => "nag", "Tabla" => "tnm", "Tauade" => "ttd", "Veddah" => "ved", "Old Turkish" => "otk", "Western Mashan Miao" => "hmw", "Southwestern Nisu" => "nsv", "Jiongnai Bunu" => "pnu", "Southern Balochi" => "bcc", "Phoenician" => "phn", "Yitha Yitha" => "xth", "Western Magar" => "mrd", "Lanoh" => "lnh", "Nadruvian" => "ndf", "Pyu" => "pyx", "Laopang" => "lbg", "Coatlán Zapotec" => "zps", "Scots" => "sco", "Brooke's Point Palawano" => "plw", "West Central Banda" => "bbp", "Yangben" => "yav", "Barzani Jewish Neo-Aramaic" => "bjf", "Kadazan Dusun" => "dtp", "Wan" => "wan", "Tiruray" => "tiy", "Kamula" => "xla", "Yerong" => "yrn", "Ghayavi" => "bmk", "Tataltepec Chatino" => "cta", "Yinbaw Karen" => "kvu", "Istro Romanian" => "ruo", "Yinwum" => "yxm", "Southern Rincon Zapotec" => "zsr", "Lishanid Noshan" => "aij", "Nagumi" => "ngv", "Ebira" => "igb", "Mansoanka" => "msw", "Sarudu" => "sdu", "Algerian Jewish Sign Language" => "ajs", "Ura" => "uur", "Sheko" => "she", "Kioko" => "ues", "Tiemacèwè Bozo" => "boo", "Akwa" => "akw", "Mende" => "sim", "Yemba" => "ybb", "Buru" => "mhs", "Palula" => "phl", "Hadrami" => "xhd", "Itik" => "itx", "Jad" => "jda", "Juang" => "jun", "Kazukuru" => "kzk", "Ts'ün-Lao" => "tsl", "Gumawana" => "gvs", "Tavoyan" => "tvn", "Kalagan" => "kqe", "Ashéninka Perené" => "prq", "Goreng" => "xgg", "Balanta-Ganja" => "bjt", "Pottangi Ollar Gadaba" => "gdb", "Mlomp" => "mlo", "Musom" => "msu", "Anu-Hkongso Chin" => "anl", "Lakha" => "lkh", "Shawnee" => "sjw", "Turks And Caicos Creole English" => "tch", "Tahltan" => "tht", "Gail" => "gic", "Warungu" => "wrg", "Zou" => "zom", "Xavánte" => "xav", "Tai Nüa" => "tdd", "Tanacross" => "tcb", "Tsou" => "tsu", "Majera" => "xmj", "Lojban" => "jbo", "Ogea" => "eri", "Dhanggatti" => "dyn", "Wangkatha" => "pti", "Venetic" => "xve", "Argentine Sign Language" => "aed", "Luchazi" => "lch", "Vurës" => "msn", "Urumi" => "uru", "Eastern Acipa" => "acp", "Dorig" => "wwo", "Serbo-Croatian" => "hbs", "Wiyot" => "wiy", "Sawknah" => "swn", "Tachoni" => "lts", "Southwest Tanna" => "nwi", "Bada" => "bhz", "Eastern Frisian" => "frs", "Tsogo" => "tsv", "Poumei Naga" => "pmx", "Sonsorol" => "sov", "Vasekele" => "vaj", "Kouya" => "kyf", "Vemgo-Mabas" => "vem", "Uighur" => "uig", "Catawba" => "chc", "Popti'" => "jac", "Latundê" => "ltn", "Anambé" => "aan", "Xârâcùù" => "ane", "Lealao Chinantec" => "cle", "Pichis Ashéninka" => "cpu", "Merey" => "meq", "Kumbaran" => "wkb", "Pushto" => "pus", "Tiv" => "tiv", "Lele" => "lln", "Yuqui" => "yuq", "Tai Yo" => "tyj", "Talondo'" => "tln", "Iamalele" => "yml", "Kemiehua" => "kfj", "Michigamea" => "cmm", "Batuley" => "bay", "Sìcìté Sénoufo" => "sep", "Gazi" => "gzi", "Kiorr" => "xko", "Dass" => "dot", "Lamogai" => "lmg", "Cajun French" => "frc", "Nyole" => "nuj", "Onjob" => "onj", "Roma" => "rmm", "Maore Comorian" => "swb", "Iberian" => "xib", "Yamap" => "ymp", "Haeke" => "aek", "Montenegrin" => "cnr", "Kaninuwa" => "wat", "Dyan" => "dya", "Adhola" => "adh", "Sissala" => "sld", "Lower Nossob" => "nsb", "Barakai" => "baj", "Barombi" => "bbi", "Temuan" => "tmw", "Atikamekw" => "atj", "Duungooma" => "dux", "Ibani" => "iby", "Teke-Nzikou" => "nzu", "Yuru" => "ljx", "Maritime Sign Language" => "nsr", "Silt'e" => "stv", "Yidgha" => "ydg", "Gikyode" => "acd", "Xokleng" => "xok", "Etchemin" => "etc", "Saraiki" => "skr", "Ngelima" => "agh", "Perai" => "wet", "Pendau" => "ums", "Chru" => "cje", "Laha" => "lhh", "Selungai Murut" => "slg", "Tai Laing" => "tjl", "Vasavi" => "vas", "Lawunuia" => "tgi", "Huallaga Huánuco Quechua" => "qub", "Pela" => "bxd", "Sochiapam Chinantec" => "cso", "Ahom" => "aho", "Reel" => "atu", "Intha" => "int", "Yawiyo" => "ybx", "Keliko" => "kbo", "Media Lengua" => "mue", "Red Gelao" => "gir", "Kharia Thar" => "ksy", "Domari" => "rmt", "Western Subanon" => "suc", "Naukan Yupik" => "ynk", "Kyenele" => "kql", "Mawa" => "wma", "Western Muria" => "mut", "Kaskean" => "zsk", "Lahu" => "lhu", "Parauk" => "prk", "Yan-nhaŋu Sign Language" => "yhs", "Haroti" => "hoj", "Defaka" => "afn", "Karakhanid" => "xqa", "Carolinian" => "cal", "Salumá" => "slj", "Eastern Gorkha Tamang" => "tge", "Mittu" => "mwu", "Ersu" => "ers", "Nunggubuyu" => "nuy", "Biritai" => "bqq", "Naka'ela" => "nae", "Hu" => "huo", "Ikulu" => "ikl", "Havasupai-Walapai-Yavapai" => "yuf", "Tala" => "tak", "Karas" => "kgv", "Sakizaya" => "szy", "Buhid" => "bku", "Tawara" => "twl", "Liabuku" => "lix", "Lipan Apache" => "apl", "Fiwaga" => "fiw", "Romany" => "rom", "Abinomn" => "bsa", "Kumbewaha" => "xks", "Chang Naga" => "nbc", "Baharna Arabic" => "abv", "Umiida" => "xud", "Kwambi" => "kwm", "Langnian Buyang" => "yln", "Old Khmer" => "okz", "Itzá" => "itz", "Sukuma" => "suk", "Croatia Sign Language" => "csq", "Ayautla Mazatec" => "vmy", "Misima-Panaeati" => "mpx", "Omurano" => "omu", "Mandaic" => "mid", "Nyamwezi" => "nym", "Romanian" => "ron", "Francoprovençal" => "frp", "Diriku" => "diu", "Hawai'i Creole English" => "hwc", "Kimbundu" => "kmb", "Suundi" => "sdj", "Masana" => "mcn", "Udi" => "udi", "Phuza" => "ypz", "Adai" => "xad", "Xârâgurè" => "axx", "Seze" => "sze", "Swedish Sign Language" => "swl", "Ile Ape" => "ila", "Yavitero" => "yvt", "Uru-Pa-In" => "urp", "Kulfa" => "kxj", "Mbalanhu" => "lnb", "Marúbo" => "mzr", "Bipi" => "biq", "Pom" => "pmo", "Kuuku-Ya'u" => "kuy", "Sangisari" => "sgr", "Agwagwune" => "yay", "Epi-Olmec" => "xep", "Geser-Gorom" => "ges", "Southern Guiyang Hmong" => "hmy", "Kufr Qassem Sign Language" => "sqx", "Gimnime" => "gmn", "Rapanui" => "rap", "Anjam" => "boj", "Even" => "eve", "Kaningdon-Nindem" => "kdp", "Neverver" => "lgk", "Kuanua" => "ksd", "Logol" => "lof", "Wetamut" => "wwo", "Shark Bay" => "ssv", "Shubi" => "suj", "Dan" => "dnj", "Kokoda" => "xod", "Lavatbura-Lamusong" => "lbv", "Takwane" => "tke", "Wanyi" => "wny", "Remontado Dumagat" => "agv", "Assiniboine" => "asb", "Tinani" => "lbf", "Bigambal" => "xbe", "Minigir" => "bxf", "Jiarong" => "jya", "Kabore One" => "onk", "Sarsi" => "srs", "Yawa" => "yva", "Chamacoco" => "ceg", "Min Nan Chinese" => "nan", "Bit" => "bgk", "Napo Lowland Quechua" => "qvo", "Yami" => "tao", "Galatian" => "xga", "Nobonob" => "gaw", "Nimo" => "niw", "Xicotepec De Juárez Totonac" => "too", "Lucumi" => "luq", "Northern Thai" => "nod", "Old Manipuri" => "omp", "Kayan River Kayan" => "xkn", "Hungarian" => "hun", "Kami" => "kmi", "Makuráp" => "mpu", "Cwi Bwamu" => "bwy", "Eggon" => "ego", "Enya" => "gey", "Kisankasa" => "kqh", "Mandobo Atas" => "aax", "Ngalum" => "szb", "Emberá-Tadó" => "tdc", "South Slavey" => "xsl", "Isoko" => "iso", "Yandruwandha" => "ynd", "Wapan" => "juk", "Kiswahili" => "swh", "Tofanma" => "tlg", "Pahlavi" => "pal", "Bagusa" => "bqb", "Tontemboan" => "tnt", "Low German" => "nds", "Central Bai" => "bca", "Chichewa" => "nya", "Kuku-Ugbanh" => "ugb", "Woun Meu" => "noa", "Pakistan Sign Language" => "pks", "Akpes" => "ibe", "Mabaka Valley Kalinga" => "kkg", "Dhundari" => "dhd", "Baltic Romani" => "rml", "Valencian Sign Language" => "vsv", "Mor" => "moq", "Kofyar" => "kwl", "Mbala" => "mdp", "Washo" => "was", "Ajiya" => "idc", "Mamboru" => "mvd", "Una" => "mtg", "Apalachee" => "xap", "Dubli" => "dub", "Pémono" => "pev", "West Kewa" => "kew", "Kokola" => "kzn", "Biloxi" => "bll", "Central Subanen" => "syb", "Cuba" => "cbq", "Varli" => "vav", "Lisabata-Nuniali" => "lcs", "Chol" => "ctu", "Ndonde Hamba" => "njd", "Arguni" => "agf", "Buna" => "bvn", "Tingui-Boto" => "tgv", "Narango" => "nrg", "Bamenyam" => "bce", "Munit" => "mtc", "Kuku-Mangk" => "xmq", "Bangba" => "bbe", "Ngadjuri" => "jui", "Yucatec Maya Sign Language" => "msd", "Mesmes" => "mys", "Paasaal" => "sig", "Gata'" => "gaq", "Komba" => "kpf", "Silopi" => "xsp", "Wariyangga" => "wri", "Wè Southern" => "gxx", "Ninia Yali" => "nlk", "Southern Qiandong Miao" => "hms", "Hemba" => "hem", "Idoma" => "idu", "Island Carib" => "crb", "Mmen" => "bfm", "Eastern Huasteca Nahuatl" => "nhe", "Heyo" => "auk", "Canela" => "ram", "Krymchak" => "jct", "East Yugur" => "yuy", "Northeastern Thai" => "tts", "Mayi-Yapi" => "xyj", "Ná-Meo" => "neo", "Wali" => "wlx", "Ngarigu" => "xni", "Mbandja" => "zmz", "Momina" => "mmb", "Fembe" => "agl", "Uya" => "usu", "Barambu" => "brm", "Lambadi" => "lmn", "Punan Tubu" => "puj", "Biao" => "byk", "Lakkia" => "lbc", "Uneapa" => "bbn", "Talu" => "yta", "Glavda" => "glw", "Hula" => "hul", "Idi" => "idi", "Binandere" => "bhg", "Belize Kriol English" => "bzj", "Bidjara" => "bym", "Nyabwa" => "nwb", "Ida'an" => "dbj", "Kandawo" => "gam", "Bitur" => "mcc", "Pai Tavytera" => "pta", "Nauru" => "nau", "Andoque" => "ano", "Korandje" => "kcy", "Nubaca" => "baf", "Brunca Sign Language" => "rnb", "Colorado" => "cof", "Neme" => "nex", "Chuvantsy" => "xcv", "Lefa" => "lfa", "Phuma" => "ypm", "Fala" => "fax", "Kulon" => "uon", "Fasu" => "faa", "Ndumu" => "nmd", "Tlacoapa Tlapanec" => "tpl", "Wab" => "wab", "Marik" => "dad", "East Berawan" => "zbe", "Northern Rengma Naga" => "nnl", "Tchitchege" => "tck", "Ga" => "gaa", "Peerapper" => "xpw", "Nyarafolo Senoufo" => "sev", "Hruso" => "hru", "Maay" => "ymm", "Imbongu" => "imo", "Balinese Malay" => "mhp", "Touo" => "tqu", "Tzeltal" => "tzh", "Central Cagayan Agta" => "agt", "Khehek" => "tlx", "Ayere" => "aye", "Bannoni" => "bcm", "Guinean Sign Language" => "gus", "Geme" => "geq", "Xaasongaxango" => "kao", "Naasioi" => "nas", "Karuwali" => "rxw", "Katawixi" => "xat", "Ese" => "mcq", "Wumbvu" => "wum", "Western Canadian Inuktitut" => "ikt", "Pimbwe" => "piw", "Border Kuna" => "kvn", "Angaataha" => "agm", "Kunigami" => "xug", "Auyokawa" => "auo", "Awjilah" => "auj", "Pagi" => "pgi", "Northern Puebla Nahuatl" => "ncj", "Machinga" => "mvw", "Solong" => "aaw", "Sialum" => "slw", "Andai" => "afd", "Nda'nda'" => "nnz", "Laomian" => "lwm", "Australian Aborigines Sign Language" => "asw", "Ali" => "aiy", "Paicî" => "pri", "Siyin Chin" => "csy", "Gupapuyngu" => "guf", "Pal" => "abw", "Pyapun" => "pcw", "Bushoong" => "buf", "Ambelau" => "amv", "Lamaholot" => "slp", "Kaang Chin" => "ckn", "Burui" => "bry", "Orma" => "orc", "Tigre" => "tig", "Yecuatla Totonac" => "tlc", "Ngindo" => "nnq", "Yamongeri" => "ymg", "Montagnais" => "moe", "Monsang Naga" => "nmh", "Luo" => "luw", "Katkari" => "kfu", "Kogi" => "kog", "Kok-Nar" => "gko", "Lillooet" => "lil", "Namo" => "mxw", "Nomatsiguenga" => "not", "Central Khmer" => "khm", "Ruund" => "rnd", "Tunia" => "tug", "Southern Pame" => "pmz", "Kodia" => "kwp", "Ratahan" => "rth", "Ngunawal" => "xul", "Natügu" => "ntu", "Amdang" => "amj", "Phong-Kniang" => "pnx", "Gbii" => "ggb", "Eki" => "eki", "Sarua" => "swy", "Manding" => "man", "Gboloo Grebo" => "gec", "Nimboran" => "nir", "Porohanon" => "prh", "Karang" => "kzr", "Apatani" => "apt", "Coyutla Totonac" => "toc", "Yombe" => "yom", "Övdalian" => "ovd", "Chhintange" => "ctn", "Toaripi" => "tqo", "Northern Huishui Hmong" => "hmi", "Sari" => "asj", "Illyrian" => "xil", "Western Tawbuid" => "twb", "Bima" => "bhp", "Arhö" => "aok", "Coos" => "csz", "Austrian Sign Language" => "asq", "Southern Samo" => "sbd", "Yalunka" => "yal", "Yucuna" => "ycn", "Kota" => "koq", "Zaachila Zapotec" => "ztx", "Koorete" => "kqy", "Limi" => "ylm", "Brunei Bisaya" => "bsb", "Lodhi" => "lbm", "Chitwania Tharu" => "the", "Usui" => "usi", "Ir" => "irr", "Bakhtiari" => "bqi", "Ezaa" => "eza", "Wadjigu" => "wdu", "Kagan Kalagan" => "kll", "Cameroon Mambila" => "mcu", "Central Sama" => "sml", "Irula" => "iru", "Auslan" => "asf", "Aneityum" => "aty", "Diri" => "dwa", "Kwandu" => "xdo", "Gwichʼin" => "gwi", "Minidien" => "wii", "Beele" => "bxq", "Hernican" => "xhr", "Eastern Parbate Kham" => "kif", "Banao Itneg" => "bjx", "Hamer-Banna" => "amf", "Hoti" => "hti", "Danish Sign Language" => "dsl", "Obo Manobo" => "obo", "Nicaraguan Sign Language" => "ncs", "Sudovian" => "xsv", "Lardil" => "lbz", "Numanggang" => "nop", "Avatime" => "avn", "Uyghur" => "uig", "Kalapuya" => "kyl", "Garhwali" => "gbm", "Timugon Murut" => "tih", "Taiwan Sign Language" => "tss", "Bwa" => "bww", "Samay" => "syx", "Plautdietsch" => "pdt", "Thracian" => "txh", "Buglere" => "sab", "Tai Loi" => "tlq", "Undetermined" => "und", "Logorik" => "liu", "Duke" => "nke", "Ngayawung" => "nwg", "Prasuni" => "prn", "Arikapú" => "ark", "Western Meohang" => "raf", "Yuki" => "yuk", "Lamu" => "llh", "Dongotono" => "ddd", "Nzanyi" => "nja", "Rapa" => "ray", "Jaitmatang" => "xjt", "Santa Inés Yatzechi Zapotec" => "zpn", "Shumcho" => "scu", "Dogoso" => "dgs", "Dongo" => "doo", "Dhivehi" => "div", "Miu" => "mpo", "Timor Pidgin" => "tvy", "Kanga" => "kcp", "Korean" => "kor", "Cuiba" => "cui", "Njyem" => "njy", "Lule" => "ule", "Mekwei" => "msf", "Western Xiangxi Miao" => "mmr", "Malaysian Sign Language" => "xml", "Zambian Sign Language" => "zsl", "Yahang" => "rhp", "Afghan Sign Language" => "afg", "Kohin" => "kkx", "Sri Lankan Sign Language" => "sqs", "Wushi" => "bse", "Koresh-e Rostam" => "okh", "Manumanaw Karen" => "kxf", "Tsamai" => "tsb", "Roviana" => "rug", "East Nyala" => "nle", "Ngbaka" => "nga", "Guana" => "gva", "Allar" => "all", "Ndom" => "nqm", "Karok" => "kyh", "Wakawaka" => "wkw", "Onobasulu" => "onn", "Amanab" => "amn", "Diebroud" => "tbp", "Salawati" => "xmx", "Pinai-Hagahai" => "pnn", "Mongolian" => "mon", "Mabire" => "muj", "Manide" => "abd", "Olutsotso" => "lto", "Ruthenian" => "rsk", "Isanzu" => "isn", "Kung" => "kfl", "Sengo" => "spk", "Rudbari" => "rdb", "Sardinian" => "srd", "Sere" => "swf", "Zakhring" => "zkr", "Koda" => "cdz", "Bugun" => "bgg", "Jawe" => "jaz", "Shuar" => "jiv", "Maslam" => "msv", "Mannan" => "mjv", "Ndendeule" => "dne", "Kanjari" => "kft", "Ngomba" => "jgo", "Tewe" => "twx", "Citak" => "txt", "Northern Binukidnon" => "kyn", "Pear" => "pcb", "Arapaso" => "arj", "Wagdi" => "wbr", "Pije" => "piz", "Manumanaw" => "kxf", "Urimo" => "urx", "Khamti" => "kht", "Chewong" => "cwg", "Mser" => "kqx", "Arta" => "atz", "Hungworo" => "nat", "Kurudu" => "kjr", "Miyobe" => "soy", "Nancere" => "nnc", "Tłı̨chǫ" => "dgr", "Nduga" => "ndx", "Sebop" => "sib", "Dirim" => "dir", "Awar" => "aya", "Gabri" => "gab", "Alabama" => "akz", "Slovenian" => "slv", "Doutai" => "tds", "Warlpiri" => "wbp", "Haryanvi" => "bgc", "Siwai" => "siw", "Timucua" => "tjm", "Kashubian" => "csb", "Dieri" => "dif", "Algerian Arabic" => "arq", "Western Katu" => "kuf", "Aguna" => "aug", "Tena" => "bfe", "Chhattisgarhi" => "hne", "Qau" => "gqu", "Jogi" => "jog", "Kowiai" => "kwh", "Au" => "avt", "Rejang Kayan" => "ree", "Yala" => "yba", "Kaikadi" => "kep", "Kwakum" => "kwu", "Lendu" => "led", "Khayo" => "lko", "Mak" => "pbl", "Lachiguiri Zapotec" => "zpa", "Papuan Malay" => "pmy", "Movima" => "mzp", "Pisaflores Tepehua" => "tpp", "Seta" => "stf", "Orang Kanaq" => "orn", "Liana-Seti" => "ste", "Matya Samo" => "stj", "Bunun" => "bnn", "Fataluku" => "ddg", "Wadaginam" => "wdg", "Kashaya" => "kju", "Mapos Buang" => "bzh", "Bora" => "boa", "Murrinh-Patha" => "mwf", "Keyagana" => "kyg", "Ngasa" => "nsg", "Basque" => "eus", "Kistane" => "gru", "Berau Malay" => "bve", "Lovono" => "vnk", "Doghoro" => "dgx", "Nete" => "net", "Yora" => "mts", "Old Dutch" => "odt", "Miyako" => "mvi", "Volscian" => "xvo", "Finnish" => "fin", "Turoyo" => "tru", "Piscataway" => "psy", "Miya" => "mkf", "Ngam" => "nmc", "Western Penan" => "pne", "Ulumanda'" => "ulm", "Petapa Zapotec" => "zpe", "Moba" => "mfq", "Wané" => "hwa", "Kobo" => "okc", "Belanda Bor" => "bxb", "Aheu" => "thm", "Zanaki" => "zak", "Paumarí" => "pad", "Busa" => "bqp", "Laro" => "lro", "Maxi Gbe" => "mxl", "Weh" => "weh", "Mamaa" => "mhf", "Zumaya" => "zuy", "Hinduri" => "hii", "Munggui" => "mth", "Tinigua" => "tit", "Tacahua Mixtec" => "xtt", "Ngurmbur" => "nrx", "Afghan Persian" => "prs", "Tumbuka" => "tum", "Lopit" => "lpx", "Hakka Chinese" => "hak", "Suabo" => "szp", "Diyari" => "dif", "Likila" => "lie", "Zemba" => "dhm", "Awun" => "aww", "Chuka" => "cuh", "Basa" => "bzw", "Bieria" => "brj", "Hunde" => "hke", "Serudung Murut" => "srk", "Wuzlam" => "udl", "Bum" => "bmv", "Bunganditj" => "xbg", "Angaité" => "aqt", "Bepour" => "bie", "suomenruotsalainen viittomakieli" => "fss", "Mayo" => "mfy", "Kwanga" => "kwj", "Isthmus-Cosoleacaque Nahuatl" => "nhk", "Old French" => "fro", "Winyé" => "kst", "Foodo" => "fod", "Gumalu" => "gmu", "Foau" => "flh", "Youjiang Zhuang" => "zyj", "Emberá-Baudó" => "bdc", "Lenkau" => "ler", "Orokaiva" => "okv", "Benggoi" => "bgy", "Bamukumbit" => "bqt", "Alangan" => "alj", "Southern Mnong" => "mnn", "Sierra Negra Nahuatl" => "nsu", "Southern Sorsoganon" => "srv", "Southern Toussian" => "wib", "Tereweng" => "twg", "Comaltepec Chinantec" => "cco", "Mbugu" => "mhd", "Orowe" => "bpk", "Bonjo" => "bok", "Eastern Lawa" => "lwl", "Seget" => "sbg", "Yawijibaya" => "jbw", "Mohave" => "mov", "Maru" => "mhx", "Legbo" => "agb", "Sô" => "sss", "Dido" => "ddo", "Isarog Agta" => "agk", "Fiji Hindi" => "hif", "Oko-Juwoi" => "okj", "Edera Awyu" => "awy", "Usan" => "wnu", "Kapya" => "klo", "Loxicha Zapotec" => "ztp", "Ibibio" => "ibb", "Vano" => "vnk", "Likwala" => "kwc", "Baga Kaloum" => "bqf", "Southern Catanduanes Bikol" => "bln", "Kamasau" => "kms", "Yugoslavian Sign Language" => "ysl", "Xadani Zapotec" => "zax", "Baha Buyang" => "yha", "Bonkeng" => "bvg", "Sarli" => "sdf", "Sened" => "sds", "Tagal Murut" => "mvv", "Emumu" => "enr", "Gheg Albanian" => "aln", "Malak Malak" => "mpb", "Straits Salish" => "str", "Llengua de signes valenciana" => "vsv", "Malay" => "zlm", "Litzlitz" => "lzl", "Shehri" => "shv", "Western Sisaala" => "ssl", "Yareni Zapotec" => "zae", "Ambonese Malay" => "abs", "Gadsup" => "gaj", "Galolen" => "gal", "Kamviri" => "xvi", "Hopi" => "hop", "Yale" => "nce", "Urartian" => "xur", "Makonde" => "kde", "Bo-Ung" => "mux", "Salinan" => "sln", "Mescalero-Chiricahua Apache" => "apm", "Mali" => "gcc", "Ma'di" => "mhi", "Sissano" => "sso", "Mayaguduna" => "xmy", "Faire Atta" => "azt", "Mawchi" => "mke", "Achang" => "acn", "Sur" => "tdl", "Somba-Siawari" => "bmu", "Naba" => "mne", "Wamas" => "wmc", "Ngala" => "nud", "Hehe" => "heh", "Noiri" => "noi", "Potawatomi" => "pot", "Koenoem" => "kcs", "Sri Lankan Creole Malay" => "sci", "Pindiini" => "pti", "Zinza" => "zin", "Sivandi" => "siy", "Bats" => "bbl", "Tembo" => "tmv", "San Baltazar Loxicha Zapotec" => "zpx", "Honduras Sign Language" => "hds", "Komo" => "xom", "Tebul Ure Dogon" => "dtu", "Dondo" => "dok", "Guanyinqiao" => "jiq", "Pictish" => "xpi", "Miani" => "pla", "Mising" => "mrg", "Yamba" => "yam", "Middle Welsh" => "wlm", "Pei" => "ppq", "Tawang Monpa" => "twm", "N'Ko" => "nqo", "Tezoatlán Mixtec" => "mxb", "Aghu" => "ahh", "Siawi" => "mmp", "Nahavaq" => "sns", "Tjurruru" => "tju", "Zari" => "zaz", "Sou" => "sqq", "Central Melanau" => "mel", "Karitiâna" => "ktn", "Ejamat" => "eja", "Dacian" => "xdc", "Acatepec Me'phaa" => "tpx", "Kupa" => "kug", "Yei" => "jei", "Blablanga" => "blp", "Nateni" => "ntm", "Daloa Bété" => "bev", "Kaansa" => "gna", "Baikeno" => "bkx", "Razajerdi" => "rat", "Tafi" => "tcd", "Minokok" => "mqq", "Worodougou" => "jud", "Ngaing" => "nnf", "San Miguel El Grande Mixtec" => "mig", "Pano" => "mqz", "Ninzo" => "nin", "Teor" => "tev", "Central Palawano" => "plc", "Yine" => "pib", "Budukh" => "bdk", "Tegali" => "ras", "Afrikaans" => "afr", "Surayt" => "tru", "Fayu" => "fau", "Bierebo" => "bnk", "Sekapan" => "skp", "Nuu-chah-nulth" => "nuk", "Panim" => "pnr", "Naha'ai" => "mlx", "Koki Naga" => "nxk", "Maco" => "wpc", "Agutaynen" => "agn", "Saho" => "ssy", "Centúúm" => "cet", "Digo" => "dig", "Kupang Malay" => "mkn", "Lolopo" => "ycl", "Tiwa" => "lax", "Rusyn" => "rue", "Tapirapé" => "taf", "Moloko" => "mlw", "Ten'edn" => "tnz", "Marovo" => "mvo", "Dagbani" => "dag", "Davawenyo" => "daw", "Santa María Quiegolani Zapotec" => "zpi", "Gobu" => "gox", "Mapoyo" => "mcg", "Asturian" => "ast", "Eastern Bontok" => "ebk", "Ponyo-Gongwang Naga" => "npg", "Nukumanu" => "nuq", "Bilma Kanuri" => "bms", "Kw'adza" => "wka", "Zhoa" => "zhw", "Kanyok" => "kny", "Gwahatike" => "dah", "Phuie" => "pug", "Goan Konkani" => "gom", "Arikem" => "ait", "Mandari" => "mqu", "Onin" => "oni", "Pakanha" => "pkn", "Cayuse" => "xcy", "Koguryo" => "zkg", "Aimaq" => "aiq", "Mel-Khaonh" => "hkn", "Panchpargania" => "tdb", "Maii" => "mmm", "Omok" => "omk", "Ntcham" => "bud", "Inuit Sign Language" => "iks", "Sartang" => "onp", "Yoy" => "yoy", "Iaai" => "iai", "Asaro'o" => "mtv", "Nottoway" => "ntw", "Ifo" => "iff", "Beba" => "bfp", "Tiale" => "mnl", "Akyaung Ari Naga" => "nqy", "Bwile" => "bwc", "Lipo" => "lpo", "Northern Bobo Madaré" => "bbo", "Tayo" => "cks", "Kayapa Kallahan" => "kak", "Sentinel" => "std", "Cuyonon" => "cyo", "Capanahua" => "kaq", "Sara Kaba" => "sbz", "Fum" => "fum", "Vaghri" => "vgr", "Southeast Ambrym" => "tvk", "Yana" => "ynn", "Mian" => "mpt", "Fyer" => "fie", "Elymian" => "xly", "Khana" => "ogo", "Jeh" => "jeh", "Ukrainian Sign Language" => "ukl", "Chimariko" => "cid", "Sakalava Malagasy" => "skg", "Wajuk" => "xwj", "Djangun" => "djf", "Kube" => "kgf", "Mesqan" => "mvz", "Ambulas" => "abt", "Runga" => "rou", "Chamicuro" => "ccc", "Ban Khor Sign Language" => "bfk", "Talodi" => "tlo", "Fang" => "fan", "Hupdë" => "jup", "Katla" => "kcr", "Kambaira" => "kyy", "Pashto" => "pus", "Twana" => "twa", "Coyotepec Popoloca" => "pbf", "Galice" => "gce", "Baibai" => "bbf", "Hdi" => "xed", "Lamnso'" => "lns", "Mapidian" => "mpw", "Torwali" => "trw", "Han" => "haa", "Tandia" => "tni", "Wik-Mungkan" => "wim", "Baybayanon" => "bvy", "Sinicized Miao" => "hmz", "Ramoaaina" => "rai", "Oko-Eni-Osayen" => "oks", "Nama" => "nmx", "Southeastern Tepehuan" => "stp", "Gogo" => "gog", "Hutterite German" => "geh", "Brunei" => "kxd", "Sierra Leone Sign Language" => "sgx", "Tok Pisin" => "tpi", "Toromono" => "tno", "Harijan Kinnauri" => "kjo", "Ngaju" => "nij", "Wergaia" => "weg", "Zia" => "zia", "Namla" => "naa", "Karao" => "kyj", "Samberigi" => "ssx", "Omaha-Ponca" => "oma", "Paakantyi" => "drl", "Bakoko" => "bkh", "Fernando Po Creole English" => "fpe", "Chortí" => "caa", "Dyugun" => "dyd", "Kalanadi" => "wkl", "Axamb" => "ahb", "Tetum" => "tet", "Wayuu" => "guc", "Mono" => "mte", "Yogad" => "yog", "Ngumbi" => "nui", "Omi" => "omi", "Kaapor Sign Language" => "uks", "Palikúr" => "plu", "Gagnoa Bété" => "btg", "Babuza" => "bzg", "Lembena" => "leq", "Olu'bo" => "lul", "Querétaro Otomi" => "otq", "Mayawali" => "yxa", "Nakai" => "nkj", "Gyaazi" => "gyz", "Filomena Mata-Coahuitlán Totonac" => "tlp", "Ewage-Notu" => "nou", "Ugaritic" => "uga", "Koya" => "kff", "Tobian" => "tox", "Mobilian" => "mod", "Rotokas" => "roo", "Salas" => "sgu", "Barikanchi" => "bxo", "Egyptian Arabic" => "arz", "Basa-Gurmana" => "buj", "Kuman" => "qwm", "Western Fijian" => "wyy", "Ternate" => "tft", "Semelai" => "sza", "Ogbronuagum" => "ogu", "Molbog" => "pwm", "Notre" => "bly", "Izon" => "ijc", "Laru" => "lan", "Mboi" => "moi", "Kaburi" => "uka", "Sholaga" => "sle", "Wailapa" => "wlr", "Mai Brat" => "ayz", "Putai" => "mfl", "Melpa" => "med", "Cori" => "cry", "Lese" => "les", "Pangutaran Sama" => "slm", "Petjo" => "pey", "Tavringer Romani" => "rmu", "Southern Ping Chinese" => "csp", "Owa" => "stn", "Vilela" => "vil", "Baoulé" => "bci", "Gilbertese" => "gil", "Wikalkan" => "wik", "Boikin" => "bzf", "Walungge" => "ola", "Sulod" => "srg", "Mabaale" => "mmz", "Bambara" => "bam", "Playero" => "gob", "Ukaan" => "kcf", "Pinyin" => "pny", "Talaandig" => "bkd", "Zulgo-Gemzek" => "gnd", "Pancana" => "pnp", "Dharuk" => "xdk", "Kabwari" => "kcw", "Campidanese Sardinian" => "sro", "Written Oirat" => "xwo", "Lokoya" => "lky", "Paniya" => "pcg", "Gugadj" => "ggd", "Ayacucho Quechua" => "quy", "Waigeo" => "wgo", "Asunción Mixtepec Zapotec" => "zoo", "Unua" => "onu", "Terei" => "buo", "Alyawarr" => "aly", "Kannada Kurumba" => "kfi", "Chinbon Chin" => "cnb", "Nusu" => "nuf", "Gurmana" => "gvm", "Wotjobaluk" => "xwt", "Yalarnnga" => "ylr", "Dugwor" => "dme", "Chicomuceltec" => "cob", "Mama" => "mma", "Zhaba" => "zhb", "Golin" => "gvf", "Mazanderani" => "mzn", "Veps" => "vep", "Samei" => "smh", "Bukat" => "bvk", "Ugandan Sign Language" => "ugn", "Masikoro Malagasy" => "msh", "Okolie" => "oie", "Southern Kiwai" => "kjd", "Poule" => "msl", "Donno So Dogon" => "dds", "Northern Kurdish" => "kmr", "Malalamai" => "mmt", "Djamindjung" => "djd", "North Central Mixe" => "neq", "Wano" => "wno", "Dagba" => "dgk", "Macuna" => "myy", "Bali" => "bcp", "Vincentian Creole English" => "svc", "Uri" => "uvh", "Arhâ" => "aqr", "Northern Muji" => "ymx", "Dusner" => "dsn", "Cowlitz" => "cow", "Nimoa" => "nmw", "Kayan" => "pdu", "Northern Dong" => "doc", "Kolbila" => "klc", "Dicamay Agta" => "duy", "Tabasco Zoque" => "zoq", "Kirya-Konzəl" => "fkk", "Dharumbal" => "xgm", "Belanda Viri" => "bvi", "Doromu-Koki" => "kqc", "Chiga" => "cgg", "Northern Grebo" => "gbo", "Akha" => "ahk", "Iha" => "ihp", "Yaminahua" => "yaa", "Wasembo" => "gsp", "Maleng" => "pkt", "Puragi" => "pru", "Gorakor" => "goc", "Lithuanian" => "lit", "Mpuono" => "zmp", "Bateri" => "btv", "Lyngngam" => "lyg", "Jangshung" => "jna", "Woria" => "wor", "Tabasco Chontal" => "chf", "Tenharim" => "pah", "Krio" => "kri", "Amba" => "utp", "Manggarai" => "mqy", "Phuan" => "phu", "Eastern Abnaki" => "aaq", "Bu-Nao Bunu" => "bwx", "Sewa Bay" => "sew", "Okpamheri" => "opa", "Eitiep" => "eit", "Kwoma" => "kmo", "Nyamwanga" => "mwn", "Oniyan" => "bsc", "Paraguayan Sign Language" => "pys", "Yawalapití" => "yaw", "Sara Kaba Deme" => "kwg", "Koneraw" => "kdw", "Yele" => "yle", "Jingpho" => "kac", "Remo" => "rem", "Teutila Cuicatec" => "cut", "Deori" => "der", "Putoh" => "put", "Croatian" => "hrv", "Barapasi" => "brp", "Tuvalu" => "tvl", "West Berawan" => "zbw", "Konyanka Maninka" => "mku", "Bainouk-Samik" => "bcb", "Dano" => "aso", "South Giziga" => "giz", "Isthmus-Pajapan Nahuatl" => "nhp", "Korur" => "auq", "Kugama" => "kow", "Tabaa Zapotec" => "zat", "Massep" => "mvs", "Pauri Bareli" => "bfb", "Bavarian" => "bar", "Shanga" => "sho", "Cuvok" => "cuv", "Betta Kurumba" => "xub", "French Belgian Sign Language" => "sfb", "Sudanese Arabic" => "apd", "Arikara" => "ari", "Jadgali" => "jdg", "Neyo" => "ney", "Patamona" => "pbc", "Kaiwá" => "kgk", "San Jerónimo Tecóatl Mazatec" => "maa", "Eastern Highland Otomi" => "otm", "Lilau" => "lll", "Ayizi" => "yyz", "Lower Ta'oih" => "tto", "Kawacha" => "kcb", "Jahanka" => "jad", "Maonan" => "mmd", "Gondi" => "gon", "Shatt" => "shj", "Twendi" => "twn", "Bilba" => "bpz", "Toura" => "neb", "Sicel" => "scx", "Dungan" => "dng", "Pokomo" => "pkb", "Bukusu" => "bxk", "San Juan Atzingo Popoloca" => "poe", "Achi" => "acr", "Central Atlas Tamazight" => "tzm", "Susquehannock" => "sqn", "C'Lela" => "dri", "Sambe" => "xab", "Nooksack" => "nok", "Pwapwâ" => "pop", "Vunapu" => "vnp", "Bribri" => "bzd", "El Molo" => "elo", "Highland Totonac" => "tos", "Makah" => "myh", "Lorang" => "lrn", "Makhuwa-Shirima" => "vmk", "Sallands" => "sdz", "Lower Silesian" => "sli", "Wanggom" => "wng", "Kangjia" => "kxs", "Samvedi" => "smv", "Kujarge" => "vkj", "Ekegusii" => "guz", "Mape" => "mlh", "Kaba" => "ksp", "Lumbu" => "lup", "Peranakan Indonesian" => "pea", "Nafi" => "srf", "Western Keres" => "kjq", "Kuthant" => "xut", "Uab Meto" => "aoz", "Ava Guaraní" => "nhd", "Labuk-Kinabatangan Kadazan" => "dtb", "Mocoví" => "moc", "Buksa" => "tkb", "Uru-Eu-Wau-Wau" => "urz", "Nambo" => "ncm", "Eviya" => "gev", "Nyankole" => "nyn", "Beja" => "bej", "Lukabaras" => "lkb", "Tenango Otomi" => "otn", "South Muyu" => "kts", "Shipibo-Conibo" => "shp", "Sepik Iwam" => "iws", "Setaman" => "stm", "Ngendelengo" => "nql", "Tunjung" => "tjg", "Sanapaná" => "spn", "Yeretuar" => "gop", "Irish" => "gle", "Tugen" => "tuy", "Mbyá Guaraní" => "gun", "Kaan" => "ldl", "Haida" => "hai", "Uma' Lasan" => "xky", "Dewas Rai" => "dwz", "Komi" => "kom", "Nyokon" => "nvo", "Amanayé" => "ama", "Koromfé" => "kfz", "Kalaamaya" => "lkm", "Venezuelan Sign Language" => "vsl", "Makhuwa-Saka" => "xsq", "Kuwaataay" => "cwt", "Ede Cabe" => "cbj", "Kadar" => "kej", "Babine" => "bcr", "Hittite" => "hit", "Matambwe" => "wtb", "Mt. Iriga Agta" => "agz", "Judeo-Persian" => "jpr", "Moskona" => "mtj", "Njen" => "njj", "Ngad'a" => "nxg", "Djabwurrung" => "tjw", "Vute" => "vut", "Batanga" => "bnm", "Ami" => "amy", "Sighu" => "sxe", "Bindal" => "xbd", "Cicipu" => "awc", "Wirangu" => "wgu", "Yindjilandji" => "yil", "Langam" => "lnm", "Cruzeño" => "crz", "Ende" => "end", "Ghanaian Sign Language" => "gse", "Higaonon" => "mba", "Turkish Sign Language" => "tsm", "Q'anjob'al" => "kjb", "Stoney" => "sto", "Khorasani Turkish" => "kmz", "Nzima" => "nzi", "Dení" => "dny", "Mbudum" => "xmd", "Tupuri" => "tui", "Tampias Lobu" => "low", "East Kewa" => "kjs", "Che" => "ruk", "Itelmen" => "itl", "Kire" => "geb", "Uamué" => "uam", "Teluti" => "tlt", "Southern Pastaza Quechua" => "qup", "Gitxsan" => "git", "Southern Ma'di" => "snm", "Gavião Do Jiparaná" => "gvo", "Lutachoni" => "lts", "Wasu" => "wsu", "Yakoma" => "yky", "Skepi Creole Dutch" => "skw", "Volapük" => "vol", "Khakas" => "kjh", "Sahu" => "saj", "Wanukaka" => "wnk", "Jorá" => "jor", "Mam" => "mam", "Mundang" => "mua", "Yamdena" => "jmd", "Dawida" => "dav", "Tugutil" => "tuj", "Sindhi Bhil" => "sbn", "Buhutu" => "bxh", "Luang" => "lex", "Southwestern Huishui Miao" => "hmh", "Lanas Lobu" => "ruu", "Auye" => "auu", "Njebi" => "nzb", "Ipalapa Amuzgo" => "azm", "Akar-Bale" => "acl", "Elu" => "elu", "Kigiryama" => "nyf", "Bagheli" => "bfy", "Koshin" => "kid", "Pasi" => "psq", "Northern Bontok" => "rbk", "Kanuri" => "kau", "Plains Indian Sign Language" => "psd", "Selepet" => "spl", "Mamaindé" => "wmd", "Bemba" => "bem", "Lhokpu" => "lhp", "Matukar" => "mjk", "Angkamuthi" => "avm", "Khalaj" => "klj", "Sui" => "swi", "Hahon" => "hah", "Mbum" => "mdd", "Gbari" => "gby", "Northern Bai" => "bfc", "Bedawiyet" => "bej", "Swati" => "ssw", "Itawit" => "itv", "Kalao" => "kly", "Lamboya" => "lmy", "Saamia" => "lsm", "Khezha Naga" => "nkh", "Bonggi" => "bdg", "Flemish" => "nld", "Chukot" => "ckt", "Waioli" => "wli", "Toogee" => "xpx", "Zulu" => "zul", "Balantak" => "blz", "Naluo Yi" => "ylo", "Legenyem" => "lcc", "Chuj" => "cac", "Gajirrabeng" => "gdh", "Guajajára" => "gub", "Kashmiri" => "kas", "Hawai'i Pidgin" => "hwc", "Yámana" => "yag", "Nora" => "nrr", "Irántxe" => "irn", "Kang" => "kyp", "Shi" => "shr", "Mbere" => "mdt", "Lama Bai" => "lay", "Gbaya-Bossangoa" => "gbp", "Northern Altai" => "atv", "Sumau" => "six", "Tutsa Naga" => "tvt", "Subiya" => "sbs", "Wolaytta" => "wal", "Karekare" => "kai", "Tajio" => "tdj", "Vao" => "vao", "Saramaccan" => "srm", "Gokana" => "gkn", "Western Durango Nahuatl" => "azn", "Marghi South" => "mfm", "Waama" => "wwa", "Saleman" => "sau", "Shabak" => "sdb", "Arigidi" => "aqg", "Kriang" => "ngt", "Tauya" => "tya", "Muda" => "ymd", "Koyraboro Senni Songhai" => "ses", "Nyemba" => "nba", "San Pedro Quiatoni Zapotec" => "zpf", "Nggem" => "nbq", "Namonuito" => "nmt", "Ngbaka Manza" => "ngg", "Lamalama" => "lby", "Amri Karbi" => "ajz", "Lower Southern Aranda" => "axl", "Mangole" => "mqc", "Tera" => "ttr", "Wagi" => "fad", "Western Lawa" => "lcp", "Mazagway" => "dkx", "Baram Kayan" => "kys", "Gawri" => "gwc", "Nara" => "nrb", "Sangtam Naga" => "nsa", "Gupa-Abawa" => "gpa", "Kalaallisut" => "kal", "Jamamadí" => "jaa", "Southern Grebo" => "grj", "Coquille" => "coq", "Konongo" => "kcz", "Glio-Oubi" => "oub", "Helambu Sherpa" => "scp", "Younuo Bunu" => "buh", "South African Sign Language" => "sfs", "Tuxá" => "tud", "Kantosi" => "xkt", "Yagwoia" => "ygw", "Aloápam Zapotec" => "zaq", "Diuwe" => "diy", "Damal" => "uhn", "Budu" => "buu", "Pemon" => "aoc", "Ringgou" => "rgu", "Kemak" => "kem", "Arifama-Miniafia" => "aai", "Na-kara" => "nck", "Southern Kurdish" => "sdh", "Gurani" => "hac", "Pa'o Karen" => "blk", "Tichurong" => "tcn", "Tabo" => "knv", "Creek" => "mus", "Wik-Me'anha" => "wih", "Me'en" => "mym", "Machinere" => "mpd", "Wayanad Chetti" => "ctt", "Bontok" => "bnc", "Siri" => "sir", "Ambele" => "ael", "Amarakaeri" => "amr", "Western Highland Chatino" => "ctp", "Kaytetye" => "gbb", "Gbanu" => "gbv", "Bactrian" => "xbc", "Camsá" => "kbh", "Eastern Egyptian Bedawi Arabic" => "avl", "Greek Sign Language" => "gss", "Tektiteko" => "ttc", "Baga Pokur" => "bcg", "Daantanai'" => "lni", "Bandjalang" => "bdy", "Kerak" => "hhr", "Wiradjuri" => "wrh", "Mokati" => "wnb", "Kosarek Yale" => "kkl", "Weyto" => "woy", "Wangkayutyuru" => "wky", "Sawi" => "saw", "Ahwai" => "nfd", "Vafsi" => "vaf", "Taupota" => "tpa", "Ligenza" => "lgz", "Northern Mashan Miao" => "hmp", "Yekora" => "ykr", "Wanggamala" => "wnm", "Isnag" => "isd", "South Picene" => "spx", "Kulung" => "kle", "Raji" => "rji", "Didinga" => "did", "Zaysete" => "zay", "Miluk" => "iml", "Eastern Balochi" => "bgp", "Liangmai Naga" => "njn", "Noy" => "noy", "Kwesten" => "kwt", "Yarsun" => "yrs", "Luiseno" => "lui", "Cook Islands Maori" => "rar", "Shoo-Minda-Nye" => "bcv", "Spanish" => "spa", "Tanjijili" => "uji", "Logooli" => "rag", "Itu Mbon Uzo" => "itm", "Mankanya" => "knf", "Tigak" => "tgc", "Calamian Tagbanwa" => "tbk", "Duvle" => "duv", "Manchu" => "mnc", "Bhaya" => "bhe", "Jarawa" => "anq", "Dulbu" => "dbo", "Sheni" => "scv", "Camunic" => "xcc", "Kyaka" => "kyc", "Mandingo" => "man", "Suoy" => "syo", "Tuwari" => "tww", "Iranun" => "ilp", "Mah Meri" => "mhe", "Tanapag" => "tpv", "Shuhi" => "sxg", "V'ënen Taut" => "nmb", "Caka" => "ckx", "Kaure" => "bpp", "Tebul Sign Language" => "tsy", "Southern Qiang" => "qxs", "Kaningi" => "kzo", "Kiembu" => "ebu", "Mon" => "mnw", "Puyuma" => "pyu", "Jaya" => "jyy", "Atauran" => "adb", "Mawan" => "mcz", "Teke-Tsaayi" => "tyi", "Maca" => "mca", "Pahari" => "phj", "Surigaonon" => "sgd", "Sarikoli" => "srh", "Bassa" => "bsq", "Tai" => "taw", "Indri" => "idr", "Siliput" => "mkc", "Karajá" => "kpj", "Biyo" => "byo", "Nauo" => "nwo", "Kalami" => "gwc", "Emplawas" => "emw", "Harsusi" => "hss", "Eastern Penan" => "pez", "Laragia" => "lrg", "Saniyo-Hiyewe" => "sny", "Ak" => "akq", "Urhobo" => "urh", "Kowaki" => "xow", "Yalakalore" => "xyl", "Mubi" => "mub", "Rotuman" => "rtm", "Mesme" => "zim", "Ombamba" => "mbm", "Hausa Sign Language" => "hsl", "Tidore" => "tvo", "Macaguaje" => "mcl", "ǁGana" => "gnk", "Central Mashan Miao" => "hmm", "Ayu" => "ayu", "Wawonii" => "wow", "Doyayo" => "dow", "Guadeloupean Creole French" => "gcf", "Worrorra" => "wro", "Dupaninan Agta" => "duo", "Squamish" => "squ", "Merwari" => "wry", "Southeastern Kolami" => "nit", "Guanano" => "gvc", "Panobo" => "pno", "Chenapian" => "cjn", "Ngen" => "gnj", "Beneraf" => "bnv", "Peñoles Mixtec" => "mil", "Andra-Hus" => "anx", "Coatepec Nahuatl" => "naz", "Salako" => "knx", "Northern Nisu" => "yiv", "Sajau Basap" => "sjb", "Southern Puebla Mixtec" => "mit", "Kongo" => "kon", "Totoro" => "ttk", "Yilan Creole" => "ycr", "Doso" => "dol", "Mbunda" => "mck", "Wahau Kenyah" => "whk", "Bolivian Sign Language" => "bvl", "Taznatit" => "grr", "Tambotalo" => "tls", "Nteng" => "nqt", "Baba Malay" => "mbf", "Hadothi" => "hoj", "Soli" => "sby", "Sumerian" => "sux", "Cheq Wong" => "cwg", "Samosa" => "swm", "Tikar" => "tik", "Yugambal" => "yub", "Tanudan Kalinga" => "kml", "Waboda" => "kmx", "Dhimal" => "dhi", "Aghul" => "agx", "Dem" => "dem", "Kirghiz" => "kir", "Toraja-Sa'dan" => "sda", "Nepalese Sign Language" => "nsp", "Estado de México Otomi" => "ots", "Jambi Malay" => "jax", "Middle High German" => "gmh", "Khunsari" => "kfm", "Tagdal" => "tda", "Wabo" => "wbb", "Kusaal" => "kus", "Zula" => "zla", "Luwo" => "lwo", "Eruwa" => "erh", "Bubia" => "bbx", "Ese Ejja" => "ese", "Bashkardi" => "bsg", "Kizamani" => "izm", "Doko-Uyanga" => "uya", "Saterfriesisch" => "stq", "Tai Pao" => "tpo", "Banjar" => "bjn", "Geko Karen" => "ghk", "Fuliiru" => "flr", "Ecuadorian Sign Language" => "ecs", "Aranama-Tamique" => "xrt", "Mari" => "mbx", "Tanosy Malagasy" => "txy", "'Ôrôê" => "bpk", "Xiriâna" => "xir", "Chochotec" => "coz", "Katua" => "kta", "Butuanon" => "btw", "Dazaga" => "dzg", "Logir" => "lqr", "Yangkam" => "bsx", "Sabah Malay" => "msi", "Fur" => "fvr", "Jerung" => "jee", "Laven" => "lbo", "Ramopa" => "kjx", "Mariri" => "mqi", "Pilagá" => "plg", "Rikbaktsa" => "rkb", "Kok Borok" => "trp", "Mbonga" => "xmb", "Alcozauca Mixtec" => "xta", "Yinhawangka" => "ywg", "Drubea" => "duf", "Mamulique" => "emm", "Sepedi" => "nso", "Pisidian" => "xps", "Russian" => "rus", "Eastern Durango Nahuatl" => "azd", "Nkangala" => "nkn", "Baga Sitemu" => "bsp", "Kusunda" => "kgg", "Hyam" => "jab", "Simeku" => "smz", "Gapapaiwa" => "pwg", "Northern Betsimisaraka Malagasy" => "bmm", "Ili'uun" => "ilu", "Kuku-Mu'inh" => "xmp", "Taje" => "pee", "Bruny Island Tasmanian" => "xpz", "Kwama" => "kmq", "Karbi" => "mjw", "Pelende" => "ppp", "Poyanáwa" => "pyn", "Palaic" => "plq", "Inapang" => "mzu", "Asháninka" => "cni", "Yis" => "yis", "Awyi" => "auw", "North Giziga" => "gis", "Morori" => "mok", "Rogo" => "rod", "Chichimeca-Jonaz" => "pei", "Yangulam" => "ynl", "Niuatoputapu" => "nkp", "Jumli" => "jml", "Phimbi" => "phm", "Duwet" => "gve", "Lao Naga" => "nlq", "Oriya" => "ory", "Long Wat" => "ttw", "Isabi" => "isa", "Laeko-Libuat" => "lkl", "Mahican" => "mjy", "Miraya Bikol" => "rbl", "Resígaro" => "rgr", "Adilabad Gondi" => "wsg", "Kota Bangun Kutai Malay" => "mqg", "Gbaya" => "krs", "Babatana" => "baa", "Oti" => "oti", "Rinconada Bikol" => "bto", "Aghwan" => "xag", "Keninjal" => "knl", "Arbore" => "arv", "Dima" => "jma", "Ikizu" => "ikz", "Mangarrayi" => "mpc", "Bengkala Sign Language" => "bqy", "Burmeso" => "bzu", "Jalkunan" => "bxl", "Lamba" => "lam", "Ngbaka Ma'bo" => "nbm", "Mayangna" => "yan", "Anufo" => "cko", "Southwestern Huishui Hmong" => "hmh", "Baba" => "bbw", "Fania" => "fni", "San Marcos Tlacoyalco Popoloca" => "pls", "Kakabe" => "kke", "Southwest Pashai" => "psh", "Seeku" => "sos", "Tombonuo" => "txa", "Jordanian Sign Language" => "jos", "Tae'" => "rob", "Lushai" => "lus", "Gabrielino-Fernandeño" => "xgf", "Faiwol" => "fai", "Libinza" => "liz", "Elip" => "ekm", "Mindiri" => "mpn", "Simaa" => "sie", "Hovongan" => "hov", "Kreye" => "xre", "Tepetotutla Chinantec" => "cnt", "Aguacateco" => "agu", "Sumbawa" => "smw", "Tenggarong Kutai Malay" => "vkt", "Kannada" => "kan", "Kumhali" => "kra", "Tiri" => "cir", "Iyo'wujwa Chorote" => "crq", "Kutto" => "kpa", "Welaun" => "wlh", "Guibian Zhuang" => "zgn", "Ladin" => "lld", "Kalanguya" => "kak", "Saudi Arabian Sign Language" => "sdl", "Togbo-Vara Banda" => "tor", "Aruá" => "arx", "Old Chinese" => "och", "Amharic" => "amh", "Dendi" => "deq", "Cumanagoto" => "cuo", "Lakalei" => "lka", "Indonesian" => "ind", "Merei" => "lmb", "Sausi" => "ssj", "Mobumrin Aizi" => "ahm", "Kukele" => "kez", "Maléku Jaíka" => "gut", "Layakha" => "lya", "Banyjima" => "pnw", "Waluwarra" => "wrb", "Parenga" => "pcj", "Ubi" => "ubi", "São Paulo Kaingáng" => "zkp", "Malimpung" => "mli", "Galeya" => "gar", "Yango" => "yng", "Lahul Lohar" => "lhl", "Baan" => "bvj", "Tankarana Malagasy" => "xmv", "Warrwa" => "wwr", "Miriti" => "mmv", "Wunai Bunu" => "bwn", "Menominee" => "mez", "Parthian" => "xpr", "Minderico" => "drc", "Sangkong" => "sgk", "Tlacolulita Zapotec" => "zpk", "Nugunu" => "yas", "Gule" => "gly", "Malango" => "mln", "Ngarluma" => "nrl", "Ute-Southern Paiute" => "ute", "Armazic" => "xrm", "Ancient Aramaic" => "oar", "Gambera" => "gma", "Caribbean Javanese" => "jvn", "Sassarese Sardinian" => "sdc", "Southern Tujia" => "tjs", "Mopán Maya" => "mop", "Mo" => "wkd", "Malba Birifor" => "bfo", "Mararit" => "mgb", "Bimin" => "bhl", "Bila" => "bip", "Mokpwe" => "bri", "Dizin" => "mdx", "Merlav" => "mrm", "Berom" => "bom", "Dhungaloo" => "dhx", "Doka" => "dbi", "Kasua" => "khs", "Mursi" => "muz", "Nungu" => "rin", "Western Arrarnta" => "are", "Totontepec Mixe" => "mto", "Ngungwel" => "ngz", "Vaeakau-Taumako" => "piv", "Bijim" => "jbm", "Middle Watut" => "mpl", "Aja" => "ajg", "Asu" => "aum", "Northern Guiyang Miao" => "huj", "Lihir" => "lih", "Middle Armenian" => "axm", "Gbaya-Mbodomo" => "gmm", "Aiklep" => "mwg", "Shona" => "sna", "Dari" => "prs", "Wikngenchera" => "wua", "ǁAni" => "hnh", "Cacaopera" => "ccr", "Lubu" => "lcf", "Paelignian" => "pgn", "Kui" => "uki", "Pa'a" => "pqa", "Koch" => "kdq", "Stellingwerfs" => "stl", "Uradhi" => "urf", "Gen" => "gej", "Ahanta" => "aha", "Bende" => "bdp", "Yautepec Zapotec" => "zpb", "Laos Sign Language" => "lso", "Gana" => "gnq", "Sedoa" => "tvw", "Macaguán" => "mbn", "Owiniga" => "owi", "Aka-Cari" => "aci", "Mapena" => "mnm", "Chothe Naga" => "nct", "Green Gelao" => "giq", "Guambiano" => "gum", "Banaro" => "byz", "Dengese" => "dez", "Hatam" => "had", "Maskelynes" => "klv", "Lauan" => "llx", "Bago-Kusuntu" => "bqg", "Nisi" => "yso", "Mbariman-Gudhinma" => "zmv", "Dar Sila Daju" => "dau", "Marghi Central" => "mrt", "Upper Saxon" => "sxu", "Tumari Kanuri" => "krt", "Manna-Dora" => "mju", "Senggi" => "snu", "Northern Lendu" => "dno", "Yopno" => "yut", "Záparo" => "zro", "Laki" => "lki", "Mansaka" => "msk", "Kimaragang" => "kqr", "Yanda Dom Dogon" => "dym", "Koiwat" => "kxt", "Shuadit" => "sdt", "Northern Tarahumara" => "thh", "Molima" => "mox", "Southern Tiwa" => "tix", "Maindo" => "cwb", "Ngundu" => "nue", "Sam" => "snx", "Vidunda" => "vid", "Mangseng" => "mbh", "Seba" => "kdg", "Banda-Bambari" => "liy", "Central Bikol" => "bcl", "Bakpinka" => "bbs", "Burarra" => "bvr", "Gbaya-Bozoum" => "gbq", "Rara Bakati'" => "lra", "Shixing" => "sxg", "Southeastern Pomo" => "pom", "Banda-Mbrès" => "bqk", "Southwestern Tarahumara" => "twr", "Bine" => "bon", "Nahali" => "nlx", "Shan" => "shn", "Bodo Parja" => "bdv", "Pouye" => "bye", "Marama" => "lrm", "Punu" => "puu", "Slovak" => "slk", "Yawuru" => "ywr", "Thangmi" => "thf", "Tsonga" => "tso", "Nguluwan" => "nuw", "Iowa-Oto" => "iow", "Anyin" => "any", "Chiru" => "cdf", "Messapic" => "cms", "Thachanadan" => "thn", "Maori" => "mri", "Tlingit" => "tli", "Mayogo" => "mdm", "Aragonese" => "arg", "Nyangatom" => "nnj", "Aneme Wake" => "aby", "Babango" => "bbm", "Kitan" => "zkt", "Central Mazahua" => "maz", "Kwanyama" => "kua", "Ndzwani Comorian" => "wni", "Gejia" => "hmj", "Mambai" => "mcs", "Weme Gbe" => "wem", "Ghari" => "gri", "Bari" => "bfa", "Gvoko" => "ngs", "Pesse" => "pze", "Ganza" => "gza", "Letzeburgesch" => "ltz", "Elamite" => "elx", "Bitare" => "brt", "Laghu" => "lgb", "Northern Uzbek" => "uzn", "Chachi" => "cbi", "Larteh" => "lar", "Muniche" => "myr", "Mal" => "mlf", "Bole" => "bol", "Yanahuanca Pasco Quechua" => "qur", "Batak Toba" => "bbc", "Palya Bareli" => "bpx", "Biyom" => "bpm", "Anfillo" => "myo", "Nyaw" => "nyw", "Sumbwa" => "suw", "Ghanongga" => "ghn", "Tumulung Sisaala" => "sil", "Old Slavonic" => "chu", "Karanga" => "kth", "Haiǁom" => "hgm", "Kagulu" => "kki", "Langue des signes de Belgique Francophone" => "sfb", "Awa" => "vwa", "Ntomba" => "nto", "Adi" => "adi", "Kesawai" => "xes", "Mmaala" => "mmu", "Wewaw" => "wea", "Ndunda" => "nuh", "Lubukusu" => "bxk", "Melo" => "mfx", "Yinchia" => "yin", "Northern Roglai" => "rog", "Sasaru" => "sxs", "Waskia" => "wsk", "Natioro" => "nti", "Tartessian" => "txr", "Sonia" => "siq", "Thai" => "tha", "Mro-Khimi Chin" => "cmr", "Ravula" => "yea", "Siroi" => "ssd", "Dai" => "dij", "Ca̱hungwa̱rya̱" => "nat", "Chadian Arabic" => "shu", "Bajelani" => "bjm", "Boghom" => "bux", "Central Huishui Hmong" => "hmc", "Djimini Senoufo" => "dyi", "Kayardild" => "gyd", "Romblomanon" => "rol", "Irigwe" => "iri", "Uyajitaya" => "duk", "Severn Ojibwa" => "ojs", "Western Tamang" => "tdg", "Montol" => "mtl", "Dehu" => "dhv", "Nshi" => "nsc", "Ibino" => "ibn", "Dibo" => "dio", "Waata" => "ssn", "Kambera" => "xbr", "Doe" => "doe", "Budeh Stieng" => "stt", "Zaza" => "zza", "Qimant" => "ahg", "Kobon" => "kpw", "Bangolan" => "bgj", "Awak" => "awo", "Bukharic" => "bhh", "Bamako Sign Language" => "bog", "Hupa" => "hup", "Pááfang" => "pfa", "Western Panjabi" => "pnb", "Sauraseni Prākrit" => "psu", "Lango" => "lgo", "Kangri" => "xnr", "Koro" => "kxr", "Manx" => "glv", "Sunam" => "ssk", "Atayal" => "tay", "Dargwa" => "dar", "Bwaidoka" => "bwd", "Kisi" => "kiz", "Yidiny" => "yii", "Kwakiutl" => "kwk", "tlhIngan Hol" => "tlh", "Manga Kanuri" => "kby", "Da'a Kaili" => "kzf", "Khengkha" => "xkf", "Yil" => "yll", "Kamberau" => "irx", "Southern One" => "osu", "Gayo" => "gay", "Sicanian" => "sxc", "Moji" => "ymi", "Kobol" => "kgu", "Bondoukou Kulango" => "kzc", "Tuvinian" => "tyv", "San Mateo Del Mar Huave" => "huv", "Gwamhi-Wuri" => "bga", "Wára" => "tci", "Mae" => "mme", "Ririo" => "rri", "Wa" => "wbm", "Manya" => "mzj", "Burunge" => "bds", "Ritharrngu" => "rit", "Rawngtu Chin" => "weu", "Southwestern Tasmanian" => "xpx", "Yugul" => "ygu", "Kuku-Uwanh" => "uwa", "Kudiya" => "kfg", "Nyeu" => "nyl", "Lehalurup" => "urr", "Nomane" => "nof", "Gumuz" => "guk", "Cashinahua" => "cbs", "Sindhi" => "snd", "Bibbulman" => "xbp", "Kulina Pano" => "xpk", "Bau" => "bbd", "Kabutra" => "kbu", "Chané" => "caj", "Kompane" => "kvp", "Kalkoti" => "xka", "Cara" => "cfd", "Eastern Huishui Miao" => "hme", "Wichí Lhamtés Güisnay" => "mzh", "Papasena" => "pas", "Bayot" => "bda", "Dhangu-Djangu" => "dhg", "Kaduo" => "ktp", "Dhudhuroa" => "ddr", "Eastern Apurímac Quechua" => "qve", "Philippine Sign Language" => "psp", "Yahadian" => "ner", "Tobo" => "tbv", "Amblong" => "alm", "Tedim Chin" => "ctd", "Panará" => "kre", "Dir-Nyamzak-Mbarimi" => "nzr", "Sera" => "sry", "Kaluli" => "bco", "Yuracare" => "yuz", "Nekgini" => "nkg", "Kuri" => "nbn", "Ginyanga" => "ayg", "Apurinã" => "apu", "Avá-Canoeiro" => "avv", "Dahalo" => "dal", "Walio" => "wla", "Koho" => "kpm", "Curonian" => "xcu", "Castilian" => "spa", "Khua" => "xhv", "Cotabato Manobo" => "mta", "Nuk" => "noc", "Lufu" => "ldq", "Chiripá" => "nhd", "Ngom" => "nra", "Satawalese" => "stw", "Kim" => "kia", "Nyaheun" => "nev", "Karore" => "xkx", "Mingang Doso" => "mko", "Som" => "smc", "Umpila" => "ump", "Kiput" => "kyi", "Manipuri" => "mni", "Tongwe" => "tny", "Chaldean Neo-Aramaic" => "cld", "Colombian Sign Language" => "csn", "Topoiyo" => "toy", "Kunyi" => "njx", "Huarijio" => "var", "Northwest Pashayi" => "glh", "Djingili" => "jig", "Sinte Romani" => "rmo", "Pholo" => "yip", "Southern Alta" => "agy", "Mfinu" => "zmf", "Haya" => "hay", "Laari" => "ldi", "Ruuli" => "ruc", "Old Ossetic" => "oos", "Blin" => "byn", "Guntai" => "gnt", "Bondei" => "bou", "Sambal" => "xsb", "Assamese" => "asm", "Nihali" => "nll", "Gangte" => "gnb", "Khorezmian" => "zkh", "Sîshëë" => "sih", "Min Dong Chinese" => "cdo", "Bhoti Kinnauri" => "nes", "Byangsi" => "bee", "Holoholo" => "hoo", "Reyesano" => "rey", "Tundra Enets" => "enh", "Piaroa" => "pid", "Jiiddu" => "jii", "Bauwaki" => "bwk", "Mullukmulluk" => "mpb", "Rutul" => "rut", "Imbabura Highland Quichua" => "qvi", "Togoyo" => "tgy", "Totoli" => "txe", "Makhuwa-Marrevone" => "xmc", "Central Maewo" => "mwo", "Dao" => "daz", "Kazakh" => "kaz", "Kwényi" => "kdk", "Pévé" => "lme", "Suri" => "suq", "Penang Sign Language" => "psg", "Baldemu" => "bdn", "Tibetan" => "bod", "Ayerrerenge" => "axe", "Bainouk-Gunyaamolo" => "bcz", "Deccan" => "dcc", "Western Bolivian Guaraní" => "gnw", "Kabardian" => "kbd", "Nkukoli" => "nbo", "Sechelt" => "sec", "Maia" => "sks", "Watam" => "wax", "Warembori" => "wsa", "Karaim" => "kdr", "Anuki" => "aui", "Magɨyi" => "gmg", "Daasanach" => "dsh", "Kungkari" => "lku", "Iban" => "iba", "Martha's Vineyard Sign Language" => "mre", "Tausug" => "tsg", "Eastern Pomo" => "peb", "Anal" => "anm", "Zuni" => "zun", "Manta" => "myg", "Binumarien" => "bjr", "Surjapuri" => "sjp", "us-Saare" => "uss", "Eastern Nisu" => "nos", "Padoe" => "pdo", "Western Maninkakan" => "mlq", "Northern Kalapuya" => "nrt", "Tagoi" => "tag", "Nenge" => "djk", "Central Dusun" => "dtp", "Barbaram" => "vmb", "Yatee Zapotec" => "zty", "Huastec" => "hus", "Mardin Sign Language" => "dsz", "Kalamsé" => "knz", "Katukína" => "kav", "Corsican" => "cos", "Zenzontepec Chatino" => "czn", "Middle Low German" => "gml", "Old Japanese" => "ojp", "Opata" => "opt", "Gbagyi" => "gbr", "Gimme" => "kmp", "Wayampi" => "oym", "Chepang" => "cdm", "Maisin" => "mbq", "Loreto-Ucayali Spanish" => "spq", "Sangil" => "snl", "Deno" => "dbb", "Nigerian Fulfulde" => "fuv", "Kwangali" => "kwn", "Marrithiyel" => "mfr", "Tuwali Ifugao" => "ifk", "Yeyi" => "yey", "Iraya" => "iry", "Wik-Epa" => "wie", "Cayubaba" => "cyb", "Morawa" => "mze", "Ngwaba" => "ngw", "Piya-Kwonci" => "piy", "Sinhala" => "sin", "Tamnim Citak" => "tml", "Zangskari" => "zau", "Tagwana Senoufo" => "tgw", "Nuenonne" => "xpf", "Gudu" => "gdu", "Lower Sorbian" => "dsb", "Sayula Popoluca" => "pos", "Classical Mongolian" => "cmg", "Herero" => "her", "Ayoquesco Zapotec" => "zaf", "Guinea-Bissau Sign Language" => "lgs", "Konabéré" => "bbo", "Tlahuitoltepec Mixe" => "mxp", "Shempire Senoufo" => "seb", "Obanliku" => "bzy", "Mezquital Otomi" => "ote", "Temoq" => "tmo", "Kanju" => "kbe", "Copainalá Zoque" => "zoc", "Old Kentish Sign Language" => "okl", "Kanu" => "khx", "Kenswei Nsei" => "ndb", "Northwest Alaska Inupiatun" => "esk", "Tamasheq" => "taq", "Yucateco" => "yua", "Batad Ifugao" => "ifb", "Wandji" => "wdd", "Anmatyerre" => "amx", "Okiek" => "oki", "Malgana" => "vml", "Guayabero" => "guo", "Lomaiviti" => "lmv", "Nyiha" => "nyr", "Yarluyandi" => "yry", "Arpitan" => "frp", "Aushiri" => "avs", "Tukudede" => "tkd", "Abure" => "abu", "Gorontalo" => "gor", "Birao" => "brr", "Panawa" => "pwb", "Dagik" => "dec", "Gujari" => "gju", "Wejewa" => "wew", "Malawi Lomwe" => "lon", "Carapana" => "cbc", "Meta'" => "mgo", "Tima" => "tms", "Dongshanba Lalo" => "yik", "Koti" => "eko", "Bena" => "yun", "Bonkiman" => "bop", "Baiso" => "bsw", "Sa" => "sax", "Meru" => "mer", "Tigon Mbembe" => "nza", "Tangchangya" => "tnv", "Ughele" => "uge", "Bafanji" => "bfj", "Central Asmat" => "cns", "Rawang" => "raw", "Djabugay" => "dyy", "Rama" => "rma", "Xiri" => "xii", "Kom" => "kmm", "Ambo" => "amb", "Bikya" => "byb", "Tiagbamrin Aizi" => "ahi", "Warwar Feni" => "hrw", "Ajyíninka Apurucayali" => "cpc", "Andoa" => "anb", "Paraguayan Guaraní" => "gug", "Sanggau" => "scg", "Inari Sami" => "smn", "Chilisso" => "clh", "Camling" => "rab", "Wongo" => "won", "Kauwera" => "xau", "Humla" => "hut", "Southern Kalinga" => "ksc", "Old Tibetan" => "otb", "Wendat" => "wdt", "Bukwen" => "buz", "Obokuitai" => "afz", "Macushi" => "mbc", "Gweda" => "grw", "Inupiaq" => "ipk", "Kua" => "tyu", "Binukid" => "bkd", "Kinaray-A" => "krj", "Páez" => "pbb", "Hadza" => "hts", "Gaa" => "ttb", "Gusii" => "guz", "Awara" => "awx", "Woi" => "wbw", "Big Nambas" => "nmb", "Skagit" => "ska", "Yaka" => "yaf", "Toro" => "tdv", "Assyrian Neo-Aramaic" => "aii", "Wogamusin" => "wog", "Amurdak" => "amg", "Mandar" => "mdr", "Swo" => "sox", "Tupinikin" => "tpk", "Kenaboi" => "xbn", "Nubi" => "kcn", "Ineseño" => "inz", "Tagbu" => "tbm", "Tolowa" => "tol", "Hermit" => "llf", "Baré" => "bae", "Himarimã" => "hir", "Northern East Cree" => "crl", "Lyélé" => "lee", "Syenara Senoufo" => "shz", "Al-Sayyid Bedouin Sign Language" => "syy", "Thompson" => "thp", "Tunica" => "tun", "Coastal Konjo" => "kjc", "Tamashek" => "tmh", "Pangasinan" => "pag", "Wangaaybuwan-Ngiyambaa" => "wyb", "Malfaxal" => "mlx", "Leinong Naga" => "lzn", "Chong" => "cog", "Kimaghima" => "kig", "Dhargari" => "dhr", "Dong" => "doh", "Bisu" => "bzi", "Asue Awyu" => "psa", "Bagirmi" => "bmi", "Shangzhai" => "jih", "Sorothaptic" => "sxo", "Ngarrindjeri" => "nay", "Jakati" => "jat", "Haka Chin" => "cnh", "Pazeh" => "pzh", "Snohomish" => "sno", "Tawallammat Tamajaq" => "ttq", "Darang Deng" => "mhu", "Jola-Kasa" => "csk", "Sanumá" => "xsu", "Bribri Sign Language" => "rib", "Sepa" => "spe", "Nganakarti" => "xnk", "Moni" => "mnz", "Malimba" => "mzd", "Kamba" => "kam", "Gbesi Gbe" => "gbs", "Puebla Mazatec" => "pbm", "Wojenaka" => "jod", "Tuxináwa" => "tux", "Baga Koga" => "bgo", "Hote" => "hot", "Kaikavian Literary Language" => "kjv", "Kuy" => "kdt", "Guugu Yimidhirr" => "kky", "Tyap" => "kcg", "Teke-Tege" => "teg", "North Babar" => "bcd", "Mundani" => "mnf", "Katso" => "kaf", "South Fali" => "fal", "Abu' Arapesh" => "aah", "Kachok" => "xkk", "Burmbar" => "vrt", "Garrwa" => "wrk", "Tippera" => "tpe", "Akei" => "tsr", "I'saka" => "ksi", "Labo Phowa" => "ypb", "Palenquero" => "pln", "Nepali" => "npi", "Khe" => "kqg", "Shoshoni" => "shh", "Tetserret" => "tez", "Twi" => "twi", "Japrería" => "jru", "Kaniet" => "ktk", "Nayini" => "nyq", "Degenan" => "dge", "Malawi Sena" => "swk", "Wangkajunga" => "mpj", "Xiang Chinese" => "hsn", "Borôro" => "bor", "Äiwoo" => "nfl", "Southern East Cree" => "crj", "Yaosakor Asmat" => "asy", "Usaghade" => "usk", "Muratayak" => "asx", "Ashtiani" => "atn", "Lave" => "brb", "Bonggo" => "bpg", "Bauzi" => "bvz", "Malankuravan" => "mjo", "Chuukese" => "chk", "Mpinda" => "pnd", "Haiphong Sign Language" => "haf", "Maiani" => "tnh", "Tarifit" => "rif", "Jur Modo" => "bex", "Sherbro" => "bun", "Machame" => "jmc", "Paranawát" => "paf", "Shua" => "shg", "North Fali" => "fll", "Beli" => "blm", "Gadang" => "gdk", "Dirasha" => "gdl", "Baluan-Pam" => "blq", "Kwaio" => "kwd", "Tita" => "tdq", "Aymara" => "aym", "Ikpeshi" => "ikp", "Judeo-Berber" => "jbe", "Panamanian Sign Language" => "lsp", "Valley Maidu" => "vmv", "Berakou" => "bxv", "Nyahkur" => "cbn", "Kemedzung" => "dmo", "Southeast Pashayi" => "psi", "Chakma" => "ccp", "Tukang Besi North" => "khc", "Ormuri" => "oru", "Keiga" => "kec", "Sena" => "seh", "Weri" => "wer", "Yimas" => "yee", "Zenaga" => "zen", "Jutish" => "jut", "Guatemalan Sign Language" => "gsm", "Unserdeutsch" => "uln", "Maritsauá" => "msp", "Wakde" => "wkd", "Waci Gbe" => "wci", "Garig-Ilgar" => "ilg", "Northern Pomo" => "pej", "Zoroastrian Dari" => "gbz", "Budza" => "bja", "Berbice Creole Dutch" => "brc", "Siriano" => "sri", "Bilua" => "blb", "Musak" => "mmq", "Cupeño" => "cup", "Ndamba" => "ndj", "Isebe" => "igo", "Gaikundi" => "gbf", "Erromintxela" => "emx", "Lower Tanana" => "taa", "Koluwawa" => "klx", "Mengen" => "mee", "Day" => "dai", "Pedi" => "nso", "Port Sandwich" => "psw", "Nyakyusa-Ngonde" => "nyy", "Mbuko" => "mqb", "Tokano" => "zuh", "Alemannic" => "gsw", "Kelabit" => "kzi", "Samo" => "smq", "Waneci" => "wne", "Yahuna" => "ynu", "Erre" => "err", "Kodaku" => "ksz", "Punthamara" => "xpt", "Araki" => "akr", "Wandala" => "mfi", "Giiwo" => "kks", "Purik" => "prx", "Purari" => "iar", "Pyemmairrener" => "xpb", "Tooro" => "ttj", "Dibole" => "bvx", "Alekano" => "gah", "Lahta Karen" => "kvt", "Dimili" => "zza", "Cacaloxtepec Mixtec" => "miu", "Kadai" => "kzd", "Wambaya" => "wmb", "Maram Naga" => "nma", "Sinasina" => "sst", "Wichita" => "wic", "Tambora" => "xxt", "Totela" => "ttl", "Terik" => "tec", "Mayi-Kulan" => "xyk", "Yokuts" => "yok", "Kon Keu" => "kkn", "Pacoh" => "pac", "Wancho Naga" => "nnp", "Yakha" => "ybh", "Ga'anda" => "gqa", "Calderón Highland Quichua" => "qud", "Luxembourgish" => "ltz", "No linguistic content" => "zxx", "Avau" => "avb", "Kickapoo" => "kic", "Huizhou Chinese" => "czh", "Belarusian" => "bel", "Vamale" => "mkt", "Imonda" => "imn", "Gula" => "kcm", "Tangko" => "tkx", "Geez" => "gez", "Waruna" => "wrv", "Honi" => "how", "Tidaá Mixtec" => "mtx", "Galela" => "gbi", "Kurnai" => "unn", "Shekhawati" => "swv", "Lega-Shabunda" => "lea", "Eastern Ojibwa" => "ojg", "Ndunga" => "ndt", "Ehueun" => "ehu", "Cotoname" => "xcn", "Kulina" => "cul", "Sanskrit" => "san", "Mota" => "mtt", "Western Kanjobal" => "knj", "Momare" => "msz", "Ayangan Ifugao" => "ifb", "Santa María Zacatepec Mixtec" => "mza", "Southern Pashto" => "pbt", "Lemoro" => "ldj", "Piro" => "pie", "Waropen" => "wrp", "Odiai" => "bhf", "Ethiopian Sign Language" => "eth", "Seki" => "syi", "Vehes" => "val", "Wudu" => "wud", "Gilima" => "gix", "Long Phuri Naga" => "lpn", "Polish" => "pol", "Middle French" => "frm", "Kwaza" => "xwa", "Waube" => "kop", "Burumakok" => "aip", "Lishana Deni" => "lsd", "Miship" => "mjs", "Nogai" => "nog", "Kapin" => "tbx", "Papel" => "pbo", "Bai" => "bdj", "Yetfa" => "yet", "Chocangacakha" => "cgk", "Tepinapa Chinantec" => "cte", "Kubo" => "jko", "Kyrgyz" => "kir", "Cinda-Regi-Tiyal" => "cdr", "Kwalhioqua-Tlatskanai" => "qwt", "Swabian" => "swg", "Tamil" => "tam", "Southwestern Bontok" => "vbk", "Nyâlayu" => "yly", "Macanese" => "mzs", "Sinaugoro" => "snc", "Southern Betsimisaraka Malagasy" => "bzc", "Mauritian Sign Language" => "lsy", "Yumplatok" => "tcs", "Ana Tinga Dogon" => "dti", "Awera" => "awr", "Rapoisi" => "kyx", "Thopho" => "ytp", "Idu-Mishmi" => "clk", "North Muyu" => "kti", "Mander" => "mqr", "Mele-Fila" => "mxe", "Bodo Gadaba" => "gbj", "Umotína" => "umo", "Marenje" => "vmr", "Alaba-K’abeena" => "alw", "Kombio" => "xbi", "Western Abnaki" => "abe", "Ilianen Manobo" => "mbi", "Dobel" => "kvo", "Malapandaram" => "mjp", "Gyalsumdo" => "gyo", "Indus Kohistani" => "mvy", "Southern Ohlone" => "css", "Old Aramaic" => "oar", "Shendu" => "shl", "Northwestern Fars" => "faz", "Langobardic" => "lng", "Tabasco Nahuatl" => "nhc", "Zhire" => "zhi", "Gone Dau" => "goo", "Nila" => "nil", "Bazigar" => "bfr", "Kenga" => "kyq", "Olushisa" => "lks", "Uisai" => "uis", "Sawila" => "swt", "Church Slavonic" => "chu", "Tanaina" => "tfn", "Adithinngithigh" => "dth", "Vlax Romani" => "rmy", "Ngando" => "nxd", "Kwara'ae" => "kwf", "Bu" => "zbu", "Kawaiisu" => "xaw", "Nonuya" => "noj", "Kwasio" => "nmg", "Lonzo" => "lnz", "Nomaande" => "lem", "Upper Tanana" => "tau", "Rathawi" => "rtw", "Bwisi" => "bwz", "Chayahuita" => "cbt", "Hoava" => "hoa", "Bubi" => "buw", "Heiltsuk" => "hei", "Nyali" => "nlj", "Kwegu" => "xwg", "Yagaria" => "ygr", "Southern Lolopo" => "ysp", "Yace" => "ekr", "Caribbean Hindustani" => "hns", "Dza" => "jen", "Libyan Sign Language" => "lbs", "Huaxcaleca Nahuatl" => "nhq", "Swampy Cree" => "csw", "Minaveha" => "mvn", "Iloko" => "ilo", "Gaelic" => "gla", "Akkala Sami" => "sia", "Domaaki" => "dmk", "Holma" => "hod", "Piti" => "pcn", "Kalarko" => "kba", "Bwela" => "bwl", "Kerinci" => "kvr", "Djadjawurrung" => "dja", "Chulym" => "clw", "Songlai Chin" => "csj", "Tibetan Sign Language" => "lsn", "Gera" => "gew", "Bangime" => "dba", "Baelelea" => "bvc", "Catalan" => "cat", "Tefaro" => "tfo", "Sidamo" => "sid", "Kenzi" => "xnz", "Diuxi-Tilantongo Mixtec" => "xtd", "Kpelle" => "kpe", "Pere" => "pfe", "Dalmatian" => "dlm", "Small Flowery Miao" => "sfm", "Edwas" => "bnv", "Iu Mien" => "ium", "Koma" => "kmy", "Sãotomense" => "cri", "Lolak" => "llq", "Pardhi" => "pcl", "Borei" => "gai", "Cajamarca Quechua" => "qvc", "Orok" => "oaa", "Bentong" => "bnu", "Nukuini" => "nuc", "Zotung Chin" => "czt", "Comecrudo" => "xcm", "Northern Sotho" => "nso", "Hung" => "hnu", "Kacipo-Bale Suri" => "koe", "Scythian" => "xsc", "Old Burmese" => "obr", "Pataxó Hã-Ha-Hãe" => "pth", "South Nuaulu" => "nxl", "Powari" => "pwr", "Soyaltepec Mixtec" => "vmq", "Vaagri Booli" => "vaa", "Mbe" => "mfo", "Chichicapan Zapotec" => "zpv", "Omagua" => "omg", "Puimei Naga" => "npu", "Aurá" => "aux", "Mawak" => "mjj", "Réunion Creole French" => "rcf", "Kanufi" => "kni", "Koongo" => "kng", "Tula" => "tul", "Chak" => "ckh", "Riang Lang" => "ril", "Busam" => "bxs", "Kharia" => "khr", "Phupha" => "yph", "Kamano" => "kbq", "Okodia" => "okd", "Dogrib" => "dgr", "Colonia Tovar German" => "gct", "Inlaod Itneg" => "iti", "Ossetian" => "oss", "Gadjerawang" => "gdh", "Median" => "xme", "Kalapalo" => "kui", "Brazilian Sign Language" => "bzs", "Principense" => "pre", "Yapunda" => "yev", "Ghera" => "ghr", "Southeast Ijo" => "ijs", "Beami" => "beo", "Bilur" => "bxf", "Inoke-Yate" => "ino", "Ipulo" => "ass", "Bote-Majhi" => "bmj", "Dakpakha" => "dka", "Nde-Gbite" => "ned", "Laba" => "lau", "Lotha Naga" => "njh", "Tela-Masbuar" => "tvm", "Wanap" => "wnp", "Huamalíes-Dos de Mayo Huánuco Quechua" => "qvh", "Eastern Krahn" => "kqo", "Vandalic" => "xvn", "Sa'a" => "apb", "Awtuw" => "kmn", "Parawen" => "prw", "Mogofin" => "mfg", "Pangwa" => "pbr", "Ukpe-Bayobiri" => "ukp", "Tunisian Arabic" => "aeb", "Mese" => "mci", "Chamalal" => "cji", "Dadibi" => "mps", "Bunoge Dogon" => "dgb", "Moere" => "mvq", "Bekwel" => "bkw", "Idakho-Isukha-Tiriki" => "ida", "Aché" => "guq", "Kanashi" => "xns", "Chukwa" => "cuw", "Sara Kaba Náà" => "kwv", "Bisorio" => "bir", "Boo" => "bqc", "Rengao" => "ren", "Rakhine" => "rki", "Eastern Subanen" => "sfe", "Taworta" => "tbp", "Bamun" => "bax", "Gulay" => "gvl", "Sowanda" => "sow", "Abom" => "aob", "Lower Chehalis" => "cea", "Sochiapan Chinantec" => "cso", "Duruma" => "dug", "Afra" => "ulf", "Telefol" => "tlf", "Western Karaboro" => "kza", "Lingala" => "lin")
part1toid(c) = part1_id[c]
id2mid(c) = iid_mid[c]
function normcode(c, check=false)
    c = get(name_id, c, c)
    if occursin("-", c)
        c = split(c, "-")[1]
    end
    c = get(part1_id, c, c)
    c = get(iid_mid, c, c)
    if check
        c in id_all || println("missing $(repr(c))")
    end
    c
end